<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfContainer ArrayType
 * @subpackage Arrays
 */
class ArrayOfContainer extends AbstractStructArrayBase
{
    /**
     * The Container
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Container[]
     */
    public $Container;
    /**
     * Constructor method for ArrayOfContainer
     * @uses ArrayOfContainer::setContainer()
     * @param \StructType\Container[] $container
     */
    public function __construct(array $container = array())
    {
        $this
            ->setContainer($container);
    }
    /**
     * Get Container value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Container[]|null
     */
    public function getContainer()
    {
        return isset($this->Container) ? $this->Container : null;
    }
    /**
     * This method is responsible for validating the values passed to the setContainer method
     * This method is willingly generated in order to preserve the one-line inline validation within the setContainer method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateContainerForArrayConstraintsFromSetContainer(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfContainerContainerItem) {
            // validation for constraint: itemType
            if (!$arrayOfContainerContainerItem instanceof \StructType\Container) {
                $invalidValues[] = is_object($arrayOfContainerContainerItem) ? get_class($arrayOfContainerContainerItem) : sprintf('%s(%s)', gettype($arrayOfContainerContainerItem), var_export($arrayOfContainerContainerItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Container property can only contain items of type \StructType\Container, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Container value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Container[] $container
     * @return \ArrayType\ArrayOfContainer
     */
    public function setContainer(array $container = array())
    {
        // validation for constraint: array
        if ('' !== ($containerArrayErrorMessage = self::validateContainerForArrayConstraintsFromSetContainer($container))) {
            throw new \InvalidArgumentException($containerArrayErrorMessage, __LINE__);
        }
        if (is_null($container) || (is_array($container) && empty($container))) {
            unset($this->Container);
        } else {
            $this->Container = $container;
        }
        return $this;
    }
    /**
     * Add item to Container value
     * @throws \InvalidArgumentException
     * @param \StructType\Container $item
     * @return \ArrayType\ArrayOfContainer
     */
    public function addToContainer(\StructType\Container $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Container) {
            throw new \InvalidArgumentException(sprintf('The Container property can only contain items of type \StructType\Container, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Container[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\Container|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\Container|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\Container|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\Container|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\Container|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Container
     */
    public function getAttributeName()
    {
        return 'Container';
    }
}
