<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfContent ArrayType
 * @subpackage Arrays
 */
class ArrayOfContent extends AbstractStructArrayBase
{
    /**
     * The Content
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Content[]
     */
    public $Content;
    /**
     * Constructor method for ArrayOfContent
     * @uses ArrayOfContent::setContent()
     * @param \StructType\Content[] $content
     */
    public function __construct(array $content = array())
    {
        $this
            ->setContent($content);
    }
    /**
     * Get Content value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Content[]|null
     */
    public function getContent()
    {
        return isset($this->Content) ? $this->Content : null;
    }
    /**
     * This method is responsible for validating the values passed to the setContent method
     * This method is willingly generated in order to preserve the one-line inline validation within the setContent method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateContentForArrayConstraintsFromSetContent(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfContentContentItem) {
            // validation for constraint: itemType
            if (!$arrayOfContentContentItem instanceof \StructType\Content) {
                $invalidValues[] = is_object($arrayOfContentContentItem) ? get_class($arrayOfContentContentItem) : sprintf('%s(%s)', gettype($arrayOfContentContentItem), var_export($arrayOfContentContentItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Content property can only contain items of type \StructType\Content, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Content value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Content[] $content
     * @return \ArrayType\ArrayOfContent
     */
    public function setContent(array $content = array())
    {
        // validation for constraint: array
        if ('' !== ($contentArrayErrorMessage = self::validateContentForArrayConstraintsFromSetContent($content))) {
            throw new \InvalidArgumentException($contentArrayErrorMessage, __LINE__);
        }
        if (is_null($content) || (is_array($content) && empty($content))) {
            unset($this->Content);
        } else {
            $this->Content = $content;
        }
        return $this;
    }
    /**
     * Add item to Content value
     * @throws \InvalidArgumentException
     * @param \StructType\Content $item
     * @return \ArrayType\ArrayOfContent
     */
    public function addToContent(\StructType\Content $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Content) {
            throw new \InvalidArgumentException(sprintf('The Content property can only contain items of type \StructType\Content, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Content[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\Content|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\Content|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\Content|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\Content|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\Content|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Content
     */
    public function getAttributeName()
    {
        return 'Content';
    }
}
