<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'Clear' => '\\StructType\\Clear',
            'ClearResponse' => '\\StructType\\ClearResponse',
            'GetProcessStatus' => '\\StructType\\GetProcessStatus',
            'GetProcessStatusResponse' => '\\StructType\\GetProcessStatusResponse',
            'ProcessResult' => '\\StructType\\ProcessResult',
            'GetScenario' => '\\StructType\\GetScenario',
            'GetScenarioResponse' => '\\StructType\\GetScenarioResponse',
            'ArrayOfCommand' => '\\ArrayType\\ArrayOfCommand',
            'Command' => '\\StructType\\Command',
            'ElementDescriptor' => '\\StructType\\ElementDescriptor',
            'ArrayOfString' => '\\ArrayType\\ArrayOfString',
            'Container' => '\\StructType\\Container',
            'ArrayOfField' => '\\ArrayType\\ArrayOfField',
            'Field' => '\\StructType\\Field',
            'Attachment' => '\\StructType\\Attachment',
            'Value' => '\\StructType\\Value',
            'ArrayOfContainer' => '\\ArrayType\\ArrayOfContainer',
            'EveryValue' => '\\StructType\\EveryValue',
            'Answer' => '\\StructType\\Answer',
            'RowNumber' => '\\StructType\\RowNumber',
            'DeleteRow' => '\\StructType\\DeleteRow',
            'NewRow' => '\\StructType\\NewRow',
            'Parameter' => '\\StructType\\Parameter',
            'Key' => '\\StructType\\Key',
            'Action' => '\\StructType\\Action',
            'GetSchema' => '\\StructType\\GetSchema',
            'GetSchemaResponse' => '\\StructType\\GetSchemaResponse',
            'Content' => '\\StructType\\Content',
            'SetSchema' => '\\StructType\\SetSchema',
            'SetSchemaResponse' => '\\StructType\\SetSchemaResponse',
            'Export' => '\\StructType\\Export',
            'ArrayOfFilter' => '\\ArrayType\\ArrayOfFilter',
            'Filter' => '\\StructType\\Filter',
            'ArrayOfArrayOfString' => '\\ArrayType\\ArrayOfArrayOfString',
            'ExportResponse' => '\\StructType\\ExportResponse',
            'Import' => '\\StructType\\Import',
            'ImportResult' => '\\StructType\\ImportResult',
            'ArrayOfValue' => '\\ArrayType\\ArrayOfValue',
            'ArrayOfImportResult' => '\\ArrayType\\ArrayOfImportResult',
            'ImportResponse' => '\\StructType\\ImportResponse',
            'Submit' => '\\StructType\\Submit',
            'ArrayOfContent' => '\\ArrayType\\ArrayOfContent',
            'SubmitResponse' => '\\StructType\\SubmitResponse',
            'Login' => '\\StructType\\Login',
            'LoginResult' => '\\StructType\\LoginResult',
            'LoginResponse' => '\\StructType\\LoginResponse',
            'Logout' => '\\StructType\\Logout',
            'LogoutResponse' => '\\StructType\\LogoutResponse',
            'SetBusinessDate' => '\\StructType\\SetBusinessDate',
            'SetBusinessDateResponse' => '\\StructType\\SetBusinessDateResponse',
            'SetLocaleName' => '\\StructType\\SetLocaleName',
            'SetLocaleNameResponse' => '\\StructType\\SetLocaleNameResponse',
            'SetSchemaMode' => '\\StructType\\SetSchemaMode',
            'SetSchemaModeResponse' => '\\StructType\\SetSchemaModeResponse',
            'PrimaryKey' => '\\StructType\\PrimaryKey',
            'Actions' => '\\StructType\\Actions',
            'OrderSummaryServiceCommands' => '\\StructType\\OrderSummaryServiceCommands',
            'OrderSummary' => '\\StructType\\OrderSummary',
            'OrderSummaryRateSelectionServiceCommands' => '\\StructType\\OrderSummaryRateSelectionServiceCommands',
            'OrderSummaryRateSelection' => '\\StructType\\OrderSummaryRateSelection',
            'OrderSummaryRateSelectionCurrencyUnitEquivalentsServiceCommands' => '\\StructType\\OrderSummaryRateSelectionCurrencyUnitEquivalentsServiceCommands',
            'OrderSummaryRateSelectionCurrencyUnitEquivalents' => '\\StructType\\OrderSummaryRateSelectionCurrencyUnitEquivalents',
            'CommissionsDefaultSalespersonServiceCommands' => '\\StructType\\CommissionsDefaultSalespersonServiceCommands',
            'CommissionsDefaultSalesperson' => '\\StructType\\CommissionsDefaultSalesperson',
            'FinancialFinancialInformationServiceCommands' => '\\StructType\\FinancialFinancialInformationServiceCommands',
            'FinancialFinancialInformation' => '\\StructType\\FinancialFinancialInformation',
            'FinancialPaymentInformationServiceCommands' => '\\StructType\\FinancialPaymentInformationServiceCommands',
            'FinancialPaymentInformation' => '\\StructType\\FinancialPaymentInformation',
            'FinancialPaymentInformationOwnershipServiceCommands' => '\\StructType\\FinancialPaymentInformationOwnershipServiceCommands',
            'FinancialPaymentInformationOwnership' => '\\StructType\\FinancialPaymentInformationOwnership',
            'FinancialPaymentInformationOtherInformationServiceCommands' => '\\StructType\\FinancialPaymentInformationOtherInformationServiceCommands',
            'FinancialPaymentInformationOtherInformation' => '\\StructType\\FinancialPaymentInformationOtherInformation',
            'ShippingDeliverySettingsServiceCommands' => '\\StructType\\ShippingDeliverySettingsServiceCommands',
            'ShippingDeliverySettings' => '\\StructType\\ShippingDeliverySettings',
            'ShippingIntercompanyPurchaseServiceCommands' => '\\StructType\\ShippingIntercompanyPurchaseServiceCommands',
            'ShippingIntercompanyPurchase' => '\\StructType\\ShippingIntercompanyPurchase',
            'ShippingOrderShippingSettingsServiceCommands' => '\\StructType\\ShippingOrderShippingSettingsServiceCommands',
            'ShippingOrderShippingSettings' => '\\StructType\\ShippingOrderShippingSettings',
            'DiscountsDisableAutomaticDiscountUpdateServiceCommands' => '\\StructType\\DiscountsDisableAutomaticDiscountUpdateServiceCommands',
            'DiscountsDisableAutomaticDiscountUpdate' => '\\StructType\\DiscountsDisableAutomaticDiscountUpdate',
            'PaymentsPaymentTotalServiceCommands' => '\\StructType\\PaymentsPaymentTotalServiceCommands',
            'PaymentsPaymentTotal' => '\\StructType\\PaymentsPaymentTotal',
            'RisksRiskStatusServiceCommands' => '\\StructType\\RisksRiskStatusServiceCommands',
            'RisksRiskStatus' => '\\StructType\\RisksRiskStatus',
            'TotalsFreightInfoServiceCommands' => '\\StructType\\TotalsFreightInfoServiceCommands',
            'TotalsFreightInfo' => '\\StructType\\TotalsFreightInfo',
            'TotalsOrderTotalsServiceCommands' => '\\StructType\\TotalsOrderTotalsServiceCommands',
            'TotalsOrderTotals' => '\\StructType\\TotalsOrderTotals',
            'TotalsCalculatedAmountsAndQuantitiesServiceCommands' => '\\StructType\\TotalsCalculatedAmountsAndQuantitiesServiceCommands',
            'TotalsCalculatedAmountsAndQuantities' => '\\StructType\\TotalsCalculatedAmountsAndQuantities',
            'ShopForRatesServicesSettingsServiceCommands' => '\\StructType\\ShopForRatesServicesSettingsServiceCommands',
            'ShopForRatesServicesSettings' => '\\StructType\\ShopForRatesServicesSettings',
            'ShopForRatesServicesSettingsIsManualPackageServiceCommands' => '\\StructType\\ShopForRatesServicesSettingsIsManualPackageServiceCommands',
            'ShopForRatesServicesSettingsIsManualPackage' => '\\StructType\\ShopForRatesServicesSettingsIsManualPackage',
            'ROTRUTDetailsRUTAndROTSettingsServiceCommands' => '\\StructType\\ROTRUTDetailsRUTAndROTSettingsServiceCommands',
            'ROTRUTDetailsRUTAndROTSettings' => '\\StructType\\ROTRUTDetailsRUTAndROTSettings',
            'ROTRUTDetailsRUTAndROTTotalsServiceCommands' => '\\StructType\\ROTRUTDetailsRUTAndROTTotalsServiceCommands',
            'ROTRUTDetailsRUTAndROTTotals' => '\\StructType\\ROTRUTDetailsRUTAndROTTotals',
            'DetailsServiceCommands' => '\\StructType\\DetailsServiceCommands',
            'Details' => '\\StructType\\Details',
            'PurchasingDetailsPurchasingSettingsServiceCommands' => '\\StructType\\PurchasingDetailsPurchasingSettingsServiceCommands',
            'PurchasingDetailsPurchasingSettings' => '\\StructType\\PurchasingDetailsPurchasingSettings',
            'ProductionOrdersServiceCommands' => '\\StructType\\ProductionOrdersServiceCommands',
            'ProductionOrders' => '\\StructType\\ProductionOrders',
            'TaxesServiceCommands' => '\\StructType\\TaxesServiceCommands',
            'Taxes' => '\\StructType\\Taxes',
            'ShipmentsServiceCommands' => '\\StructType\\ShipmentsServiceCommands',
            'Shipments' => '\\StructType\\Shipments',
            'AddressesBillToAddressServiceCommands' => '\\StructType\\AddressesBillToAddressServiceCommands',
            'AddressesBillToAddress' => '\\StructType\\AddressesBillToAddress',
            'AddressesShipToAddressServiceCommands' => '\\StructType\\AddressesShipToAddressServiceCommands',
            'AddressesShipToAddress' => '\\StructType\\AddressesShipToAddress',
            'AddressesBillToContactServiceCommands' => '\\StructType\\AddressesBillToContactServiceCommands',
            'AddressesBillToContact' => '\\StructType\\AddressesBillToContact',
            'AddressesShipToContactServiceCommands' => '\\StructType\\AddressesShipToContactServiceCommands',
            'AddressesShipToContact' => '\\StructType\\AddressesShipToContact',
            'ApprovalsServiceCommands' => '\\StructType\\ApprovalsServiceCommands',
            'Approvals' => '\\StructType\\Approvals',
            'DiscountsServiceCommands' => '\\StructType\\DiscountsServiceCommands',
            'Discounts' => '\\StructType\\Discounts',
            'SpecifyShipmentParametersServiceCommands' => '\\StructType\\SpecifyShipmentParametersServiceCommands',
            'SpecifyShipmentParameters' => '\\StructType\\SpecifyShipmentParameters',
            'AddInvoiceDetailsDocTypeServiceCommands' => '\\StructType\\AddInvoiceDetailsDocTypeServiceCommands',
            'AddInvoiceDetailsDocType' => '\\StructType\\AddInvoiceDetailsDocType',
            'CopyToServiceCommands' => '\\StructType\\CopyToServiceCommands',
            'CopyTo' => '\\StructType\\CopyTo',
            'RecalculatePricesServiceCommands' => '\\StructType\\RecalculatePricesServiceCommands',
            'RecalculatePrices' => '\\StructType\\RecalculatePrices',
            'AddInvoiceDetailsServiceCommands' => '\\StructType\\AddInvoiceDetailsServiceCommands',
            'AddInvoiceDetails' => '\\StructType\\AddInvoiceDetails',
            'CommissionsServiceCommands' => '\\StructType\\CommissionsServiceCommands',
            'Commissions' => '\\StructType\\Commissions',
            'ShopForRatesPackagesServiceCommands' => '\\StructType\\ShopForRatesPackagesServiceCommands',
            'ShopForRatesPackages' => '\\StructType\\ShopForRatesPackages',
            'PaymentsServiceCommands' => '\\StructType\\PaymentsServiceCommands',
            'Payments' => '\\StructType\\Payments',
            'ROTRUTDetailsRUTAndROTDistributionRUTAndROTDistributionServiceCommands' => '\\StructType\\ROTRUTDetailsRUTAndROTDistributionRUTAndROTDistributionServiceCommands',
            'ROTRUTDetailsRUTAndROTDistributionRUTAndROTDistribution' => '\\StructType\\ROTRUTDetailsRUTAndROTDistributionRUTAndROTDistribution',
            'InventoryLookupInventoryServiceCommands' => '\\StructType\\InventoryLookupInventoryServiceCommands',
            'InventoryLookupInventory' => '\\StructType\\InventoryLookupInventory',
            'InventoryLookupSelectedModeServiceCommands' => '\\StructType\\InventoryLookupSelectedModeServiceCommands',
            'InventoryLookupSelectedMode' => '\\StructType\\InventoryLookupSelectedMode',
            'InventoryLookupShippingParametersToApplyServiceCommands' => '\\StructType\\InventoryLookupShippingParametersToApplyServiceCommands',
            'InventoryLookupShippingParametersToApply' => '\\StructType\\InventoryLookupShippingParametersToApply',
            'InventoryLookupServiceCommands' => '\\StructType\\InventoryLookupServiceCommands',
            'InventoryLookup' => '\\StructType\\InventoryLookup',
            'ShopForRatesCarrierRatesServiceCommands' => '\\StructType\\ShopForRatesCarrierRatesServiceCommands',
            'ShopForRatesCarrierRates' => '\\StructType\\ShopForRatesCarrierRates',
            'ChildOrdersServiceCommands' => '\\StructType\\ChildOrdersServiceCommands',
            'ChildOrders' => '\\StructType\\ChildOrders',
            'AddBlanketSalesOrderLineServiceCommands' => '\\StructType\\AddBlanketSalesOrderLineServiceCommands',
            'AddBlanketSalesOrderLine' => '\\StructType\\AddBlanketSalesOrderLine',
            'OverrideTaxZoneServiceCommands' => '\\StructType\\OverrideTaxZoneServiceCommands',
            'OverrideTaxZone' => '\\StructType\\OverrideTaxZone',
            'PurchasingDetailsServiceCommands' => '\\StructType\\PurchasingDetailsServiceCommands',
            'PurchasingDetails' => '\\StructType\\PurchasingDetails',
            'AddressLookupServiceCommands' => '\\StructType\\AddressLookupServiceCommands',
            'AddressLookup' => '\\StructType\\AddressLookup',
            'ProcessOrderServiceCommands' => '\\StructType\\ProcessOrderServiceCommands',
            'ProcessOrder' => '\\StructType\\ProcessOrder',
            'ProcessOrderPrintingSettingsServiceCommands' => '\\StructType\\ProcessOrderPrintingSettingsServiceCommands',
            'ProcessOrderPrintingSettings' => '\\StructType\\ProcessOrderPrintingSettings',
            'ProcessOrderAvailabilityServiceCommands' => '\\StructType\\ProcessOrderAvailabilityServiceCommands',
            'ProcessOrderAvailability' => '\\StructType\\ProcessOrderAvailability',
            'ProcessOrderShippingServiceCommands' => '\\StructType\\ProcessOrderShippingServiceCommands',
            'ProcessOrderShipping' => '\\StructType\\ProcessOrderShipping',
            'ProcessOrderInvoicingServiceCommands' => '\\StructType\\ProcessOrderInvoicingServiceCommands',
            'ProcessOrderInvoicing' => '\\StructType\\ProcessOrderInvoicing',
            'LineDetailsServiceCommands' => '\\StructType\\LineDetailsServiceCommands',
            'LineDetails' => '\\StructType\\LineDetails',
            'EnterReasonServiceCommands' => '\\StructType\\EnterReasonServiceCommands',
            'EnterReason' => '\\StructType\\EnterReason',
            'CreatePaymentServiceCommands' => '\\StructType\\CreatePaymentServiceCommands',
            'CreatePayment' => '\\StructType\\CreatePayment',
            'ImportCCPaymentServiceCommands' => '\\StructType\\ImportCCPaymentServiceCommands',
            'ImportCCPayment' => '\\StructType\\ImportCCPayment',
            'AddRelatedItemsServiceCommands' => '\\StructType\\AddRelatedItemsServiceCommands',
            'AddRelatedItems' => '\\StructType\\AddRelatedItems',
            'AddRelatedItemsAllRelatedItemsServiceCommands' => '\\StructType\\AddRelatedItemsAllRelatedItemsServiceCommands',
            'AddRelatedItemsAllRelatedItems' => '\\StructType\\AddRelatedItemsAllRelatedItems',
            'AddRelatedItemsSubstituteItemsServiceCommands' => '\\StructType\\AddRelatedItemsSubstituteItemsServiceCommands',
            'AddRelatedItemsSubstituteItems' => '\\StructType\\AddRelatedItemsSubstituteItems',
            'AddRelatedItemsUpSellItemsServiceCommands' => '\\StructType\\AddRelatedItemsUpSellItemsServiceCommands',
            'AddRelatedItemsUpSellItems' => '\\StructType\\AddRelatedItemsUpSellItems',
            'AddRelatedItemsCrossSellItemsServiceCommands' => '\\StructType\\AddRelatedItemsCrossSellItemsServiceCommands',
            'AddRelatedItemsCrossSellItems' => '\\StructType\\AddRelatedItemsCrossSellItems',
            'AddRelatedItemsOtherRelatedItemsServiceCommands' => '\\StructType\\AddRelatedItemsOtherRelatedItemsServiceCommands',
            'AddRelatedItemsOtherRelatedItems' => '\\StructType\\AddRelatedItemsOtherRelatedItems',
            'PurchasingDetailsSelectedServiceCommands' => '\\StructType\\PurchasingDetailsSelectedServiceCommands',
            'PurchasingDetailsSelected' => '\\StructType\\PurchasingDetailsSelected',
            'AddMatrixItemTableViewServiceCommands' => '\\StructType\\AddMatrixItemTableViewServiceCommands',
            'AddMatrixItemTableView' => '\\StructType\\AddMatrixItemTableView',
            'AddMatrixItemMatrixViewMatrixAvailabilityServiceCommands' => '\\StructType\\AddMatrixItemMatrixViewMatrixAvailabilityServiceCommands',
            'AddMatrixItemMatrixViewMatrixAvailability' => '\\StructType\\AddMatrixItemMatrixViewMatrixAvailability',
            'AddMatrixItemTableViewTemplateItemIDServiceCommands' => '\\StructType\\AddMatrixItemTableViewTemplateItemIDServiceCommands',
            'AddMatrixItemTableViewTemplateItemID' => '\\StructType\\AddMatrixItemTableViewTemplateItemID',
            'AddMatrixItemMatrixViewTemplateItemIDServiceCommands' => '\\StructType\\AddMatrixItemMatrixViewTemplateItemIDServiceCommands',
            'AddMatrixItemMatrixViewTemplateItemID' => '\\StructType\\AddMatrixItemMatrixViewTemplateItemID',
            'RisksServiceCommands' => '\\StructType\\RisksServiceCommands',
            'Risks' => '\\StructType\\Risks',
            'EstimatesServiceCommands' => '\\StructType\\EstimatesServiceCommands',
            'Estimates' => '\\StructType\\Estimates',
            'ProductionDetailsServiceCommands' => '\\StructType\\ProductionDetailsServiceCommands',
            'ProductionDetails' => '\\StructType\\ProductionDetails',
            'ProductionDetailsNoneServiceCommands' => '\\StructType\\ProductionDetailsNoneServiceCommands',
            'ProductionDetailsNone' => '\\StructType\\ProductionDetailsNone',
            'QuickEstimateServiceCommands' => '\\StructType\\QuickEstimateServiceCommands',
            'QuickEstimate' => '\\StructType\\QuickEstimate',
            'AddEstimateServiceCommands' => '\\StructType\\AddEstimateServiceCommands',
            'AddEstimate' => '\\StructType\\AddEstimate',
            'CreateServiceOrderServiceCommands' => '\\StructType\\CreateServiceOrderServiceCommands',
            'CreateServiceOrder' => '\\StructType\\CreateServiceOrder',
            'LineDetailsUnassignedQtyServiceCommands' => '\\StructType\\LineDetailsUnassignedQtyServiceCommands',
            'LineDetailsUnassignedQty' => '\\StructType\\LineDetailsUnassignedQty',
        );
    }
}
