<?php

namespace EnumType;

use \WsdlToPhp\PackageBase\AbstractStructEnumBase;

/**
 * This class stands for ElementTypes EnumType
 * @subpackage Enumerations
 */
class ElementTypes extends AbstractStructEnumBase
{
    /**
     * Constant for value 'String'
     * @return string 'String'
     */
    const VALUE_STRING = 'String';
    /**
     * Constant for value 'AsciiString'
     * @return string 'AsciiString'
     */
    const VALUE_ASCII_STRING = 'AsciiString';
    /**
     * Constant for value 'StringSelector'
     * @return string 'StringSelector'
     */
    const VALUE_STRING_SELECTOR = 'StringSelector';
    /**
     * Constant for value 'ExplicitSelector'
     * @return string 'ExplicitSelector'
     */
    const VALUE_EXPLICIT_SELECTOR = 'ExplicitSelector';
    /**
     * Constant for value 'Number'
     * @return string 'Number'
     */
    const VALUE_NUMBER = 'Number';
    /**
     * Constant for value 'Option'
     * @return string 'Option'
     */
    const VALUE_OPTION = 'Option';
    /**
     * Constant for value 'WideOption'
     * @return string 'WideOption'
     */
    const VALUE_WIDE_OPTION = 'WideOption';
    /**
     * Constant for value 'Calendar'
     * @return string 'Calendar'
     */
    const VALUE_CALENDAR = 'Calendar';
    /**
     * Constant for value 'Action'
     * @return string 'Action'
     */
    const VALUE_ACTION = 'Action';
    /**
     * Constant for value 'Sign'
     * @return string 'Sign'
     */
    const VALUE_SIGN = 'Sign';
    /**
     * Constant for value 'ReportPreview'
     * @return string 'ReportPreview'
     */
    const VALUE_REPORT_PREVIEW = 'ReportPreview';
    /**
     * Return allowed values
     * @uses self::VALUE_STRING
     * @uses self::VALUE_ASCII_STRING
     * @uses self::VALUE_STRING_SELECTOR
     * @uses self::VALUE_EXPLICIT_SELECTOR
     * @uses self::VALUE_NUMBER
     * @uses self::VALUE_OPTION
     * @uses self::VALUE_WIDE_OPTION
     * @uses self::VALUE_CALENDAR
     * @uses self::VALUE_ACTION
     * @uses self::VALUE_SIGN
     * @uses self::VALUE_REPORT_PREVIEW
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_STRING,
            self::VALUE_ASCII_STRING,
            self::VALUE_STRING_SELECTOR,
            self::VALUE_EXPLICIT_SELECTOR,
            self::VALUE_NUMBER,
            self::VALUE_OPTION,
            self::VALUE_WIDE_OPTION,
            self::VALUE_CALENDAR,
            self::VALUE_ACTION,
            self::VALUE_SIGN,
            self::VALUE_REPORT_PREVIEW,
        );
    }
}
