<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AddBlanketSalesOrderLine StructType
 * @subpackage Structs
 */
class AddBlanketSalesOrderLine extends AbstractStructBase
{
    /**
     * The DisplayName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DisplayName;
    /**
     * The Selected
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $Selected;
    /**
     * The OrderType
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $OrderType;
    /**
     * The OrderNbr
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $OrderNbr;
    /**
     * The SchedOrderDate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $SchedOrderDate;
    /**
     * The InventoryID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $InventoryID;
    /**
     * The Subitem
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $Subitem;
    /**
     * The Description
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $Description;
    /**
     * The Warehouse
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $Warehouse;
    /**
     * The CustomerOrderNbr
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $CustomerOrderNbr;
    /**
     * The UOM
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $UOM;
    /**
     * The BlanketOpenQty
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $BlanketOpenQty;
    /**
     * The ShipToLocation
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $ShipToLocation;
    /**
     * The TaxZone
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $TaxZone;
    /**
     * The ServiceCommands
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\AddBlanketSalesOrderLineServiceCommands
     */
    public $ServiceCommands;
    /**
     * Constructor method for AddBlanketSalesOrderLine
     * @uses AddBlanketSalesOrderLine::setDisplayName()
     * @uses AddBlanketSalesOrderLine::setSelected()
     * @uses AddBlanketSalesOrderLine::setOrderType()
     * @uses AddBlanketSalesOrderLine::setOrderNbr()
     * @uses AddBlanketSalesOrderLine::setSchedOrderDate()
     * @uses AddBlanketSalesOrderLine::setInventoryID()
     * @uses AddBlanketSalesOrderLine::setSubitem()
     * @uses AddBlanketSalesOrderLine::setDescription()
     * @uses AddBlanketSalesOrderLine::setWarehouse()
     * @uses AddBlanketSalesOrderLine::setCustomerOrderNbr()
     * @uses AddBlanketSalesOrderLine::setUOM()
     * @uses AddBlanketSalesOrderLine::setBlanketOpenQty()
     * @uses AddBlanketSalesOrderLine::setShipToLocation()
     * @uses AddBlanketSalesOrderLine::setTaxZone()
     * @uses AddBlanketSalesOrderLine::setServiceCommands()
     * @param string $displayName
     * @param \StructType\Field $selected
     * @param \StructType\Field $orderType
     * @param \StructType\Field $orderNbr
     * @param \StructType\Field $schedOrderDate
     * @param \StructType\Field $inventoryID
     * @param \StructType\Field $subitem
     * @param \StructType\Field $description
     * @param \StructType\Field $warehouse
     * @param \StructType\Field $customerOrderNbr
     * @param \StructType\Field $uOM
     * @param \StructType\Field $blanketOpenQty
     * @param \StructType\Field $shipToLocation
     * @param \StructType\Field $taxZone
     * @param \StructType\AddBlanketSalesOrderLineServiceCommands $serviceCommands
     */
    public function __construct($displayName = null, \StructType\Field $selected = null, \StructType\Field $orderType = null, \StructType\Field $orderNbr = null, \StructType\Field $schedOrderDate = null, \StructType\Field $inventoryID = null, \StructType\Field $subitem = null, \StructType\Field $description = null, \StructType\Field $warehouse = null, \StructType\Field $customerOrderNbr = null, \StructType\Field $uOM = null, \StructType\Field $blanketOpenQty = null, \StructType\Field $shipToLocation = null, \StructType\Field $taxZone = null, \StructType\AddBlanketSalesOrderLineServiceCommands $serviceCommands = null)
    {
        $this
            ->setDisplayName($displayName)
            ->setSelected($selected)
            ->setOrderType($orderType)
            ->setOrderNbr($orderNbr)
            ->setSchedOrderDate($schedOrderDate)
            ->setInventoryID($inventoryID)
            ->setSubitem($subitem)
            ->setDescription($description)
            ->setWarehouse($warehouse)
            ->setCustomerOrderNbr($customerOrderNbr)
            ->setUOM($uOM)
            ->setBlanketOpenQty($blanketOpenQty)
            ->setShipToLocation($shipToLocation)
            ->setTaxZone($taxZone)
            ->setServiceCommands($serviceCommands);
    }
    /**
     * Get DisplayName value
     * @return string|null
     */
    public function getDisplayName()
    {
        return $this->DisplayName;
    }
    /**
     * Set DisplayName value
     * @param string $displayName
     * @return \StructType\AddBlanketSalesOrderLine
     */
    public function setDisplayName($displayName = null)
    {
        // validation for constraint: string
        if (!is_null($displayName) && !is_string($displayName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($displayName, true), gettype($displayName)), __LINE__);
        }
        $this->DisplayName = $displayName;
        return $this;
    }
    /**
     * Get Selected value
     * @return \StructType\Field|null
     */
    public function getSelected()
    {
        return $this->Selected;
    }
    /**
     * Set Selected value
     * @param \StructType\Field $selected
     * @return \StructType\AddBlanketSalesOrderLine
     */
    public function setSelected(\StructType\Field $selected = null)
    {
        $this->Selected = $selected;
        return $this;
    }
    /**
     * Get OrderType value
     * @return \StructType\Field|null
     */
    public function getOrderType()
    {
        return $this->OrderType;
    }
    /**
     * Set OrderType value
     * @param \StructType\Field $orderType
     * @return \StructType\AddBlanketSalesOrderLine
     */
    public function setOrderType(\StructType\Field $orderType = null)
    {
        $this->OrderType = $orderType;
        return $this;
    }
    /**
     * Get OrderNbr value
     * @return \StructType\Field|null
     */
    public function getOrderNbr()
    {
        return $this->OrderNbr;
    }
    /**
     * Set OrderNbr value
     * @param \StructType\Field $orderNbr
     * @return \StructType\AddBlanketSalesOrderLine
     */
    public function setOrderNbr(\StructType\Field $orderNbr = null)
    {
        $this->OrderNbr = $orderNbr;
        return $this;
    }
    /**
     * Get SchedOrderDate value
     * @return \StructType\Field|null
     */
    public function getSchedOrderDate()
    {
        return $this->SchedOrderDate;
    }
    /**
     * Set SchedOrderDate value
     * @param \StructType\Field $schedOrderDate
     * @return \StructType\AddBlanketSalesOrderLine
     */
    public function setSchedOrderDate(\StructType\Field $schedOrderDate = null)
    {
        $this->SchedOrderDate = $schedOrderDate;
        return $this;
    }
    /**
     * Get InventoryID value
     * @return \StructType\Field|null
     */
    public function getInventoryID()
    {
        return $this->InventoryID;
    }
    /**
     * Set InventoryID value
     * @param \StructType\Field $inventoryID
     * @return \StructType\AddBlanketSalesOrderLine
     */
    public function setInventoryID(\StructType\Field $inventoryID = null)
    {
        $this->InventoryID = $inventoryID;
        return $this;
    }
    /**
     * Get Subitem value
     * @return \StructType\Field|null
     */
    public function getSubitem()
    {
        return $this->Subitem;
    }
    /**
     * Set Subitem value
     * @param \StructType\Field $subitem
     * @return \StructType\AddBlanketSalesOrderLine
     */
    public function setSubitem(\StructType\Field $subitem = null)
    {
        $this->Subitem = $subitem;
        return $this;
    }
    /**
     * Get Description value
     * @return \StructType\Field|null
     */
    public function getDescription()
    {
        return $this->Description;
    }
    /**
     * Set Description value
     * @param \StructType\Field $description
     * @return \StructType\AddBlanketSalesOrderLine
     */
    public function setDescription(\StructType\Field $description = null)
    {
        $this->Description = $description;
        return $this;
    }
    /**
     * Get Warehouse value
     * @return \StructType\Field|null
     */
    public function getWarehouse()
    {
        return $this->Warehouse;
    }
    /**
     * Set Warehouse value
     * @param \StructType\Field $warehouse
     * @return \StructType\AddBlanketSalesOrderLine
     */
    public function setWarehouse(\StructType\Field $warehouse = null)
    {
        $this->Warehouse = $warehouse;
        return $this;
    }
    /**
     * Get CustomerOrderNbr value
     * @return \StructType\Field|null
     */
    public function getCustomerOrderNbr()
    {
        return $this->CustomerOrderNbr;
    }
    /**
     * Set CustomerOrderNbr value
     * @param \StructType\Field $customerOrderNbr
     * @return \StructType\AddBlanketSalesOrderLine
     */
    public function setCustomerOrderNbr(\StructType\Field $customerOrderNbr = null)
    {
        $this->CustomerOrderNbr = $customerOrderNbr;
        return $this;
    }
    /**
     * Get UOM value
     * @return \StructType\Field|null
     */
    public function getUOM()
    {
        return $this->UOM;
    }
    /**
     * Set UOM value
     * @param \StructType\Field $uOM
     * @return \StructType\AddBlanketSalesOrderLine
     */
    public function setUOM(\StructType\Field $uOM = null)
    {
        $this->UOM = $uOM;
        return $this;
    }
    /**
     * Get BlanketOpenQty value
     * @return \StructType\Field|null
     */
    public function getBlanketOpenQty()
    {
        return $this->BlanketOpenQty;
    }
    /**
     * Set BlanketOpenQty value
     * @param \StructType\Field $blanketOpenQty
     * @return \StructType\AddBlanketSalesOrderLine
     */
    public function setBlanketOpenQty(\StructType\Field $blanketOpenQty = null)
    {
        $this->BlanketOpenQty = $blanketOpenQty;
        return $this;
    }
    /**
     * Get ShipToLocation value
     * @return \StructType\Field|null
     */
    public function getShipToLocation()
    {
        return $this->ShipToLocation;
    }
    /**
     * Set ShipToLocation value
     * @param \StructType\Field $shipToLocation
     * @return \StructType\AddBlanketSalesOrderLine
     */
    public function setShipToLocation(\StructType\Field $shipToLocation = null)
    {
        $this->ShipToLocation = $shipToLocation;
        return $this;
    }
    /**
     * Get TaxZone value
     * @return \StructType\Field|null
     */
    public function getTaxZone()
    {
        return $this->TaxZone;
    }
    /**
     * Set TaxZone value
     * @param \StructType\Field $taxZone
     * @return \StructType\AddBlanketSalesOrderLine
     */
    public function setTaxZone(\StructType\Field $taxZone = null)
    {
        $this->TaxZone = $taxZone;
        return $this;
    }
    /**
     * Get ServiceCommands value
     * @return \StructType\AddBlanketSalesOrderLineServiceCommands|null
     */
    public function getServiceCommands()
    {
        return $this->ServiceCommands;
    }
    /**
     * Set ServiceCommands value
     * @param \StructType\AddBlanketSalesOrderLineServiceCommands $serviceCommands
     * @return \StructType\AddBlanketSalesOrderLine
     */
    public function setServiceCommands(\StructType\AddBlanketSalesOrderLineServiceCommands $serviceCommands = null)
    {
        $this->ServiceCommands = $serviceCommands;
        return $this;
    }
}
