<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AddEstimate StructType
 * @subpackage Structs
 */
class AddEstimate extends AbstractStructBase
{
    /**
     * The DisplayName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DisplayName;
    /**
     * The EstimateID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $EstimateID;
    /**
     * The AddExisting
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $AddExisting;
    /**
     * The RevisionID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $RevisionID;
    /**
     * The InventoryCD
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $InventoryCD;
    /**
     * The IsNonInventory
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $IsNonInventory;
    /**
     * The SubItemID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $SubItemID;
    /**
     * The SiteID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $SiteID;
    /**
     * The ItemDesc
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $ItemDesc;
    /**
     * The EstimateClassID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $EstimateClassID;
    /**
     * The ItemClassID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $ItemClassID;
    /**
     * The UOM
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $UOM;
    /**
     * The BranchID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $BranchID;
    /**
     * The ServiceCommands
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\AddEstimateServiceCommands
     */
    public $ServiceCommands;
    /**
     * Constructor method for AddEstimate
     * @uses AddEstimate::setDisplayName()
     * @uses AddEstimate::setEstimateID()
     * @uses AddEstimate::setAddExisting()
     * @uses AddEstimate::setRevisionID()
     * @uses AddEstimate::setInventoryCD()
     * @uses AddEstimate::setIsNonInventory()
     * @uses AddEstimate::setSubItemID()
     * @uses AddEstimate::setSiteID()
     * @uses AddEstimate::setItemDesc()
     * @uses AddEstimate::setEstimateClassID()
     * @uses AddEstimate::setItemClassID()
     * @uses AddEstimate::setUOM()
     * @uses AddEstimate::setBranchID()
     * @uses AddEstimate::setServiceCommands()
     * @param string $displayName
     * @param \StructType\Field $estimateID
     * @param \StructType\Field $addExisting
     * @param \StructType\Field $revisionID
     * @param \StructType\Field $inventoryCD
     * @param \StructType\Field $isNonInventory
     * @param \StructType\Field $subItemID
     * @param \StructType\Field $siteID
     * @param \StructType\Field $itemDesc
     * @param \StructType\Field $estimateClassID
     * @param \StructType\Field $itemClassID
     * @param \StructType\Field $uOM
     * @param \StructType\Field $branchID
     * @param \StructType\AddEstimateServiceCommands $serviceCommands
     */
    public function __construct($displayName = null, \StructType\Field $estimateID = null, \StructType\Field $addExisting = null, \StructType\Field $revisionID = null, \StructType\Field $inventoryCD = null, \StructType\Field $isNonInventory = null, \StructType\Field $subItemID = null, \StructType\Field $siteID = null, \StructType\Field $itemDesc = null, \StructType\Field $estimateClassID = null, \StructType\Field $itemClassID = null, \StructType\Field $uOM = null, \StructType\Field $branchID = null, \StructType\AddEstimateServiceCommands $serviceCommands = null)
    {
        $this
            ->setDisplayName($displayName)
            ->setEstimateID($estimateID)
            ->setAddExisting($addExisting)
            ->setRevisionID($revisionID)
            ->setInventoryCD($inventoryCD)
            ->setIsNonInventory($isNonInventory)
            ->setSubItemID($subItemID)
            ->setSiteID($siteID)
            ->setItemDesc($itemDesc)
            ->setEstimateClassID($estimateClassID)
            ->setItemClassID($itemClassID)
            ->setUOM($uOM)
            ->setBranchID($branchID)
            ->setServiceCommands($serviceCommands);
    }
    /**
     * Get DisplayName value
     * @return string|null
     */
    public function getDisplayName()
    {
        return $this->DisplayName;
    }
    /**
     * Set DisplayName value
     * @param string $displayName
     * @return \StructType\AddEstimate
     */
    public function setDisplayName($displayName = null)
    {
        // validation for constraint: string
        if (!is_null($displayName) && !is_string($displayName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($displayName, true), gettype($displayName)), __LINE__);
        }
        $this->DisplayName = $displayName;
        return $this;
    }
    /**
     * Get EstimateID value
     * @return \StructType\Field|null
     */
    public function getEstimateID()
    {
        return $this->EstimateID;
    }
    /**
     * Set EstimateID value
     * @param \StructType\Field $estimateID
     * @return \StructType\AddEstimate
     */
    public function setEstimateID(\StructType\Field $estimateID = null)
    {
        $this->EstimateID = $estimateID;
        return $this;
    }
    /**
     * Get AddExisting value
     * @return \StructType\Field|null
     */
    public function getAddExisting()
    {
        return $this->AddExisting;
    }
    /**
     * Set AddExisting value
     * @param \StructType\Field $addExisting
     * @return \StructType\AddEstimate
     */
    public function setAddExisting(\StructType\Field $addExisting = null)
    {
        $this->AddExisting = $addExisting;
        return $this;
    }
    /**
     * Get RevisionID value
     * @return \StructType\Field|null
     */
    public function getRevisionID()
    {
        return $this->RevisionID;
    }
    /**
     * Set RevisionID value
     * @param \StructType\Field $revisionID
     * @return \StructType\AddEstimate
     */
    public function setRevisionID(\StructType\Field $revisionID = null)
    {
        $this->RevisionID = $revisionID;
        return $this;
    }
    /**
     * Get InventoryCD value
     * @return \StructType\Field|null
     */
    public function getInventoryCD()
    {
        return $this->InventoryCD;
    }
    /**
     * Set InventoryCD value
     * @param \StructType\Field $inventoryCD
     * @return \StructType\AddEstimate
     */
    public function setInventoryCD(\StructType\Field $inventoryCD = null)
    {
        $this->InventoryCD = $inventoryCD;
        return $this;
    }
    /**
     * Get IsNonInventory value
     * @return \StructType\Field|null
     */
    public function getIsNonInventory()
    {
        return $this->IsNonInventory;
    }
    /**
     * Set IsNonInventory value
     * @param \StructType\Field $isNonInventory
     * @return \StructType\AddEstimate
     */
    public function setIsNonInventory(\StructType\Field $isNonInventory = null)
    {
        $this->IsNonInventory = $isNonInventory;
        return $this;
    }
    /**
     * Get SubItemID value
     * @return \StructType\Field|null
     */
    public function getSubItemID()
    {
        return $this->SubItemID;
    }
    /**
     * Set SubItemID value
     * @param \StructType\Field $subItemID
     * @return \StructType\AddEstimate
     */
    public function setSubItemID(\StructType\Field $subItemID = null)
    {
        $this->SubItemID = $subItemID;
        return $this;
    }
    /**
     * Get SiteID value
     * @return \StructType\Field|null
     */
    public function getSiteID()
    {
        return $this->SiteID;
    }
    /**
     * Set SiteID value
     * @param \StructType\Field $siteID
     * @return \StructType\AddEstimate
     */
    public function setSiteID(\StructType\Field $siteID = null)
    {
        $this->SiteID = $siteID;
        return $this;
    }
    /**
     * Get ItemDesc value
     * @return \StructType\Field|null
     */
    public function getItemDesc()
    {
        return $this->ItemDesc;
    }
    /**
     * Set ItemDesc value
     * @param \StructType\Field $itemDesc
     * @return \StructType\AddEstimate
     */
    public function setItemDesc(\StructType\Field $itemDesc = null)
    {
        $this->ItemDesc = $itemDesc;
        return $this;
    }
    /**
     * Get EstimateClassID value
     * @return \StructType\Field|null
     */
    public function getEstimateClassID()
    {
        return $this->EstimateClassID;
    }
    /**
     * Set EstimateClassID value
     * @param \StructType\Field $estimateClassID
     * @return \StructType\AddEstimate
     */
    public function setEstimateClassID(\StructType\Field $estimateClassID = null)
    {
        $this->EstimateClassID = $estimateClassID;
        return $this;
    }
    /**
     * Get ItemClassID value
     * @return \StructType\Field|null
     */
    public function getItemClassID()
    {
        return $this->ItemClassID;
    }
    /**
     * Set ItemClassID value
     * @param \StructType\Field $itemClassID
     * @return \StructType\AddEstimate
     */
    public function setItemClassID(\StructType\Field $itemClassID = null)
    {
        $this->ItemClassID = $itemClassID;
        return $this;
    }
    /**
     * Get UOM value
     * @return \StructType\Field|null
     */
    public function getUOM()
    {
        return $this->UOM;
    }
    /**
     * Set UOM value
     * @param \StructType\Field $uOM
     * @return \StructType\AddEstimate
     */
    public function setUOM(\StructType\Field $uOM = null)
    {
        $this->UOM = $uOM;
        return $this;
    }
    /**
     * Get BranchID value
     * @return \StructType\Field|null
     */
    public function getBranchID()
    {
        return $this->BranchID;
    }
    /**
     * Set BranchID value
     * @param \StructType\Field $branchID
     * @return \StructType\AddEstimate
     */
    public function setBranchID(\StructType\Field $branchID = null)
    {
        $this->BranchID = $branchID;
        return $this;
    }
    /**
     * Get ServiceCommands value
     * @return \StructType\AddEstimateServiceCommands|null
     */
    public function getServiceCommands()
    {
        return $this->ServiceCommands;
    }
    /**
     * Set ServiceCommands value
     * @param \StructType\AddEstimateServiceCommands $serviceCommands
     * @return \StructType\AddEstimate
     */
    public function setServiceCommands(\StructType\AddEstimateServiceCommands $serviceCommands = null)
    {
        $this->ServiceCommands = $serviceCommands;
        return $this;
    }
}
