<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AddMatrixItemMatrixViewTemplateItemID StructType
 * @subpackage Structs
 */
class AddMatrixItemMatrixViewTemplateItemID extends AbstractStructBase
{
    /**
     * The DisplayName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DisplayName;
    /**
     * The TemplateItemID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $TemplateItemID;
    /**
     * The ColAttributeID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $ColAttributeID;
    /**
     * The RowAttributeID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $RowAttributeID;
    /**
     * The ShowAvailable
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $ShowAvailable;
    /**
     * The SiteID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $SiteID;
    /**
     * The ServiceCommands
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\AddMatrixItemMatrixViewTemplateItemIDServiceCommands
     */
    public $ServiceCommands;
    /**
     * Constructor method for AddMatrixItemMatrixViewTemplateItemID
     * @uses AddMatrixItemMatrixViewTemplateItemID::setDisplayName()
     * @uses AddMatrixItemMatrixViewTemplateItemID::setTemplateItemID()
     * @uses AddMatrixItemMatrixViewTemplateItemID::setColAttributeID()
     * @uses AddMatrixItemMatrixViewTemplateItemID::setRowAttributeID()
     * @uses AddMatrixItemMatrixViewTemplateItemID::setShowAvailable()
     * @uses AddMatrixItemMatrixViewTemplateItemID::setSiteID()
     * @uses AddMatrixItemMatrixViewTemplateItemID::setServiceCommands()
     * @param string $displayName
     * @param \StructType\Field $templateItemID
     * @param \StructType\Field $colAttributeID
     * @param \StructType\Field $rowAttributeID
     * @param \StructType\Field $showAvailable
     * @param \StructType\Field $siteID
     * @param \StructType\AddMatrixItemMatrixViewTemplateItemIDServiceCommands $serviceCommands
     */
    public function __construct($displayName = null, \StructType\Field $templateItemID = null, \StructType\Field $colAttributeID = null, \StructType\Field $rowAttributeID = null, \StructType\Field $showAvailable = null, \StructType\Field $siteID = null, \StructType\AddMatrixItemMatrixViewTemplateItemIDServiceCommands $serviceCommands = null)
    {
        $this
            ->setDisplayName($displayName)
            ->setTemplateItemID($templateItemID)
            ->setColAttributeID($colAttributeID)
            ->setRowAttributeID($rowAttributeID)
            ->setShowAvailable($showAvailable)
            ->setSiteID($siteID)
            ->setServiceCommands($serviceCommands);
    }
    /**
     * Get DisplayName value
     * @return string|null
     */
    public function getDisplayName()
    {
        return $this->DisplayName;
    }
    /**
     * Set DisplayName value
     * @param string $displayName
     * @return \StructType\AddMatrixItemMatrixViewTemplateItemID
     */
    public function setDisplayName($displayName = null)
    {
        // validation for constraint: string
        if (!is_null($displayName) && !is_string($displayName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($displayName, true), gettype($displayName)), __LINE__);
        }
        $this->DisplayName = $displayName;
        return $this;
    }
    /**
     * Get TemplateItemID value
     * @return \StructType\Field|null
     */
    public function getTemplateItemID()
    {
        return $this->TemplateItemID;
    }
    /**
     * Set TemplateItemID value
     * @param \StructType\Field $templateItemID
     * @return \StructType\AddMatrixItemMatrixViewTemplateItemID
     */
    public function setTemplateItemID(\StructType\Field $templateItemID = null)
    {
        $this->TemplateItemID = $templateItemID;
        return $this;
    }
    /**
     * Get ColAttributeID value
     * @return \StructType\Field|null
     */
    public function getColAttributeID()
    {
        return $this->ColAttributeID;
    }
    /**
     * Set ColAttributeID value
     * @param \StructType\Field $colAttributeID
     * @return \StructType\AddMatrixItemMatrixViewTemplateItemID
     */
    public function setColAttributeID(\StructType\Field $colAttributeID = null)
    {
        $this->ColAttributeID = $colAttributeID;
        return $this;
    }
    /**
     * Get RowAttributeID value
     * @return \StructType\Field|null
     */
    public function getRowAttributeID()
    {
        return $this->RowAttributeID;
    }
    /**
     * Set RowAttributeID value
     * @param \StructType\Field $rowAttributeID
     * @return \StructType\AddMatrixItemMatrixViewTemplateItemID
     */
    public function setRowAttributeID(\StructType\Field $rowAttributeID = null)
    {
        $this->RowAttributeID = $rowAttributeID;
        return $this;
    }
    /**
     * Get ShowAvailable value
     * @return \StructType\Field|null
     */
    public function getShowAvailable()
    {
        return $this->ShowAvailable;
    }
    /**
     * Set ShowAvailable value
     * @param \StructType\Field $showAvailable
     * @return \StructType\AddMatrixItemMatrixViewTemplateItemID
     */
    public function setShowAvailable(\StructType\Field $showAvailable = null)
    {
        $this->ShowAvailable = $showAvailable;
        return $this;
    }
    /**
     * Get SiteID value
     * @return \StructType\Field|null
     */
    public function getSiteID()
    {
        return $this->SiteID;
    }
    /**
     * Set SiteID value
     * @param \StructType\Field $siteID
     * @return \StructType\AddMatrixItemMatrixViewTemplateItemID
     */
    public function setSiteID(\StructType\Field $siteID = null)
    {
        $this->SiteID = $siteID;
        return $this;
    }
    /**
     * Get ServiceCommands value
     * @return \StructType\AddMatrixItemMatrixViewTemplateItemIDServiceCommands|null
     */
    public function getServiceCommands()
    {
        return $this->ServiceCommands;
    }
    /**
     * Set ServiceCommands value
     * @param \StructType\AddMatrixItemMatrixViewTemplateItemIDServiceCommands $serviceCommands
     * @return \StructType\AddMatrixItemMatrixViewTemplateItemID
     */
    public function setServiceCommands(\StructType\AddMatrixItemMatrixViewTemplateItemIDServiceCommands $serviceCommands = null)
    {
        $this->ServiceCommands = $serviceCommands;
        return $this;
    }
}
