<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AddMatrixItemTableView StructType
 * @subpackage Structs
 */
class AddMatrixItemTableView extends AbstractStructBase
{
    /**
     * The DisplayName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DisplayName;
    /**
     * The AttributeValue0
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $AttributeValue0;
    /**
     * The Qty
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $Qty;
    /**
     * The InventoryCD
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $InventoryCD;
    /**
     * The Descr
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $Descr;
    /**
     * The New
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $New;
    /**
     * The StkItem
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $StkItem;
    /**
     * The BasePrice
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $BasePrice;
    /**
     * The ItemClassID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $ItemClassID;
    /**
     * The TaxCategoryID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $TaxCategoryID;
    /**
     * The ServiceCommands
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\AddMatrixItemTableViewServiceCommands
     */
    public $ServiceCommands;
    /**
     * Constructor method for AddMatrixItemTableView
     * @uses AddMatrixItemTableView::setDisplayName()
     * @uses AddMatrixItemTableView::setAttributeValue0()
     * @uses AddMatrixItemTableView::setQty()
     * @uses AddMatrixItemTableView::setInventoryCD()
     * @uses AddMatrixItemTableView::setDescr()
     * @uses AddMatrixItemTableView::setNew()
     * @uses AddMatrixItemTableView::setStkItem()
     * @uses AddMatrixItemTableView::setBasePrice()
     * @uses AddMatrixItemTableView::setItemClassID()
     * @uses AddMatrixItemTableView::setTaxCategoryID()
     * @uses AddMatrixItemTableView::setServiceCommands()
     * @param string $displayName
     * @param \StructType\Field $attributeValue0
     * @param \StructType\Field $qty
     * @param \StructType\Field $inventoryCD
     * @param \StructType\Field $descr
     * @param \StructType\Field $new
     * @param \StructType\Field $stkItem
     * @param \StructType\Field $basePrice
     * @param \StructType\Field $itemClassID
     * @param \StructType\Field $taxCategoryID
     * @param \StructType\AddMatrixItemTableViewServiceCommands $serviceCommands
     */
    public function __construct($displayName = null, \StructType\Field $attributeValue0 = null, \StructType\Field $qty = null, \StructType\Field $inventoryCD = null, \StructType\Field $descr = null, \StructType\Field $new = null, \StructType\Field $stkItem = null, \StructType\Field $basePrice = null, \StructType\Field $itemClassID = null, \StructType\Field $taxCategoryID = null, \StructType\AddMatrixItemTableViewServiceCommands $serviceCommands = null)
    {
        $this
            ->setDisplayName($displayName)
            ->setAttributeValue0($attributeValue0)
            ->setQty($qty)
            ->setInventoryCD($inventoryCD)
            ->setDescr($descr)
            ->setNew($new)
            ->setStkItem($stkItem)
            ->setBasePrice($basePrice)
            ->setItemClassID($itemClassID)
            ->setTaxCategoryID($taxCategoryID)
            ->setServiceCommands($serviceCommands);
    }
    /**
     * Get DisplayName value
     * @return string|null
     */
    public function getDisplayName()
    {
        return $this->DisplayName;
    }
    /**
     * Set DisplayName value
     * @param string $displayName
     * @return \StructType\AddMatrixItemTableView
     */
    public function setDisplayName($displayName = null)
    {
        // validation for constraint: string
        if (!is_null($displayName) && !is_string($displayName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($displayName, true), gettype($displayName)), __LINE__);
        }
        $this->DisplayName = $displayName;
        return $this;
    }
    /**
     * Get AttributeValue0 value
     * @return \StructType\Field|null
     */
    public function getAttributeValue0()
    {
        return $this->AttributeValue0;
    }
    /**
     * Set AttributeValue0 value
     * @param \StructType\Field $attributeValue0
     * @return \StructType\AddMatrixItemTableView
     */
    public function setAttributeValue0(\StructType\Field $attributeValue0 = null)
    {
        $this->AttributeValue0 = $attributeValue0;
        return $this;
    }
    /**
     * Get Qty value
     * @return \StructType\Field|null
     */
    public function getQty()
    {
        return $this->Qty;
    }
    /**
     * Set Qty value
     * @param \StructType\Field $qty
     * @return \StructType\AddMatrixItemTableView
     */
    public function setQty(\StructType\Field $qty = null)
    {
        $this->Qty = $qty;
        return $this;
    }
    /**
     * Get InventoryCD value
     * @return \StructType\Field|null
     */
    public function getInventoryCD()
    {
        return $this->InventoryCD;
    }
    /**
     * Set InventoryCD value
     * @param \StructType\Field $inventoryCD
     * @return \StructType\AddMatrixItemTableView
     */
    public function setInventoryCD(\StructType\Field $inventoryCD = null)
    {
        $this->InventoryCD = $inventoryCD;
        return $this;
    }
    /**
     * Get Descr value
     * @return \StructType\Field|null
     */
    public function getDescr()
    {
        return $this->Descr;
    }
    /**
     * Set Descr value
     * @param \StructType\Field $descr
     * @return \StructType\AddMatrixItemTableView
     */
    public function setDescr(\StructType\Field $descr = null)
    {
        $this->Descr = $descr;
        return $this;
    }
    /**
     * Get New value
     * @return \StructType\Field|null
     */
    public function getNew()
    {
        return $this->New;
    }
    /**
     * Set New value
     * @param \StructType\Field $new
     * @return \StructType\AddMatrixItemTableView
     */
    public function setNew(\StructType\Field $new = null)
    {
        $this->New = $new;
        return $this;
    }
    /**
     * Get StkItem value
     * @return \StructType\Field|null
     */
    public function getStkItem()
    {
        return $this->StkItem;
    }
    /**
     * Set StkItem value
     * @param \StructType\Field $stkItem
     * @return \StructType\AddMatrixItemTableView
     */
    public function setStkItem(\StructType\Field $stkItem = null)
    {
        $this->StkItem = $stkItem;
        return $this;
    }
    /**
     * Get BasePrice value
     * @return \StructType\Field|null
     */
    public function getBasePrice()
    {
        return $this->BasePrice;
    }
    /**
     * Set BasePrice value
     * @param \StructType\Field $basePrice
     * @return \StructType\AddMatrixItemTableView
     */
    public function setBasePrice(\StructType\Field $basePrice = null)
    {
        $this->BasePrice = $basePrice;
        return $this;
    }
    /**
     * Get ItemClassID value
     * @return \StructType\Field|null
     */
    public function getItemClassID()
    {
        return $this->ItemClassID;
    }
    /**
     * Set ItemClassID value
     * @param \StructType\Field $itemClassID
     * @return \StructType\AddMatrixItemTableView
     */
    public function setItemClassID(\StructType\Field $itemClassID = null)
    {
        $this->ItemClassID = $itemClassID;
        return $this;
    }
    /**
     * Get TaxCategoryID value
     * @return \StructType\Field|null
     */
    public function getTaxCategoryID()
    {
        return $this->TaxCategoryID;
    }
    /**
     * Set TaxCategoryID value
     * @param \StructType\Field $taxCategoryID
     * @return \StructType\AddMatrixItemTableView
     */
    public function setTaxCategoryID(\StructType\Field $taxCategoryID = null)
    {
        $this->TaxCategoryID = $taxCategoryID;
        return $this;
    }
    /**
     * Get ServiceCommands value
     * @return \StructType\AddMatrixItemTableViewServiceCommands|null
     */
    public function getServiceCommands()
    {
        return $this->ServiceCommands;
    }
    /**
     * Set ServiceCommands value
     * @param \StructType\AddMatrixItemTableViewServiceCommands $serviceCommands
     * @return \StructType\AddMatrixItemTableView
     */
    public function setServiceCommands(\StructType\AddMatrixItemTableViewServiceCommands $serviceCommands = null)
    {
        $this->ServiceCommands = $serviceCommands;
        return $this;
    }
}
