<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AddressesBillToAddress StructType
 * @subpackage Structs
 */
class AddressesBillToAddress extends AbstractStructBase
{
    /**
     * The DisplayName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DisplayName;
    /**
     * The OverrideAddress
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $OverrideAddress;
    /**
     * The AddressLine1
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $AddressLine1;
    /**
     * The AddressLine2
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $AddressLine2;
    /**
     * The City
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $City;
    /**
     * The Country
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $Country;
    /**
     * The State
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $State;
    /**
     * The PostalCode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $PostalCode;
    /**
     * The Validated
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $Validated;
    /**
     * The ServiceCommands
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\AddressesBillToAddressServiceCommands
     */
    public $ServiceCommands;
    /**
     * Constructor method for AddressesBillToAddress
     * @uses AddressesBillToAddress::setDisplayName()
     * @uses AddressesBillToAddress::setOverrideAddress()
     * @uses AddressesBillToAddress::setAddressLine1()
     * @uses AddressesBillToAddress::setAddressLine2()
     * @uses AddressesBillToAddress::setCity()
     * @uses AddressesBillToAddress::setCountry()
     * @uses AddressesBillToAddress::setState()
     * @uses AddressesBillToAddress::setPostalCode()
     * @uses AddressesBillToAddress::setValidated()
     * @uses AddressesBillToAddress::setServiceCommands()
     * @param string $displayName
     * @param \StructType\Field $overrideAddress
     * @param \StructType\Field $addressLine1
     * @param \StructType\Field $addressLine2
     * @param \StructType\Field $city
     * @param \StructType\Field $country
     * @param \StructType\Field $state
     * @param \StructType\Field $postalCode
     * @param \StructType\Field $validated
     * @param \StructType\AddressesBillToAddressServiceCommands $serviceCommands
     */
    public function __construct($displayName = null, \StructType\Field $overrideAddress = null, \StructType\Field $addressLine1 = null, \StructType\Field $addressLine2 = null, \StructType\Field $city = null, \StructType\Field $country = null, \StructType\Field $state = null, \StructType\Field $postalCode = null, \StructType\Field $validated = null, \StructType\AddressesBillToAddressServiceCommands $serviceCommands = null)
    {
        $this
            ->setDisplayName($displayName)
            ->setOverrideAddress($overrideAddress)
            ->setAddressLine1($addressLine1)
            ->setAddressLine2($addressLine2)
            ->setCity($city)
            ->setCountry($country)
            ->setState($state)
            ->setPostalCode($postalCode)
            ->setValidated($validated)
            ->setServiceCommands($serviceCommands);
    }
    /**
     * Get DisplayName value
     * @return string|null
     */
    public function getDisplayName()
    {
        return $this->DisplayName;
    }
    /**
     * Set DisplayName value
     * @param string $displayName
     * @return \StructType\AddressesBillToAddress
     */
    public function setDisplayName($displayName = null)
    {
        // validation for constraint: string
        if (!is_null($displayName) && !is_string($displayName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($displayName, true), gettype($displayName)), __LINE__);
        }
        $this->DisplayName = $displayName;
        return $this;
    }
    /**
     * Get OverrideAddress value
     * @return \StructType\Field|null
     */
    public function getOverrideAddress()
    {
        return $this->OverrideAddress;
    }
    /**
     * Set OverrideAddress value
     * @param \StructType\Field $overrideAddress
     * @return \StructType\AddressesBillToAddress
     */
    public function setOverrideAddress(\StructType\Field $overrideAddress = null)
    {
        $this->OverrideAddress = $overrideAddress;
        return $this;
    }
    /**
     * Get AddressLine1 value
     * @return \StructType\Field|null
     */
    public function getAddressLine1()
    {
        return $this->AddressLine1;
    }
    /**
     * Set AddressLine1 value
     * @param \StructType\Field $addressLine1
     * @return \StructType\AddressesBillToAddress
     */
    public function setAddressLine1(\StructType\Field $addressLine1 = null)
    {
        $this->AddressLine1 = $addressLine1;
        return $this;
    }
    /**
     * Get AddressLine2 value
     * @return \StructType\Field|null
     */
    public function getAddressLine2()
    {
        return $this->AddressLine2;
    }
    /**
     * Set AddressLine2 value
     * @param \StructType\Field $addressLine2
     * @return \StructType\AddressesBillToAddress
     */
    public function setAddressLine2(\StructType\Field $addressLine2 = null)
    {
        $this->AddressLine2 = $addressLine2;
        return $this;
    }
    /**
     * Get City value
     * @return \StructType\Field|null
     */
    public function getCity()
    {
        return $this->City;
    }
    /**
     * Set City value
     * @param \StructType\Field $city
     * @return \StructType\AddressesBillToAddress
     */
    public function setCity(\StructType\Field $city = null)
    {
        $this->City = $city;
        return $this;
    }
    /**
     * Get Country value
     * @return \StructType\Field|null
     */
    public function getCountry()
    {
        return $this->Country;
    }
    /**
     * Set Country value
     * @param \StructType\Field $country
     * @return \StructType\AddressesBillToAddress
     */
    public function setCountry(\StructType\Field $country = null)
    {
        $this->Country = $country;
        return $this;
    }
    /**
     * Get State value
     * @return \StructType\Field|null
     */
    public function getState()
    {
        return $this->State;
    }
    /**
     * Set State value
     * @param \StructType\Field $state
     * @return \StructType\AddressesBillToAddress
     */
    public function setState(\StructType\Field $state = null)
    {
        $this->State = $state;
        return $this;
    }
    /**
     * Get PostalCode value
     * @return \StructType\Field|null
     */
    public function getPostalCode()
    {
        return $this->PostalCode;
    }
    /**
     * Set PostalCode value
     * @param \StructType\Field $postalCode
     * @return \StructType\AddressesBillToAddress
     */
    public function setPostalCode(\StructType\Field $postalCode = null)
    {
        $this->PostalCode = $postalCode;
        return $this;
    }
    /**
     * Get Validated value
     * @return \StructType\Field|null
     */
    public function getValidated()
    {
        return $this->Validated;
    }
    /**
     * Set Validated value
     * @param \StructType\Field $validated
     * @return \StructType\AddressesBillToAddress
     */
    public function setValidated(\StructType\Field $validated = null)
    {
        $this->Validated = $validated;
        return $this;
    }
    /**
     * Get ServiceCommands value
     * @return \StructType\AddressesBillToAddressServiceCommands|null
     */
    public function getServiceCommands()
    {
        return $this->ServiceCommands;
    }
    /**
     * Set ServiceCommands value
     * @param \StructType\AddressesBillToAddressServiceCommands $serviceCommands
     * @return \StructType\AddressesBillToAddress
     */
    public function setServiceCommands(\StructType\AddressesBillToAddressServiceCommands $serviceCommands = null)
    {
        $this->ServiceCommands = $serviceCommands;
        return $this;
    }
}
