<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AddressesShipToContact StructType
 * @subpackage Structs
 */
class AddressesShipToContact extends AbstractStructBase
{
    /**
     * The DisplayName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DisplayName;
    /**
     * The OverrideContact
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $OverrideContact;
    /**
     * The AccountName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $AccountName;
    /**
     * The Attention
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $Attention;
    /**
     * The Phone1
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $Phone1;
    /**
     * The Email
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $Email;
    /**
     * The ServiceCommands
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\AddressesShipToContactServiceCommands
     */
    public $ServiceCommands;
    /**
     * Constructor method for AddressesShipToContact
     * @uses AddressesShipToContact::setDisplayName()
     * @uses AddressesShipToContact::setOverrideContact()
     * @uses AddressesShipToContact::setAccountName()
     * @uses AddressesShipToContact::setAttention()
     * @uses AddressesShipToContact::setPhone1()
     * @uses AddressesShipToContact::setEmail()
     * @uses AddressesShipToContact::setServiceCommands()
     * @param string $displayName
     * @param \StructType\Field $overrideContact
     * @param \StructType\Field $accountName
     * @param \StructType\Field $attention
     * @param \StructType\Field $phone1
     * @param \StructType\Field $email
     * @param \StructType\AddressesShipToContactServiceCommands $serviceCommands
     */
    public function __construct($displayName = null, \StructType\Field $overrideContact = null, \StructType\Field $accountName = null, \StructType\Field $attention = null, \StructType\Field $phone1 = null, \StructType\Field $email = null, \StructType\AddressesShipToContactServiceCommands $serviceCommands = null)
    {
        $this
            ->setDisplayName($displayName)
            ->setOverrideContact($overrideContact)
            ->setAccountName($accountName)
            ->setAttention($attention)
            ->setPhone1($phone1)
            ->setEmail($email)
            ->setServiceCommands($serviceCommands);
    }
    /**
     * Get DisplayName value
     * @return string|null
     */
    public function getDisplayName()
    {
        return $this->DisplayName;
    }
    /**
     * Set DisplayName value
     * @param string $displayName
     * @return \StructType\AddressesShipToContact
     */
    public function setDisplayName($displayName = null)
    {
        // validation for constraint: string
        if (!is_null($displayName) && !is_string($displayName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($displayName, true), gettype($displayName)), __LINE__);
        }
        $this->DisplayName = $displayName;
        return $this;
    }
    /**
     * Get OverrideContact value
     * @return \StructType\Field|null
     */
    public function getOverrideContact()
    {
        return $this->OverrideContact;
    }
    /**
     * Set OverrideContact value
     * @param \StructType\Field $overrideContact
     * @return \StructType\AddressesShipToContact
     */
    public function setOverrideContact(\StructType\Field $overrideContact = null)
    {
        $this->OverrideContact = $overrideContact;
        return $this;
    }
    /**
     * Get AccountName value
     * @return \StructType\Field|null
     */
    public function getAccountName()
    {
        return $this->AccountName;
    }
    /**
     * Set AccountName value
     * @param \StructType\Field $accountName
     * @return \StructType\AddressesShipToContact
     */
    public function setAccountName(\StructType\Field $accountName = null)
    {
        $this->AccountName = $accountName;
        return $this;
    }
    /**
     * Get Attention value
     * @return \StructType\Field|null
     */
    public function getAttention()
    {
        return $this->Attention;
    }
    /**
     * Set Attention value
     * @param \StructType\Field $attention
     * @return \StructType\AddressesShipToContact
     */
    public function setAttention(\StructType\Field $attention = null)
    {
        $this->Attention = $attention;
        return $this;
    }
    /**
     * Get Phone1 value
     * @return \StructType\Field|null
     */
    public function getPhone1()
    {
        return $this->Phone1;
    }
    /**
     * Set Phone1 value
     * @param \StructType\Field $phone1
     * @return \StructType\AddressesShipToContact
     */
    public function setPhone1(\StructType\Field $phone1 = null)
    {
        $this->Phone1 = $phone1;
        return $this;
    }
    /**
     * Get Email value
     * @return \StructType\Field|null
     */
    public function getEmail()
    {
        return $this->Email;
    }
    /**
     * Set Email value
     * @param \StructType\Field $email
     * @return \StructType\AddressesShipToContact
     */
    public function setEmail(\StructType\Field $email = null)
    {
        $this->Email = $email;
        return $this;
    }
    /**
     * Get ServiceCommands value
     * @return \StructType\AddressesShipToContactServiceCommands|null
     */
    public function getServiceCommands()
    {
        return $this->ServiceCommands;
    }
    /**
     * Set ServiceCommands value
     * @param \StructType\AddressesShipToContactServiceCommands $serviceCommands
     * @return \StructType\AddressesShipToContact
     */
    public function setServiceCommands(\StructType\AddressesShipToContactServiceCommands $serviceCommands = null)
    {
        $this->ServiceCommands = $serviceCommands;
        return $this;
    }
}
