<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Approvals StructType
 * @subpackage Structs
 */
class Approvals extends AbstractStructBase
{
    /**
     * The DisplayName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DisplayName;
    /**
     * The AssigneeID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $AssigneeID;
    /**
     * The AssignedTo
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $AssignedTo;
    /**
     * The Workgroup
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $Workgroup;
    /**
     * The ApprovedByID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $ApprovedByID;
    /**
     * The ApprovedBy
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $ApprovedBy;
    /**
     * The ApprovalDate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $ApprovalDate;
    /**
     * The Status
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $Status;
    /**
     * The Reason
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $Reason;
    /**
     * The Map
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $Map;
    /**
     * The MapRule
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $MapRule;
    /**
     * The MapStep
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $MapStep;
    /**
     * The AssignmentDate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $AssignmentDate;
    /**
     * The NoteText
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $NoteText;
    /**
     * The ServiceCommands
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\ApprovalsServiceCommands
     */
    public $ServiceCommands;
    /**
     * Constructor method for Approvals
     * @uses Approvals::setDisplayName()
     * @uses Approvals::setAssigneeID()
     * @uses Approvals::setAssignedTo()
     * @uses Approvals::setWorkgroup()
     * @uses Approvals::setApprovedByID()
     * @uses Approvals::setApprovedBy()
     * @uses Approvals::setApprovalDate()
     * @uses Approvals::setStatus()
     * @uses Approvals::setReason()
     * @uses Approvals::setMap()
     * @uses Approvals::setMapRule()
     * @uses Approvals::setMapStep()
     * @uses Approvals::setAssignmentDate()
     * @uses Approvals::setNoteText()
     * @uses Approvals::setServiceCommands()
     * @param string $displayName
     * @param \StructType\Field $assigneeID
     * @param \StructType\Field $assignedTo
     * @param \StructType\Field $workgroup
     * @param \StructType\Field $approvedByID
     * @param \StructType\Field $approvedBy
     * @param \StructType\Field $approvalDate
     * @param \StructType\Field $status
     * @param \StructType\Field $reason
     * @param \StructType\Field $map
     * @param \StructType\Field $mapRule
     * @param \StructType\Field $mapStep
     * @param \StructType\Field $assignmentDate
     * @param \StructType\Field $noteText
     * @param \StructType\ApprovalsServiceCommands $serviceCommands
     */
    public function __construct($displayName = null, \StructType\Field $assigneeID = null, \StructType\Field $assignedTo = null, \StructType\Field $workgroup = null, \StructType\Field $approvedByID = null, \StructType\Field $approvedBy = null, \StructType\Field $approvalDate = null, \StructType\Field $status = null, \StructType\Field $reason = null, \StructType\Field $map = null, \StructType\Field $mapRule = null, \StructType\Field $mapStep = null, \StructType\Field $assignmentDate = null, \StructType\Field $noteText = null, \StructType\ApprovalsServiceCommands $serviceCommands = null)
    {
        $this
            ->setDisplayName($displayName)
            ->setAssigneeID($assigneeID)
            ->setAssignedTo($assignedTo)
            ->setWorkgroup($workgroup)
            ->setApprovedByID($approvedByID)
            ->setApprovedBy($approvedBy)
            ->setApprovalDate($approvalDate)
            ->setStatus($status)
            ->setReason($reason)
            ->setMap($map)
            ->setMapRule($mapRule)
            ->setMapStep($mapStep)
            ->setAssignmentDate($assignmentDate)
            ->setNoteText($noteText)
            ->setServiceCommands($serviceCommands);
    }
    /**
     * Get DisplayName value
     * @return string|null
     */
    public function getDisplayName()
    {
        return $this->DisplayName;
    }
    /**
     * Set DisplayName value
     * @param string $displayName
     * @return \StructType\Approvals
     */
    public function setDisplayName($displayName = null)
    {
        // validation for constraint: string
        if (!is_null($displayName) && !is_string($displayName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($displayName, true), gettype($displayName)), __LINE__);
        }
        $this->DisplayName = $displayName;
        return $this;
    }
    /**
     * Get AssigneeID value
     * @return \StructType\Field|null
     */
    public function getAssigneeID()
    {
        return $this->AssigneeID;
    }
    /**
     * Set AssigneeID value
     * @param \StructType\Field $assigneeID
     * @return \StructType\Approvals
     */
    public function setAssigneeID(\StructType\Field $assigneeID = null)
    {
        $this->AssigneeID = $assigneeID;
        return $this;
    }
    /**
     * Get AssignedTo value
     * @return \StructType\Field|null
     */
    public function getAssignedTo()
    {
        return $this->AssignedTo;
    }
    /**
     * Set AssignedTo value
     * @param \StructType\Field $assignedTo
     * @return \StructType\Approvals
     */
    public function setAssignedTo(\StructType\Field $assignedTo = null)
    {
        $this->AssignedTo = $assignedTo;
        return $this;
    }
    /**
     * Get Workgroup value
     * @return \StructType\Field|null
     */
    public function getWorkgroup()
    {
        return $this->Workgroup;
    }
    /**
     * Set Workgroup value
     * @param \StructType\Field $workgroup
     * @return \StructType\Approvals
     */
    public function setWorkgroup(\StructType\Field $workgroup = null)
    {
        $this->Workgroup = $workgroup;
        return $this;
    }
    /**
     * Get ApprovedByID value
     * @return \StructType\Field|null
     */
    public function getApprovedByID()
    {
        return $this->ApprovedByID;
    }
    /**
     * Set ApprovedByID value
     * @param \StructType\Field $approvedByID
     * @return \StructType\Approvals
     */
    public function setApprovedByID(\StructType\Field $approvedByID = null)
    {
        $this->ApprovedByID = $approvedByID;
        return $this;
    }
    /**
     * Get ApprovedBy value
     * @return \StructType\Field|null
     */
    public function getApprovedBy()
    {
        return $this->ApprovedBy;
    }
    /**
     * Set ApprovedBy value
     * @param \StructType\Field $approvedBy
     * @return \StructType\Approvals
     */
    public function setApprovedBy(\StructType\Field $approvedBy = null)
    {
        $this->ApprovedBy = $approvedBy;
        return $this;
    }
    /**
     * Get ApprovalDate value
     * @return \StructType\Field|null
     */
    public function getApprovalDate()
    {
        return $this->ApprovalDate;
    }
    /**
     * Set ApprovalDate value
     * @param \StructType\Field $approvalDate
     * @return \StructType\Approvals
     */
    public function setApprovalDate(\StructType\Field $approvalDate = null)
    {
        $this->ApprovalDate = $approvalDate;
        return $this;
    }
    /**
     * Get Status value
     * @return \StructType\Field|null
     */
    public function getStatus()
    {
        return $this->Status;
    }
    /**
     * Set Status value
     * @param \StructType\Field $status
     * @return \StructType\Approvals
     */
    public function setStatus(\StructType\Field $status = null)
    {
        $this->Status = $status;
        return $this;
    }
    /**
     * Get Reason value
     * @return \StructType\Field|null
     */
    public function getReason()
    {
        return $this->Reason;
    }
    /**
     * Set Reason value
     * @param \StructType\Field $reason
     * @return \StructType\Approvals
     */
    public function setReason(\StructType\Field $reason = null)
    {
        $this->Reason = $reason;
        return $this;
    }
    /**
     * Get Map value
     * @return \StructType\Field|null
     */
    public function getMap()
    {
        return $this->Map;
    }
    /**
     * Set Map value
     * @param \StructType\Field $map
     * @return \StructType\Approvals
     */
    public function setMap(\StructType\Field $map = null)
    {
        $this->Map = $map;
        return $this;
    }
    /**
     * Get MapRule value
     * @return \StructType\Field|null
     */
    public function getMapRule()
    {
        return $this->MapRule;
    }
    /**
     * Set MapRule value
     * @param \StructType\Field $mapRule
     * @return \StructType\Approvals
     */
    public function setMapRule(\StructType\Field $mapRule = null)
    {
        $this->MapRule = $mapRule;
        return $this;
    }
    /**
     * Get MapStep value
     * @return \StructType\Field|null
     */
    public function getMapStep()
    {
        return $this->MapStep;
    }
    /**
     * Set MapStep value
     * @param \StructType\Field $mapStep
     * @return \StructType\Approvals
     */
    public function setMapStep(\StructType\Field $mapStep = null)
    {
        $this->MapStep = $mapStep;
        return $this;
    }
    /**
     * Get AssignmentDate value
     * @return \StructType\Field|null
     */
    public function getAssignmentDate()
    {
        return $this->AssignmentDate;
    }
    /**
     * Set AssignmentDate value
     * @param \StructType\Field $assignmentDate
     * @return \StructType\Approvals
     */
    public function setAssignmentDate(\StructType\Field $assignmentDate = null)
    {
        $this->AssignmentDate = $assignmentDate;
        return $this;
    }
    /**
     * Get NoteText value
     * @return \StructType\Field|null
     */
    public function getNoteText()
    {
        return $this->NoteText;
    }
    /**
     * Set NoteText value
     * @param \StructType\Field $noteText
     * @return \StructType\Approvals
     */
    public function setNoteText(\StructType\Field $noteText = null)
    {
        $this->NoteText = $noteText;
        return $this;
    }
    /**
     * Get ServiceCommands value
     * @return \StructType\ApprovalsServiceCommands|null
     */
    public function getServiceCommands()
    {
        return $this->ServiceCommands;
    }
    /**
     * Set ServiceCommands value
     * @param \StructType\ApprovalsServiceCommands $serviceCommands
     * @return \StructType\Approvals
     */
    public function setServiceCommands(\StructType\ApprovalsServiceCommands $serviceCommands = null)
    {
        $this->ServiceCommands = $serviceCommands;
        return $this;
    }
}
