<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ChildOrders StructType
 * @subpackage Structs
 */
class ChildOrders extends AbstractStructBase
{
    /**
     * The DisplayName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DisplayName;
    /**
     * The ShipToLocation
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $ShipToLocation;
    /**
     * The OrderNbr
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $OrderNbr;
    /**
     * The OrderDate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $OrderDate;
    /**
     * The OrderStatus
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $OrderStatus;
    /**
     * The OrderedQty
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $OrderedQty;
    /**
     * The OrderedAmount
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $OrderedAmount;
    /**
     * The ShipmentType
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $ShipmentType;
    /**
     * The ShipmentNbr
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $ShipmentNbr;
    /**
     * The DocumentNbr
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $DocumentNbr;
    /**
     * The ShipmentDate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $ShipmentDate;
    /**
     * The ShipmentStatus
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $ShipmentStatus;
    /**
     * The ShippedQty
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $ShippedQty;
    /**
     * The InvoiceType
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $InvoiceType;
    /**
     * The InvoiceNbr
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $InvoiceNbr;
    /**
     * The InvoiceDate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $InvoiceDate;
    /**
     * The InvoiceStatus
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $InvoiceStatus;
    /**
     * The ServiceCommands
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\ChildOrdersServiceCommands
     */
    public $ServiceCommands;
    /**
     * Constructor method for ChildOrders
     * @uses ChildOrders::setDisplayName()
     * @uses ChildOrders::setShipToLocation()
     * @uses ChildOrders::setOrderNbr()
     * @uses ChildOrders::setOrderDate()
     * @uses ChildOrders::setOrderStatus()
     * @uses ChildOrders::setOrderedQty()
     * @uses ChildOrders::setOrderedAmount()
     * @uses ChildOrders::setShipmentType()
     * @uses ChildOrders::setShipmentNbr()
     * @uses ChildOrders::setDocumentNbr()
     * @uses ChildOrders::setShipmentDate()
     * @uses ChildOrders::setShipmentStatus()
     * @uses ChildOrders::setShippedQty()
     * @uses ChildOrders::setInvoiceType()
     * @uses ChildOrders::setInvoiceNbr()
     * @uses ChildOrders::setInvoiceDate()
     * @uses ChildOrders::setInvoiceStatus()
     * @uses ChildOrders::setServiceCommands()
     * @param string $displayName
     * @param \StructType\Field $shipToLocation
     * @param \StructType\Field $orderNbr
     * @param \StructType\Field $orderDate
     * @param \StructType\Field $orderStatus
     * @param \StructType\Field $orderedQty
     * @param \StructType\Field $orderedAmount
     * @param \StructType\Field $shipmentType
     * @param \StructType\Field $shipmentNbr
     * @param \StructType\Field $documentNbr
     * @param \StructType\Field $shipmentDate
     * @param \StructType\Field $shipmentStatus
     * @param \StructType\Field $shippedQty
     * @param \StructType\Field $invoiceType
     * @param \StructType\Field $invoiceNbr
     * @param \StructType\Field $invoiceDate
     * @param \StructType\Field $invoiceStatus
     * @param \StructType\ChildOrdersServiceCommands $serviceCommands
     */
    public function __construct($displayName = null, \StructType\Field $shipToLocation = null, \StructType\Field $orderNbr = null, \StructType\Field $orderDate = null, \StructType\Field $orderStatus = null, \StructType\Field $orderedQty = null, \StructType\Field $orderedAmount = null, \StructType\Field $shipmentType = null, \StructType\Field $shipmentNbr = null, \StructType\Field $documentNbr = null, \StructType\Field $shipmentDate = null, \StructType\Field $shipmentStatus = null, \StructType\Field $shippedQty = null, \StructType\Field $invoiceType = null, \StructType\Field $invoiceNbr = null, \StructType\Field $invoiceDate = null, \StructType\Field $invoiceStatus = null, \StructType\ChildOrdersServiceCommands $serviceCommands = null)
    {
        $this
            ->setDisplayName($displayName)
            ->setShipToLocation($shipToLocation)
            ->setOrderNbr($orderNbr)
            ->setOrderDate($orderDate)
            ->setOrderStatus($orderStatus)
            ->setOrderedQty($orderedQty)
            ->setOrderedAmount($orderedAmount)
            ->setShipmentType($shipmentType)
            ->setShipmentNbr($shipmentNbr)
            ->setDocumentNbr($documentNbr)
            ->setShipmentDate($shipmentDate)
            ->setShipmentStatus($shipmentStatus)
            ->setShippedQty($shippedQty)
            ->setInvoiceType($invoiceType)
            ->setInvoiceNbr($invoiceNbr)
            ->setInvoiceDate($invoiceDate)
            ->setInvoiceStatus($invoiceStatus)
            ->setServiceCommands($serviceCommands);
    }
    /**
     * Get DisplayName value
     * @return string|null
     */
    public function getDisplayName()
    {
        return $this->DisplayName;
    }
    /**
     * Set DisplayName value
     * @param string $displayName
     * @return \StructType\ChildOrders
     */
    public function setDisplayName($displayName = null)
    {
        // validation for constraint: string
        if (!is_null($displayName) && !is_string($displayName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($displayName, true), gettype($displayName)), __LINE__);
        }
        $this->DisplayName = $displayName;
        return $this;
    }
    /**
     * Get ShipToLocation value
     * @return \StructType\Field|null
     */
    public function getShipToLocation()
    {
        return $this->ShipToLocation;
    }
    /**
     * Set ShipToLocation value
     * @param \StructType\Field $shipToLocation
     * @return \StructType\ChildOrders
     */
    public function setShipToLocation(\StructType\Field $shipToLocation = null)
    {
        $this->ShipToLocation = $shipToLocation;
        return $this;
    }
    /**
     * Get OrderNbr value
     * @return \StructType\Field|null
     */
    public function getOrderNbr()
    {
        return $this->OrderNbr;
    }
    /**
     * Set OrderNbr value
     * @param \StructType\Field $orderNbr
     * @return \StructType\ChildOrders
     */
    public function setOrderNbr(\StructType\Field $orderNbr = null)
    {
        $this->OrderNbr = $orderNbr;
        return $this;
    }
    /**
     * Get OrderDate value
     * @return \StructType\Field|null
     */
    public function getOrderDate()
    {
        return $this->OrderDate;
    }
    /**
     * Set OrderDate value
     * @param \StructType\Field $orderDate
     * @return \StructType\ChildOrders
     */
    public function setOrderDate(\StructType\Field $orderDate = null)
    {
        $this->OrderDate = $orderDate;
        return $this;
    }
    /**
     * Get OrderStatus value
     * @return \StructType\Field|null
     */
    public function getOrderStatus()
    {
        return $this->OrderStatus;
    }
    /**
     * Set OrderStatus value
     * @param \StructType\Field $orderStatus
     * @return \StructType\ChildOrders
     */
    public function setOrderStatus(\StructType\Field $orderStatus = null)
    {
        $this->OrderStatus = $orderStatus;
        return $this;
    }
    /**
     * Get OrderedQty value
     * @return \StructType\Field|null
     */
    public function getOrderedQty()
    {
        return $this->OrderedQty;
    }
    /**
     * Set OrderedQty value
     * @param \StructType\Field $orderedQty
     * @return \StructType\ChildOrders
     */
    public function setOrderedQty(\StructType\Field $orderedQty = null)
    {
        $this->OrderedQty = $orderedQty;
        return $this;
    }
    /**
     * Get OrderedAmount value
     * @return \StructType\Field|null
     */
    public function getOrderedAmount()
    {
        return $this->OrderedAmount;
    }
    /**
     * Set OrderedAmount value
     * @param \StructType\Field $orderedAmount
     * @return \StructType\ChildOrders
     */
    public function setOrderedAmount(\StructType\Field $orderedAmount = null)
    {
        $this->OrderedAmount = $orderedAmount;
        return $this;
    }
    /**
     * Get ShipmentType value
     * @return \StructType\Field|null
     */
    public function getShipmentType()
    {
        return $this->ShipmentType;
    }
    /**
     * Set ShipmentType value
     * @param \StructType\Field $shipmentType
     * @return \StructType\ChildOrders
     */
    public function setShipmentType(\StructType\Field $shipmentType = null)
    {
        $this->ShipmentType = $shipmentType;
        return $this;
    }
    /**
     * Get ShipmentNbr value
     * @return \StructType\Field|null
     */
    public function getShipmentNbr()
    {
        return $this->ShipmentNbr;
    }
    /**
     * Set ShipmentNbr value
     * @param \StructType\Field $shipmentNbr
     * @return \StructType\ChildOrders
     */
    public function setShipmentNbr(\StructType\Field $shipmentNbr = null)
    {
        $this->ShipmentNbr = $shipmentNbr;
        return $this;
    }
    /**
     * Get DocumentNbr value
     * @return \StructType\Field|null
     */
    public function getDocumentNbr()
    {
        return $this->DocumentNbr;
    }
    /**
     * Set DocumentNbr value
     * @param \StructType\Field $documentNbr
     * @return \StructType\ChildOrders
     */
    public function setDocumentNbr(\StructType\Field $documentNbr = null)
    {
        $this->DocumentNbr = $documentNbr;
        return $this;
    }
    /**
     * Get ShipmentDate value
     * @return \StructType\Field|null
     */
    public function getShipmentDate()
    {
        return $this->ShipmentDate;
    }
    /**
     * Set ShipmentDate value
     * @param \StructType\Field $shipmentDate
     * @return \StructType\ChildOrders
     */
    public function setShipmentDate(\StructType\Field $shipmentDate = null)
    {
        $this->ShipmentDate = $shipmentDate;
        return $this;
    }
    /**
     * Get ShipmentStatus value
     * @return \StructType\Field|null
     */
    public function getShipmentStatus()
    {
        return $this->ShipmentStatus;
    }
    /**
     * Set ShipmentStatus value
     * @param \StructType\Field $shipmentStatus
     * @return \StructType\ChildOrders
     */
    public function setShipmentStatus(\StructType\Field $shipmentStatus = null)
    {
        $this->ShipmentStatus = $shipmentStatus;
        return $this;
    }
    /**
     * Get ShippedQty value
     * @return \StructType\Field|null
     */
    public function getShippedQty()
    {
        return $this->ShippedQty;
    }
    /**
     * Set ShippedQty value
     * @param \StructType\Field $shippedQty
     * @return \StructType\ChildOrders
     */
    public function setShippedQty(\StructType\Field $shippedQty = null)
    {
        $this->ShippedQty = $shippedQty;
        return $this;
    }
    /**
     * Get InvoiceType value
     * @return \StructType\Field|null
     */
    public function getInvoiceType()
    {
        return $this->InvoiceType;
    }
    /**
     * Set InvoiceType value
     * @param \StructType\Field $invoiceType
     * @return \StructType\ChildOrders
     */
    public function setInvoiceType(\StructType\Field $invoiceType = null)
    {
        $this->InvoiceType = $invoiceType;
        return $this;
    }
    /**
     * Get InvoiceNbr value
     * @return \StructType\Field|null
     */
    public function getInvoiceNbr()
    {
        return $this->InvoiceNbr;
    }
    /**
     * Set InvoiceNbr value
     * @param \StructType\Field $invoiceNbr
     * @return \StructType\ChildOrders
     */
    public function setInvoiceNbr(\StructType\Field $invoiceNbr = null)
    {
        $this->InvoiceNbr = $invoiceNbr;
        return $this;
    }
    /**
     * Get InvoiceDate value
     * @return \StructType\Field|null
     */
    public function getInvoiceDate()
    {
        return $this->InvoiceDate;
    }
    /**
     * Set InvoiceDate value
     * @param \StructType\Field $invoiceDate
     * @return \StructType\ChildOrders
     */
    public function setInvoiceDate(\StructType\Field $invoiceDate = null)
    {
        $this->InvoiceDate = $invoiceDate;
        return $this;
    }
    /**
     * Get InvoiceStatus value
     * @return \StructType\Field|null
     */
    public function getInvoiceStatus()
    {
        return $this->InvoiceStatus;
    }
    /**
     * Set InvoiceStatus value
     * @param \StructType\Field $invoiceStatus
     * @return \StructType\ChildOrders
     */
    public function setInvoiceStatus(\StructType\Field $invoiceStatus = null)
    {
        $this->InvoiceStatus = $invoiceStatus;
        return $this;
    }
    /**
     * Get ServiceCommands value
     * @return \StructType\ChildOrdersServiceCommands|null
     */
    public function getServiceCommands()
    {
        return $this->ServiceCommands;
    }
    /**
     * Set ServiceCommands value
     * @param \StructType\ChildOrdersServiceCommands $serviceCommands
     * @return \StructType\ChildOrders
     */
    public function setServiceCommands(\StructType\ChildOrdersServiceCommands $serviceCommands = null)
    {
        $this->ServiceCommands = $serviceCommands;
        return $this;
    }
}
