<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Commissions StructType
 * @subpackage Structs
 */
class Commissions extends AbstractStructBase
{
    /**
     * The DisplayName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DisplayName;
    /**
     * The SalespersonID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $SalespersonID;
    /**
     * The Commission
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $Commission;
    /**
     * The CommissionAmt
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $CommissionAmt;
    /**
     * The CommissionableAmount
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $CommissionableAmount;
    /**
     * The ServiceCommands
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\CommissionsServiceCommands
     */
    public $ServiceCommands;
    /**
     * Constructor method for Commissions
     * @uses Commissions::setDisplayName()
     * @uses Commissions::setSalespersonID()
     * @uses Commissions::setCommission()
     * @uses Commissions::setCommissionAmt()
     * @uses Commissions::setCommissionableAmount()
     * @uses Commissions::setServiceCommands()
     * @param string $displayName
     * @param \StructType\Field $salespersonID
     * @param \StructType\Field $commission
     * @param \StructType\Field $commissionAmt
     * @param \StructType\Field $commissionableAmount
     * @param \StructType\CommissionsServiceCommands $serviceCommands
     */
    public function __construct($displayName = null, \StructType\Field $salespersonID = null, \StructType\Field $commission = null, \StructType\Field $commissionAmt = null, \StructType\Field $commissionableAmount = null, \StructType\CommissionsServiceCommands $serviceCommands = null)
    {
        $this
            ->setDisplayName($displayName)
            ->setSalespersonID($salespersonID)
            ->setCommission($commission)
            ->setCommissionAmt($commissionAmt)
            ->setCommissionableAmount($commissionableAmount)
            ->setServiceCommands($serviceCommands);
    }
    /**
     * Get DisplayName value
     * @return string|null
     */
    public function getDisplayName()
    {
        return $this->DisplayName;
    }
    /**
     * Set DisplayName value
     * @param string $displayName
     * @return \StructType\Commissions
     */
    public function setDisplayName($displayName = null)
    {
        // validation for constraint: string
        if (!is_null($displayName) && !is_string($displayName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($displayName, true), gettype($displayName)), __LINE__);
        }
        $this->DisplayName = $displayName;
        return $this;
    }
    /**
     * Get SalespersonID value
     * @return \StructType\Field|null
     */
    public function getSalespersonID()
    {
        return $this->SalespersonID;
    }
    /**
     * Set SalespersonID value
     * @param \StructType\Field $salespersonID
     * @return \StructType\Commissions
     */
    public function setSalespersonID(\StructType\Field $salespersonID = null)
    {
        $this->SalespersonID = $salespersonID;
        return $this;
    }
    /**
     * Get Commission value
     * @return \StructType\Field|null
     */
    public function getCommission()
    {
        return $this->Commission;
    }
    /**
     * Set Commission value
     * @param \StructType\Field $commission
     * @return \StructType\Commissions
     */
    public function setCommission(\StructType\Field $commission = null)
    {
        $this->Commission = $commission;
        return $this;
    }
    /**
     * Get CommissionAmt value
     * @return \StructType\Field|null
     */
    public function getCommissionAmt()
    {
        return $this->CommissionAmt;
    }
    /**
     * Set CommissionAmt value
     * @param \StructType\Field $commissionAmt
     * @return \StructType\Commissions
     */
    public function setCommissionAmt(\StructType\Field $commissionAmt = null)
    {
        $this->CommissionAmt = $commissionAmt;
        return $this;
    }
    /**
     * Get CommissionableAmount value
     * @return \StructType\Field|null
     */
    public function getCommissionableAmount()
    {
        return $this->CommissionableAmount;
    }
    /**
     * Set CommissionableAmount value
     * @param \StructType\Field $commissionableAmount
     * @return \StructType\Commissions
     */
    public function setCommissionableAmount(\StructType\Field $commissionableAmount = null)
    {
        $this->CommissionableAmount = $commissionableAmount;
        return $this;
    }
    /**
     * Get ServiceCommands value
     * @return \StructType\CommissionsServiceCommands|null
     */
    public function getServiceCommands()
    {
        return $this->ServiceCommands;
    }
    /**
     * Set ServiceCommands value
     * @param \StructType\CommissionsServiceCommands $serviceCommands
     * @return \StructType\Commissions
     */
    public function setServiceCommands(\StructType\CommissionsServiceCommands $serviceCommands = null)
    {
        $this->ServiceCommands = $serviceCommands;
        return $this;
    }
}
