<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FinancialFinancialInformation StructType
 * @subpackage Structs
 */
class FinancialFinancialInformation extends AbstractStructBase
{
    /**
     * The DisplayName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DisplayName;
    /**
     * The Branch
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $Branch;
    /**
     * The BaseCurrency
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $BaseCurrency;
    /**
     * The OverrideTaxZone
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $OverrideTaxZone;
    /**
     * The CustomerTaxZone
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $CustomerTaxZone;
    /**
     * The TaxCalculationMode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $TaxCalculationMode;
    /**
     * The TaxExemptionNumber
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $TaxExemptionNumber;
    /**
     * The EntityUsageType
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $EntityUsageType;
    /**
     * The BillSeparately
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $BillSeparately;
    /**
     * The InvoiceNbr
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $InvoiceNbr;
    /**
     * The InvoiceDate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $InvoiceDate;
    /**
     * The Terms
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $Terms;
    /**
     * The DueDate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $DueDate;
    /**
     * The CashDiscountDate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $CashDiscountDate;
    /**
     * The PostPeriod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $PostPeriod;
    /**
     * The ServiceCommands
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\FinancialFinancialInformationServiceCommands
     */
    public $ServiceCommands;
    /**
     * Constructor method for FinancialFinancialInformation
     * @uses FinancialFinancialInformation::setDisplayName()
     * @uses FinancialFinancialInformation::setBranch()
     * @uses FinancialFinancialInformation::setBaseCurrency()
     * @uses FinancialFinancialInformation::setOverrideTaxZone()
     * @uses FinancialFinancialInformation::setCustomerTaxZone()
     * @uses FinancialFinancialInformation::setTaxCalculationMode()
     * @uses FinancialFinancialInformation::setTaxExemptionNumber()
     * @uses FinancialFinancialInformation::setEntityUsageType()
     * @uses FinancialFinancialInformation::setBillSeparately()
     * @uses FinancialFinancialInformation::setInvoiceNbr()
     * @uses FinancialFinancialInformation::setInvoiceDate()
     * @uses FinancialFinancialInformation::setTerms()
     * @uses FinancialFinancialInformation::setDueDate()
     * @uses FinancialFinancialInformation::setCashDiscountDate()
     * @uses FinancialFinancialInformation::setPostPeriod()
     * @uses FinancialFinancialInformation::setServiceCommands()
     * @param string $displayName
     * @param \StructType\Field $branch
     * @param \StructType\Field $baseCurrency
     * @param \StructType\Field $overrideTaxZone
     * @param \StructType\Field $customerTaxZone
     * @param \StructType\Field $taxCalculationMode
     * @param \StructType\Field $taxExemptionNumber
     * @param \StructType\Field $entityUsageType
     * @param \StructType\Field $billSeparately
     * @param \StructType\Field $invoiceNbr
     * @param \StructType\Field $invoiceDate
     * @param \StructType\Field $terms
     * @param \StructType\Field $dueDate
     * @param \StructType\Field $cashDiscountDate
     * @param \StructType\Field $postPeriod
     * @param \StructType\FinancialFinancialInformationServiceCommands $serviceCommands
     */
    public function __construct($displayName = null, \StructType\Field $branch = null, \StructType\Field $baseCurrency = null, \StructType\Field $overrideTaxZone = null, \StructType\Field $customerTaxZone = null, \StructType\Field $taxCalculationMode = null, \StructType\Field $taxExemptionNumber = null, \StructType\Field $entityUsageType = null, \StructType\Field $billSeparately = null, \StructType\Field $invoiceNbr = null, \StructType\Field $invoiceDate = null, \StructType\Field $terms = null, \StructType\Field $dueDate = null, \StructType\Field $cashDiscountDate = null, \StructType\Field $postPeriod = null, \StructType\FinancialFinancialInformationServiceCommands $serviceCommands = null)
    {
        $this
            ->setDisplayName($displayName)
            ->setBranch($branch)
            ->setBaseCurrency($baseCurrency)
            ->setOverrideTaxZone($overrideTaxZone)
            ->setCustomerTaxZone($customerTaxZone)
            ->setTaxCalculationMode($taxCalculationMode)
            ->setTaxExemptionNumber($taxExemptionNumber)
            ->setEntityUsageType($entityUsageType)
            ->setBillSeparately($billSeparately)
            ->setInvoiceNbr($invoiceNbr)
            ->setInvoiceDate($invoiceDate)
            ->setTerms($terms)
            ->setDueDate($dueDate)
            ->setCashDiscountDate($cashDiscountDate)
            ->setPostPeriod($postPeriod)
            ->setServiceCommands($serviceCommands);
    }
    /**
     * Get DisplayName value
     * @return string|null
     */
    public function getDisplayName()
    {
        return $this->DisplayName;
    }
    /**
     * Set DisplayName value
     * @param string $displayName
     * @return \StructType\FinancialFinancialInformation
     */
    public function setDisplayName($displayName = null)
    {
        // validation for constraint: string
        if (!is_null($displayName) && !is_string($displayName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($displayName, true), gettype($displayName)), __LINE__);
        }
        $this->DisplayName = $displayName;
        return $this;
    }
    /**
     * Get Branch value
     * @return \StructType\Field|null
     */
    public function getBranch()
    {
        return $this->Branch;
    }
    /**
     * Set Branch value
     * @param \StructType\Field $branch
     * @return \StructType\FinancialFinancialInformation
     */
    public function setBranch(\StructType\Field $branch = null)
    {
        $this->Branch = $branch;
        return $this;
    }
    /**
     * Get BaseCurrency value
     * @return \StructType\Field|null
     */
    public function getBaseCurrency()
    {
        return $this->BaseCurrency;
    }
    /**
     * Set BaseCurrency value
     * @param \StructType\Field $baseCurrency
     * @return \StructType\FinancialFinancialInformation
     */
    public function setBaseCurrency(\StructType\Field $baseCurrency = null)
    {
        $this->BaseCurrency = $baseCurrency;
        return $this;
    }
    /**
     * Get OverrideTaxZone value
     * @return \StructType\Field|null
     */
    public function getOverrideTaxZone()
    {
        return $this->OverrideTaxZone;
    }
    /**
     * Set OverrideTaxZone value
     * @param \StructType\Field $overrideTaxZone
     * @return \StructType\FinancialFinancialInformation
     */
    public function setOverrideTaxZone(\StructType\Field $overrideTaxZone = null)
    {
        $this->OverrideTaxZone = $overrideTaxZone;
        return $this;
    }
    /**
     * Get CustomerTaxZone value
     * @return \StructType\Field|null
     */
    public function getCustomerTaxZone()
    {
        return $this->CustomerTaxZone;
    }
    /**
     * Set CustomerTaxZone value
     * @param \StructType\Field $customerTaxZone
     * @return \StructType\FinancialFinancialInformation
     */
    public function setCustomerTaxZone(\StructType\Field $customerTaxZone = null)
    {
        $this->CustomerTaxZone = $customerTaxZone;
        return $this;
    }
    /**
     * Get TaxCalculationMode value
     * @return \StructType\Field|null
     */
    public function getTaxCalculationMode()
    {
        return $this->TaxCalculationMode;
    }
    /**
     * Set TaxCalculationMode value
     * @param \StructType\Field $taxCalculationMode
     * @return \StructType\FinancialFinancialInformation
     */
    public function setTaxCalculationMode(\StructType\Field $taxCalculationMode = null)
    {
        $this->TaxCalculationMode = $taxCalculationMode;
        return $this;
    }
    /**
     * Get TaxExemptionNumber value
     * @return \StructType\Field|null
     */
    public function getTaxExemptionNumber()
    {
        return $this->TaxExemptionNumber;
    }
    /**
     * Set TaxExemptionNumber value
     * @param \StructType\Field $taxExemptionNumber
     * @return \StructType\FinancialFinancialInformation
     */
    public function setTaxExemptionNumber(\StructType\Field $taxExemptionNumber = null)
    {
        $this->TaxExemptionNumber = $taxExemptionNumber;
        return $this;
    }
    /**
     * Get EntityUsageType value
     * @return \StructType\Field|null
     */
    public function getEntityUsageType()
    {
        return $this->EntityUsageType;
    }
    /**
     * Set EntityUsageType value
     * @param \StructType\Field $entityUsageType
     * @return \StructType\FinancialFinancialInformation
     */
    public function setEntityUsageType(\StructType\Field $entityUsageType = null)
    {
        $this->EntityUsageType = $entityUsageType;
        return $this;
    }
    /**
     * Get BillSeparately value
     * @return \StructType\Field|null
     */
    public function getBillSeparately()
    {
        return $this->BillSeparately;
    }
    /**
     * Set BillSeparately value
     * @param \StructType\Field $billSeparately
     * @return \StructType\FinancialFinancialInformation
     */
    public function setBillSeparately(\StructType\Field $billSeparately = null)
    {
        $this->BillSeparately = $billSeparately;
        return $this;
    }
    /**
     * Get InvoiceNbr value
     * @return \StructType\Field|null
     */
    public function getInvoiceNbr()
    {
        return $this->InvoiceNbr;
    }
    /**
     * Set InvoiceNbr value
     * @param \StructType\Field $invoiceNbr
     * @return \StructType\FinancialFinancialInformation
     */
    public function setInvoiceNbr(\StructType\Field $invoiceNbr = null)
    {
        $this->InvoiceNbr = $invoiceNbr;
        return $this;
    }
    /**
     * Get InvoiceDate value
     * @return \StructType\Field|null
     */
    public function getInvoiceDate()
    {
        return $this->InvoiceDate;
    }
    /**
     * Set InvoiceDate value
     * @param \StructType\Field $invoiceDate
     * @return \StructType\FinancialFinancialInformation
     */
    public function setInvoiceDate(\StructType\Field $invoiceDate = null)
    {
        $this->InvoiceDate = $invoiceDate;
        return $this;
    }
    /**
     * Get Terms value
     * @return \StructType\Field|null
     */
    public function getTerms()
    {
        return $this->Terms;
    }
    /**
     * Set Terms value
     * @param \StructType\Field $terms
     * @return \StructType\FinancialFinancialInformation
     */
    public function setTerms(\StructType\Field $terms = null)
    {
        $this->Terms = $terms;
        return $this;
    }
    /**
     * Get DueDate value
     * @return \StructType\Field|null
     */
    public function getDueDate()
    {
        return $this->DueDate;
    }
    /**
     * Set DueDate value
     * @param \StructType\Field $dueDate
     * @return \StructType\FinancialFinancialInformation
     */
    public function setDueDate(\StructType\Field $dueDate = null)
    {
        $this->DueDate = $dueDate;
        return $this;
    }
    /**
     * Get CashDiscountDate value
     * @return \StructType\Field|null
     */
    public function getCashDiscountDate()
    {
        return $this->CashDiscountDate;
    }
    /**
     * Set CashDiscountDate value
     * @param \StructType\Field $cashDiscountDate
     * @return \StructType\FinancialFinancialInformation
     */
    public function setCashDiscountDate(\StructType\Field $cashDiscountDate = null)
    {
        $this->CashDiscountDate = $cashDiscountDate;
        return $this;
    }
    /**
     * Get PostPeriod value
     * @return \StructType\Field|null
     */
    public function getPostPeriod()
    {
        return $this->PostPeriod;
    }
    /**
     * Set PostPeriod value
     * @param \StructType\Field $postPeriod
     * @return \StructType\FinancialFinancialInformation
     */
    public function setPostPeriod(\StructType\Field $postPeriod = null)
    {
        $this->PostPeriod = $postPeriod;
        return $this;
    }
    /**
     * Get ServiceCommands value
     * @return \StructType\FinancialFinancialInformationServiceCommands|null
     */
    public function getServiceCommands()
    {
        return $this->ServiceCommands;
    }
    /**
     * Set ServiceCommands value
     * @param \StructType\FinancialFinancialInformationServiceCommands $serviceCommands
     * @return \StructType\FinancialFinancialInformation
     */
    public function setServiceCommands(\StructType\FinancialFinancialInformationServiceCommands $serviceCommands = null)
    {
        $this->ServiceCommands = $serviceCommands;
        return $this;
    }
}
