<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for InventoryLookupInventory StructType
 * @subpackage Structs
 */
class InventoryLookupInventory extends AbstractStructBase
{
    /**
     * The DisplayName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DisplayName;
    /**
     * The Inventory
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $Inventory;
    /**
     * The BarCode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $BarCode;
    /**
     * The SiteID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $SiteID;
    /**
     * The ItemClass
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $ItemClass;
    /**
     * The SubItem
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $SubItem;
    /**
     * The ServiceCommands
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\InventoryLookupInventoryServiceCommands
     */
    public $ServiceCommands;
    /**
     * Constructor method for InventoryLookupInventory
     * @uses InventoryLookupInventory::setDisplayName()
     * @uses InventoryLookupInventory::setInventory()
     * @uses InventoryLookupInventory::setBarCode()
     * @uses InventoryLookupInventory::setSiteID()
     * @uses InventoryLookupInventory::setItemClass()
     * @uses InventoryLookupInventory::setSubItem()
     * @uses InventoryLookupInventory::setServiceCommands()
     * @param string $displayName
     * @param \StructType\Field $inventory
     * @param \StructType\Field $barCode
     * @param \StructType\Field $siteID
     * @param \StructType\Field $itemClass
     * @param \StructType\Field $subItem
     * @param \StructType\InventoryLookupInventoryServiceCommands $serviceCommands
     */
    public function __construct($displayName = null, \StructType\Field $inventory = null, \StructType\Field $barCode = null, \StructType\Field $siteID = null, \StructType\Field $itemClass = null, \StructType\Field $subItem = null, \StructType\InventoryLookupInventoryServiceCommands $serviceCommands = null)
    {
        $this
            ->setDisplayName($displayName)
            ->setInventory($inventory)
            ->setBarCode($barCode)
            ->setSiteID($siteID)
            ->setItemClass($itemClass)
            ->setSubItem($subItem)
            ->setServiceCommands($serviceCommands);
    }
    /**
     * Get DisplayName value
     * @return string|null
     */
    public function getDisplayName()
    {
        return $this->DisplayName;
    }
    /**
     * Set DisplayName value
     * @param string $displayName
     * @return \StructType\InventoryLookupInventory
     */
    public function setDisplayName($displayName = null)
    {
        // validation for constraint: string
        if (!is_null($displayName) && !is_string($displayName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($displayName, true), gettype($displayName)), __LINE__);
        }
        $this->DisplayName = $displayName;
        return $this;
    }
    /**
     * Get Inventory value
     * @return \StructType\Field|null
     */
    public function getInventory()
    {
        return $this->Inventory;
    }
    /**
     * Set Inventory value
     * @param \StructType\Field $inventory
     * @return \StructType\InventoryLookupInventory
     */
    public function setInventory(\StructType\Field $inventory = null)
    {
        $this->Inventory = $inventory;
        return $this;
    }
    /**
     * Get BarCode value
     * @return \StructType\Field|null
     */
    public function getBarCode()
    {
        return $this->BarCode;
    }
    /**
     * Set BarCode value
     * @param \StructType\Field $barCode
     * @return \StructType\InventoryLookupInventory
     */
    public function setBarCode(\StructType\Field $barCode = null)
    {
        $this->BarCode = $barCode;
        return $this;
    }
    /**
     * Get SiteID value
     * @return \StructType\Field|null
     */
    public function getSiteID()
    {
        return $this->SiteID;
    }
    /**
     * Set SiteID value
     * @param \StructType\Field $siteID
     * @return \StructType\InventoryLookupInventory
     */
    public function setSiteID(\StructType\Field $siteID = null)
    {
        $this->SiteID = $siteID;
        return $this;
    }
    /**
     * Get ItemClass value
     * @return \StructType\Field|null
     */
    public function getItemClass()
    {
        return $this->ItemClass;
    }
    /**
     * Set ItemClass value
     * @param \StructType\Field $itemClass
     * @return \StructType\InventoryLookupInventory
     */
    public function setItemClass(\StructType\Field $itemClass = null)
    {
        $this->ItemClass = $itemClass;
        return $this;
    }
    /**
     * Get SubItem value
     * @return \StructType\Field|null
     */
    public function getSubItem()
    {
        return $this->SubItem;
    }
    /**
     * Set SubItem value
     * @param \StructType\Field $subItem
     * @return \StructType\InventoryLookupInventory
     */
    public function setSubItem(\StructType\Field $subItem = null)
    {
        $this->SubItem = $subItem;
        return $this;
    }
    /**
     * Get ServiceCommands value
     * @return \StructType\InventoryLookupInventoryServiceCommands|null
     */
    public function getServiceCommands()
    {
        return $this->ServiceCommands;
    }
    /**
     * Set ServiceCommands value
     * @param \StructType\InventoryLookupInventoryServiceCommands $serviceCommands
     * @return \StructType\InventoryLookupInventory
     */
    public function setServiceCommands(\StructType\InventoryLookupInventoryServiceCommands $serviceCommands = null)
    {
        $this->ServiceCommands = $serviceCommands;
        return $this;
    }
}
