<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for InventoryLookupSelectedMode StructType
 * @subpackage Structs
 */
class InventoryLookupSelectedMode extends AbstractStructBase
{
    /**
     * The DisplayName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DisplayName;
    /**
     * The Mode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $Mode;
    /**
     * The HistoryDate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $HistoryDate;
    /**
     * The OnlyAvailable
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $OnlyAvailable;
    /**
     * The DropShipSales
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $DropShipSales;
    /**
     * The ServiceCommands
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\InventoryLookupSelectedModeServiceCommands
     */
    public $ServiceCommands;
    /**
     * Constructor method for InventoryLookupSelectedMode
     * @uses InventoryLookupSelectedMode::setDisplayName()
     * @uses InventoryLookupSelectedMode::setMode()
     * @uses InventoryLookupSelectedMode::setHistoryDate()
     * @uses InventoryLookupSelectedMode::setOnlyAvailable()
     * @uses InventoryLookupSelectedMode::setDropShipSales()
     * @uses InventoryLookupSelectedMode::setServiceCommands()
     * @param string $displayName
     * @param \StructType\Field $mode
     * @param \StructType\Field $historyDate
     * @param \StructType\Field $onlyAvailable
     * @param \StructType\Field $dropShipSales
     * @param \StructType\InventoryLookupSelectedModeServiceCommands $serviceCommands
     */
    public function __construct($displayName = null, \StructType\Field $mode = null, \StructType\Field $historyDate = null, \StructType\Field $onlyAvailable = null, \StructType\Field $dropShipSales = null, \StructType\InventoryLookupSelectedModeServiceCommands $serviceCommands = null)
    {
        $this
            ->setDisplayName($displayName)
            ->setMode($mode)
            ->setHistoryDate($historyDate)
            ->setOnlyAvailable($onlyAvailable)
            ->setDropShipSales($dropShipSales)
            ->setServiceCommands($serviceCommands);
    }
    /**
     * Get DisplayName value
     * @return string|null
     */
    public function getDisplayName()
    {
        return $this->DisplayName;
    }
    /**
     * Set DisplayName value
     * @param string $displayName
     * @return \StructType\InventoryLookupSelectedMode
     */
    public function setDisplayName($displayName = null)
    {
        // validation for constraint: string
        if (!is_null($displayName) && !is_string($displayName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($displayName, true), gettype($displayName)), __LINE__);
        }
        $this->DisplayName = $displayName;
        return $this;
    }
    /**
     * Get Mode value
     * @return \StructType\Field|null
     */
    public function getMode()
    {
        return $this->Mode;
    }
    /**
     * Set Mode value
     * @param \StructType\Field $mode
     * @return \StructType\InventoryLookupSelectedMode
     */
    public function setMode(\StructType\Field $mode = null)
    {
        $this->Mode = $mode;
        return $this;
    }
    /**
     * Get HistoryDate value
     * @return \StructType\Field|null
     */
    public function getHistoryDate()
    {
        return $this->HistoryDate;
    }
    /**
     * Set HistoryDate value
     * @param \StructType\Field $historyDate
     * @return \StructType\InventoryLookupSelectedMode
     */
    public function setHistoryDate(\StructType\Field $historyDate = null)
    {
        $this->HistoryDate = $historyDate;
        return $this;
    }
    /**
     * Get OnlyAvailable value
     * @return \StructType\Field|null
     */
    public function getOnlyAvailable()
    {
        return $this->OnlyAvailable;
    }
    /**
     * Set OnlyAvailable value
     * @param \StructType\Field $onlyAvailable
     * @return \StructType\InventoryLookupSelectedMode
     */
    public function setOnlyAvailable(\StructType\Field $onlyAvailable = null)
    {
        $this->OnlyAvailable = $onlyAvailable;
        return $this;
    }
    /**
     * Get DropShipSales value
     * @return \StructType\Field|null
     */
    public function getDropShipSales()
    {
        return $this->DropShipSales;
    }
    /**
     * Set DropShipSales value
     * @param \StructType\Field $dropShipSales
     * @return \StructType\InventoryLookupSelectedMode
     */
    public function setDropShipSales(\StructType\Field $dropShipSales = null)
    {
        $this->DropShipSales = $dropShipSales;
        return $this;
    }
    /**
     * Get ServiceCommands value
     * @return \StructType\InventoryLookupSelectedModeServiceCommands|null
     */
    public function getServiceCommands()
    {
        return $this->ServiceCommands;
    }
    /**
     * Set ServiceCommands value
     * @param \StructType\InventoryLookupSelectedModeServiceCommands $serviceCommands
     * @return \StructType\InventoryLookupSelectedMode
     */
    public function setServiceCommands(\StructType\InventoryLookupSelectedModeServiceCommands $serviceCommands = null)
    {
        $this->ServiceCommands = $serviceCommands;
        return $this;
    }
}
