<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for InventoryLookupShippingParametersToApply StructType
 * @subpackage Structs
 */
class InventoryLookupShippingParametersToApply extends AbstractStructBase
{
    /**
     * The DisplayName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DisplayName;
    /**
     * The CustomerLocationID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $CustomerLocationID;
    /**
     * The ServiceCommands
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\InventoryLookupShippingParametersToApplyServiceCommands
     */
    public $ServiceCommands;
    /**
     * Constructor method for InventoryLookupShippingParametersToApply
     * @uses InventoryLookupShippingParametersToApply::setDisplayName()
     * @uses InventoryLookupShippingParametersToApply::setCustomerLocationID()
     * @uses InventoryLookupShippingParametersToApply::setServiceCommands()
     * @param string $displayName
     * @param \StructType\Field $customerLocationID
     * @param \StructType\InventoryLookupShippingParametersToApplyServiceCommands $serviceCommands
     */
    public function __construct($displayName = null, \StructType\Field $customerLocationID = null, \StructType\InventoryLookupShippingParametersToApplyServiceCommands $serviceCommands = null)
    {
        $this
            ->setDisplayName($displayName)
            ->setCustomerLocationID($customerLocationID)
            ->setServiceCommands($serviceCommands);
    }
    /**
     * Get DisplayName value
     * @return string|null
     */
    public function getDisplayName()
    {
        return $this->DisplayName;
    }
    /**
     * Set DisplayName value
     * @param string $displayName
     * @return \StructType\InventoryLookupShippingParametersToApply
     */
    public function setDisplayName($displayName = null)
    {
        // validation for constraint: string
        if (!is_null($displayName) && !is_string($displayName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($displayName, true), gettype($displayName)), __LINE__);
        }
        $this->DisplayName = $displayName;
        return $this;
    }
    /**
     * Get CustomerLocationID value
     * @return \StructType\Field|null
     */
    public function getCustomerLocationID()
    {
        return $this->CustomerLocationID;
    }
    /**
     * Set CustomerLocationID value
     * @param \StructType\Field $customerLocationID
     * @return \StructType\InventoryLookupShippingParametersToApply
     */
    public function setCustomerLocationID(\StructType\Field $customerLocationID = null)
    {
        $this->CustomerLocationID = $customerLocationID;
        return $this;
    }
    /**
     * Get ServiceCommands value
     * @return \StructType\InventoryLookupShippingParametersToApplyServiceCommands|null
     */
    public function getServiceCommands()
    {
        return $this->ServiceCommands;
    }
    /**
     * Set ServiceCommands value
     * @param \StructType\InventoryLookupShippingParametersToApplyServiceCommands $serviceCommands
     * @return \StructType\InventoryLookupShippingParametersToApply
     */
    public function setServiceCommands(\StructType\InventoryLookupShippingParametersToApplyServiceCommands $serviceCommands = null)
    {
        $this->ServiceCommands = $serviceCommands;
        return $this;
    }
}
