<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OrderSummaryRateSelection StructType
 * @subpackage Structs
 */
class OrderSummaryRateSelection extends AbstractStructBase
{
    /**
     * The DisplayName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DisplayName;
    /**
     * The CurrRateTypeID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $CurrRateTypeID;
    /**
     * The EffectiveDate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $EffectiveDate;
    /**
     * The ServiceCommands
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\OrderSummaryRateSelectionServiceCommands
     */
    public $ServiceCommands;
    /**
     * Constructor method for OrderSummaryRateSelection
     * @uses OrderSummaryRateSelection::setDisplayName()
     * @uses OrderSummaryRateSelection::setCurrRateTypeID()
     * @uses OrderSummaryRateSelection::setEffectiveDate()
     * @uses OrderSummaryRateSelection::setServiceCommands()
     * @param string $displayName
     * @param \StructType\Field $currRateTypeID
     * @param \StructType\Field $effectiveDate
     * @param \StructType\OrderSummaryRateSelectionServiceCommands $serviceCommands
     */
    public function __construct($displayName = null, \StructType\Field $currRateTypeID = null, \StructType\Field $effectiveDate = null, \StructType\OrderSummaryRateSelectionServiceCommands $serviceCommands = null)
    {
        $this
            ->setDisplayName($displayName)
            ->setCurrRateTypeID($currRateTypeID)
            ->setEffectiveDate($effectiveDate)
            ->setServiceCommands($serviceCommands);
    }
    /**
     * Get DisplayName value
     * @return string|null
     */
    public function getDisplayName()
    {
        return $this->DisplayName;
    }
    /**
     * Set DisplayName value
     * @param string $displayName
     * @return \StructType\OrderSummaryRateSelection
     */
    public function setDisplayName($displayName = null)
    {
        // validation for constraint: string
        if (!is_null($displayName) && !is_string($displayName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($displayName, true), gettype($displayName)), __LINE__);
        }
        $this->DisplayName = $displayName;
        return $this;
    }
    /**
     * Get CurrRateTypeID value
     * @return \StructType\Field|null
     */
    public function getCurrRateTypeID()
    {
        return $this->CurrRateTypeID;
    }
    /**
     * Set CurrRateTypeID value
     * @param \StructType\Field $currRateTypeID
     * @return \StructType\OrderSummaryRateSelection
     */
    public function setCurrRateTypeID(\StructType\Field $currRateTypeID = null)
    {
        $this->CurrRateTypeID = $currRateTypeID;
        return $this;
    }
    /**
     * Get EffectiveDate value
     * @return \StructType\Field|null
     */
    public function getEffectiveDate()
    {
        return $this->EffectiveDate;
    }
    /**
     * Set EffectiveDate value
     * @param \StructType\Field $effectiveDate
     * @return \StructType\OrderSummaryRateSelection
     */
    public function setEffectiveDate(\StructType\Field $effectiveDate = null)
    {
        $this->EffectiveDate = $effectiveDate;
        return $this;
    }
    /**
     * Get ServiceCommands value
     * @return \StructType\OrderSummaryRateSelectionServiceCommands|null
     */
    public function getServiceCommands()
    {
        return $this->ServiceCommands;
    }
    /**
     * Set ServiceCommands value
     * @param \StructType\OrderSummaryRateSelectionServiceCommands $serviceCommands
     * @return \StructType\OrderSummaryRateSelection
     */
    public function setServiceCommands(\StructType\OrderSummaryRateSelectionServiceCommands $serviceCommands = null)
    {
        $this->ServiceCommands = $serviceCommands;
        return $this;
    }
}
