<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OrderSummaryRateSelectionCurrencyUnitEquivalents
 * StructType
 * @subpackage Structs
 */
class OrderSummaryRateSelectionCurrencyUnitEquivalents extends AbstractStructBase
{
    /**
     * The DisplayName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DisplayName;
    /**
     * The CurrencyID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $CurrencyID;
    /**
     * The CurrRate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $CurrRate;
    /**
     * The BaseCurrencyID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $BaseCurrencyID;
    /**
     * The ReciprocalRate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $ReciprocalRate;
    /**
     * The ServiceCommands
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\OrderSummaryRateSelectionCurrencyUnitEquivalentsServiceCommands
     */
    public $ServiceCommands;
    /**
     * Constructor method for OrderSummaryRateSelectionCurrencyUnitEquivalents
     * @uses OrderSummaryRateSelectionCurrencyUnitEquivalents::setDisplayName()
     * @uses OrderSummaryRateSelectionCurrencyUnitEquivalents::setCurrencyID()
     * @uses OrderSummaryRateSelectionCurrencyUnitEquivalents::setCurrRate()
     * @uses OrderSummaryRateSelectionCurrencyUnitEquivalents::setBaseCurrencyID()
     * @uses OrderSummaryRateSelectionCurrencyUnitEquivalents::setReciprocalRate()
     * @uses OrderSummaryRateSelectionCurrencyUnitEquivalents::setServiceCommands()
     * @param string $displayName
     * @param \StructType\Field $currencyID
     * @param \StructType\Field $currRate
     * @param \StructType\Field $baseCurrencyID
     * @param \StructType\Field $reciprocalRate
     * @param \StructType\OrderSummaryRateSelectionCurrencyUnitEquivalentsServiceCommands $serviceCommands
     */
    public function __construct($displayName = null, \StructType\Field $currencyID = null, \StructType\Field $currRate = null, \StructType\Field $baseCurrencyID = null, \StructType\Field $reciprocalRate = null, \StructType\OrderSummaryRateSelectionCurrencyUnitEquivalentsServiceCommands $serviceCommands = null)
    {
        $this
            ->setDisplayName($displayName)
            ->setCurrencyID($currencyID)
            ->setCurrRate($currRate)
            ->setBaseCurrencyID($baseCurrencyID)
            ->setReciprocalRate($reciprocalRate)
            ->setServiceCommands($serviceCommands);
    }
    /**
     * Get DisplayName value
     * @return string|null
     */
    public function getDisplayName()
    {
        return $this->DisplayName;
    }
    /**
     * Set DisplayName value
     * @param string $displayName
     * @return \StructType\OrderSummaryRateSelectionCurrencyUnitEquivalents
     */
    public function setDisplayName($displayName = null)
    {
        // validation for constraint: string
        if (!is_null($displayName) && !is_string($displayName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($displayName, true), gettype($displayName)), __LINE__);
        }
        $this->DisplayName = $displayName;
        return $this;
    }
    /**
     * Get CurrencyID value
     * @return \StructType\Field|null
     */
    public function getCurrencyID()
    {
        return $this->CurrencyID;
    }
    /**
     * Set CurrencyID value
     * @param \StructType\Field $currencyID
     * @return \StructType\OrderSummaryRateSelectionCurrencyUnitEquivalents
     */
    public function setCurrencyID(\StructType\Field $currencyID = null)
    {
        $this->CurrencyID = $currencyID;
        return $this;
    }
    /**
     * Get CurrRate value
     * @return \StructType\Field|null
     */
    public function getCurrRate()
    {
        return $this->CurrRate;
    }
    /**
     * Set CurrRate value
     * @param \StructType\Field $currRate
     * @return \StructType\OrderSummaryRateSelectionCurrencyUnitEquivalents
     */
    public function setCurrRate(\StructType\Field $currRate = null)
    {
        $this->CurrRate = $currRate;
        return $this;
    }
    /**
     * Get BaseCurrencyID value
     * @return \StructType\Field|null
     */
    public function getBaseCurrencyID()
    {
        return $this->BaseCurrencyID;
    }
    /**
     * Set BaseCurrencyID value
     * @param \StructType\Field $baseCurrencyID
     * @return \StructType\OrderSummaryRateSelectionCurrencyUnitEquivalents
     */
    public function setBaseCurrencyID(\StructType\Field $baseCurrencyID = null)
    {
        $this->BaseCurrencyID = $baseCurrencyID;
        return $this;
    }
    /**
     * Get ReciprocalRate value
     * @return \StructType\Field|null
     */
    public function getReciprocalRate()
    {
        return $this->ReciprocalRate;
    }
    /**
     * Set ReciprocalRate value
     * @param \StructType\Field $reciprocalRate
     * @return \StructType\OrderSummaryRateSelectionCurrencyUnitEquivalents
     */
    public function setReciprocalRate(\StructType\Field $reciprocalRate = null)
    {
        $this->ReciprocalRate = $reciprocalRate;
        return $this;
    }
    /**
     * Get ServiceCommands value
     * @return \StructType\OrderSummaryRateSelectionCurrencyUnitEquivalentsServiceCommands|null
     */
    public function getServiceCommands()
    {
        return $this->ServiceCommands;
    }
    /**
     * Set ServiceCommands value
     * @param \StructType\OrderSummaryRateSelectionCurrencyUnitEquivalentsServiceCommands $serviceCommands
     * @return \StructType\OrderSummaryRateSelectionCurrencyUnitEquivalents
     */
    public function setServiceCommands(\StructType\OrderSummaryRateSelectionCurrencyUnitEquivalentsServiceCommands $serviceCommands = null)
    {
        $this->ServiceCommands = $serviceCommands;
        return $this;
    }
}
