<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OverrideTaxZone StructType
 * @subpackage Structs
 */
class OverrideTaxZone extends AbstractStructBase
{
    /**
     * The DisplayName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DisplayName;
    /**
     * The CustomerTaxZone
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $CustomerTaxZone;
    /**
     * The ServiceCommands
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\OverrideTaxZoneServiceCommands
     */
    public $ServiceCommands;
    /**
     * Constructor method for OverrideTaxZone
     * @uses OverrideTaxZone::setDisplayName()
     * @uses OverrideTaxZone::setCustomerTaxZone()
     * @uses OverrideTaxZone::setServiceCommands()
     * @param string $displayName
     * @param \StructType\Field $customerTaxZone
     * @param \StructType\OverrideTaxZoneServiceCommands $serviceCommands
     */
    public function __construct($displayName = null, \StructType\Field $customerTaxZone = null, \StructType\OverrideTaxZoneServiceCommands $serviceCommands = null)
    {
        $this
            ->setDisplayName($displayName)
            ->setCustomerTaxZone($customerTaxZone)
            ->setServiceCommands($serviceCommands);
    }
    /**
     * Get DisplayName value
     * @return string|null
     */
    public function getDisplayName()
    {
        return $this->DisplayName;
    }
    /**
     * Set DisplayName value
     * @param string $displayName
     * @return \StructType\OverrideTaxZone
     */
    public function setDisplayName($displayName = null)
    {
        // validation for constraint: string
        if (!is_null($displayName) && !is_string($displayName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($displayName, true), gettype($displayName)), __LINE__);
        }
        $this->DisplayName = $displayName;
        return $this;
    }
    /**
     * Get CustomerTaxZone value
     * @return \StructType\Field|null
     */
    public function getCustomerTaxZone()
    {
        return $this->CustomerTaxZone;
    }
    /**
     * Set CustomerTaxZone value
     * @param \StructType\Field $customerTaxZone
     * @return \StructType\OverrideTaxZone
     */
    public function setCustomerTaxZone(\StructType\Field $customerTaxZone = null)
    {
        $this->CustomerTaxZone = $customerTaxZone;
        return $this;
    }
    /**
     * Get ServiceCommands value
     * @return \StructType\OverrideTaxZoneServiceCommands|null
     */
    public function getServiceCommands()
    {
        return $this->ServiceCommands;
    }
    /**
     * Set ServiceCommands value
     * @param \StructType\OverrideTaxZoneServiceCommands $serviceCommands
     * @return \StructType\OverrideTaxZone
     */
    public function setServiceCommands(\StructType\OverrideTaxZoneServiceCommands $serviceCommands = null)
    {
        $this->ServiceCommands = $serviceCommands;
        return $this;
    }
}
