<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PaymentsPaymentTotal StructType
 * @subpackage Structs
 */
class PaymentsPaymentTotal extends AbstractStructBase
{
    /**
     * The DisplayName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DisplayName;
    /**
     * The NotReleased
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $NotReleased;
    /**
     * The Authorized
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $Authorized;
    /**
     * The Released
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $Released;
    /**
     * The TotalPaid
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $TotalPaid;
    /**
     * The TotalTransferredToInvoices
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $TotalTransferredToInvoices;
    /**
     * The TotalTransferredToChildOrders
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $TotalTransferredToChildOrders;
    /**
     * The UnpaidBalance
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $UnpaidBalance;
    /**
     * The UnbilledBalance
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $UnbilledBalance;
    /**
     * The ServiceCommands
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\PaymentsPaymentTotalServiceCommands
     */
    public $ServiceCommands;
    /**
     * Constructor method for PaymentsPaymentTotal
     * @uses PaymentsPaymentTotal::setDisplayName()
     * @uses PaymentsPaymentTotal::setNotReleased()
     * @uses PaymentsPaymentTotal::setAuthorized()
     * @uses PaymentsPaymentTotal::setReleased()
     * @uses PaymentsPaymentTotal::setTotalPaid()
     * @uses PaymentsPaymentTotal::setTotalTransferredToInvoices()
     * @uses PaymentsPaymentTotal::setTotalTransferredToChildOrders()
     * @uses PaymentsPaymentTotal::setUnpaidBalance()
     * @uses PaymentsPaymentTotal::setUnbilledBalance()
     * @uses PaymentsPaymentTotal::setServiceCommands()
     * @param string $displayName
     * @param \StructType\Field $notReleased
     * @param \StructType\Field $authorized
     * @param \StructType\Field $released
     * @param \StructType\Field $totalPaid
     * @param \StructType\Field $totalTransferredToInvoices
     * @param \StructType\Field $totalTransferredToChildOrders
     * @param \StructType\Field $unpaidBalance
     * @param \StructType\Field $unbilledBalance
     * @param \StructType\PaymentsPaymentTotalServiceCommands $serviceCommands
     */
    public function __construct($displayName = null, \StructType\Field $notReleased = null, \StructType\Field $authorized = null, \StructType\Field $released = null, \StructType\Field $totalPaid = null, \StructType\Field $totalTransferredToInvoices = null, \StructType\Field $totalTransferredToChildOrders = null, \StructType\Field $unpaidBalance = null, \StructType\Field $unbilledBalance = null, \StructType\PaymentsPaymentTotalServiceCommands $serviceCommands = null)
    {
        $this
            ->setDisplayName($displayName)
            ->setNotReleased($notReleased)
            ->setAuthorized($authorized)
            ->setReleased($released)
            ->setTotalPaid($totalPaid)
            ->setTotalTransferredToInvoices($totalTransferredToInvoices)
            ->setTotalTransferredToChildOrders($totalTransferredToChildOrders)
            ->setUnpaidBalance($unpaidBalance)
            ->setUnbilledBalance($unbilledBalance)
            ->setServiceCommands($serviceCommands);
    }
    /**
     * Get DisplayName value
     * @return string|null
     */
    public function getDisplayName()
    {
        return $this->DisplayName;
    }
    /**
     * Set DisplayName value
     * @param string $displayName
     * @return \StructType\PaymentsPaymentTotal
     */
    public function setDisplayName($displayName = null)
    {
        // validation for constraint: string
        if (!is_null($displayName) && !is_string($displayName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($displayName, true), gettype($displayName)), __LINE__);
        }
        $this->DisplayName = $displayName;
        return $this;
    }
    /**
     * Get NotReleased value
     * @return \StructType\Field|null
     */
    public function getNotReleased()
    {
        return $this->NotReleased;
    }
    /**
     * Set NotReleased value
     * @param \StructType\Field $notReleased
     * @return \StructType\PaymentsPaymentTotal
     */
    public function setNotReleased(\StructType\Field $notReleased = null)
    {
        $this->NotReleased = $notReleased;
        return $this;
    }
    /**
     * Get Authorized value
     * @return \StructType\Field|null
     */
    public function getAuthorized()
    {
        return $this->Authorized;
    }
    /**
     * Set Authorized value
     * @param \StructType\Field $authorized
     * @return \StructType\PaymentsPaymentTotal
     */
    public function setAuthorized(\StructType\Field $authorized = null)
    {
        $this->Authorized = $authorized;
        return $this;
    }
    /**
     * Get Released value
     * @return \StructType\Field|null
     */
    public function getReleased()
    {
        return $this->Released;
    }
    /**
     * Set Released value
     * @param \StructType\Field $released
     * @return \StructType\PaymentsPaymentTotal
     */
    public function setReleased(\StructType\Field $released = null)
    {
        $this->Released = $released;
        return $this;
    }
    /**
     * Get TotalPaid value
     * @return \StructType\Field|null
     */
    public function getTotalPaid()
    {
        return $this->TotalPaid;
    }
    /**
     * Set TotalPaid value
     * @param \StructType\Field $totalPaid
     * @return \StructType\PaymentsPaymentTotal
     */
    public function setTotalPaid(\StructType\Field $totalPaid = null)
    {
        $this->TotalPaid = $totalPaid;
        return $this;
    }
    /**
     * Get TotalTransferredToInvoices value
     * @return \StructType\Field|null
     */
    public function getTotalTransferredToInvoices()
    {
        return $this->TotalTransferredToInvoices;
    }
    /**
     * Set TotalTransferredToInvoices value
     * @param \StructType\Field $totalTransferredToInvoices
     * @return \StructType\PaymentsPaymentTotal
     */
    public function setTotalTransferredToInvoices(\StructType\Field $totalTransferredToInvoices = null)
    {
        $this->TotalTransferredToInvoices = $totalTransferredToInvoices;
        return $this;
    }
    /**
     * Get TotalTransferredToChildOrders value
     * @return \StructType\Field|null
     */
    public function getTotalTransferredToChildOrders()
    {
        return $this->TotalTransferredToChildOrders;
    }
    /**
     * Set TotalTransferredToChildOrders value
     * @param \StructType\Field $totalTransferredToChildOrders
     * @return \StructType\PaymentsPaymentTotal
     */
    public function setTotalTransferredToChildOrders(\StructType\Field $totalTransferredToChildOrders = null)
    {
        $this->TotalTransferredToChildOrders = $totalTransferredToChildOrders;
        return $this;
    }
    /**
     * Get UnpaidBalance value
     * @return \StructType\Field|null
     */
    public function getUnpaidBalance()
    {
        return $this->UnpaidBalance;
    }
    /**
     * Set UnpaidBalance value
     * @param \StructType\Field $unpaidBalance
     * @return \StructType\PaymentsPaymentTotal
     */
    public function setUnpaidBalance(\StructType\Field $unpaidBalance = null)
    {
        $this->UnpaidBalance = $unpaidBalance;
        return $this;
    }
    /**
     * Get UnbilledBalance value
     * @return \StructType\Field|null
     */
    public function getUnbilledBalance()
    {
        return $this->UnbilledBalance;
    }
    /**
     * Set UnbilledBalance value
     * @param \StructType\Field $unbilledBalance
     * @return \StructType\PaymentsPaymentTotal
     */
    public function setUnbilledBalance(\StructType\Field $unbilledBalance = null)
    {
        $this->UnbilledBalance = $unbilledBalance;
        return $this;
    }
    /**
     * Get ServiceCommands value
     * @return \StructType\PaymentsPaymentTotalServiceCommands|null
     */
    public function getServiceCommands()
    {
        return $this->ServiceCommands;
    }
    /**
     * Set ServiceCommands value
     * @param \StructType\PaymentsPaymentTotalServiceCommands $serviceCommands
     * @return \StructType\PaymentsPaymentTotal
     */
    public function setServiceCommands(\StructType\PaymentsPaymentTotalServiceCommands $serviceCommands = null)
    {
        $this->ServiceCommands = $serviceCommands;
        return $this;
    }
}
