<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PrimaryKey StructType
 * @subpackage Structs
 */
class PrimaryKey extends AbstractStructBase
{
    /**
     * The OrderType
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Value
     */
    public $OrderType;
    /**
     * The OrderNbr
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Value
     */
    public $OrderNbr;
    /**
     * Constructor method for PrimaryKey
     * @uses PrimaryKey::setOrderType()
     * @uses PrimaryKey::setOrderNbr()
     * @param \StructType\Value $orderType
     * @param \StructType\Value $orderNbr
     */
    public function __construct(\StructType\Value $orderType = null, \StructType\Value $orderNbr = null)
    {
        $this
            ->setOrderType($orderType)
            ->setOrderNbr($orderNbr);
    }
    /**
     * Get OrderType value
     * @return \StructType\Value|null
     */
    public function getOrderType()
    {
        return $this->OrderType;
    }
    /**
     * Set OrderType value
     * @param \StructType\Value $orderType
     * @return \StructType\PrimaryKey
     */
    public function setOrderType(\StructType\Value $orderType = null)
    {
        $this->OrderType = $orderType;
        return $this;
    }
    /**
     * Get OrderNbr value
     * @return \StructType\Value|null
     */
    public function getOrderNbr()
    {
        return $this->OrderNbr;
    }
    /**
     * Set OrderNbr value
     * @param \StructType\Value $orderNbr
     * @return \StructType\PrimaryKey
     */
    public function setOrderNbr(\StructType\Value $orderNbr = null)
    {
        $this->OrderNbr = $orderNbr;
        return $this;
    }
}
