<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ProcessOrderInvoicing StructType
 * @subpackage Structs
 */
class ProcessOrderInvoicing extends AbstractStructBase
{
    /**
     * The DisplayName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DisplayName;
    /**
     * The PrepareInvoicePrepareInvoiceFromShipment
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $PrepareInvoicePrepareInvoiceFromShipment;
    /**
     * The PrepareInvoicePrepareInvoice
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $PrepareInvoicePrepareInvoice;
    /**
     * The PrintInvoice
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $PrintInvoice;
    /**
     * The EmailInvoice
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $EmailInvoice;
    /**
     * The ReleaseInvoice
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $ReleaseInvoice;
    /**
     * The ServiceCommands
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\ProcessOrderInvoicingServiceCommands
     */
    public $ServiceCommands;
    /**
     * Constructor method for ProcessOrderInvoicing
     * @uses ProcessOrderInvoicing::setDisplayName()
     * @uses ProcessOrderInvoicing::setPrepareInvoicePrepareInvoiceFromShipment()
     * @uses ProcessOrderInvoicing::setPrepareInvoicePrepareInvoice()
     * @uses ProcessOrderInvoicing::setPrintInvoice()
     * @uses ProcessOrderInvoicing::setEmailInvoice()
     * @uses ProcessOrderInvoicing::setReleaseInvoice()
     * @uses ProcessOrderInvoicing::setServiceCommands()
     * @param string $displayName
     * @param \StructType\Field $prepareInvoicePrepareInvoiceFromShipment
     * @param \StructType\Field $prepareInvoicePrepareInvoice
     * @param \StructType\Field $printInvoice
     * @param \StructType\Field $emailInvoice
     * @param \StructType\Field $releaseInvoice
     * @param \StructType\ProcessOrderInvoicingServiceCommands $serviceCommands
     */
    public function __construct($displayName = null, \StructType\Field $prepareInvoicePrepareInvoiceFromShipment = null, \StructType\Field $prepareInvoicePrepareInvoice = null, \StructType\Field $printInvoice = null, \StructType\Field $emailInvoice = null, \StructType\Field $releaseInvoice = null, \StructType\ProcessOrderInvoicingServiceCommands $serviceCommands = null)
    {
        $this
            ->setDisplayName($displayName)
            ->setPrepareInvoicePrepareInvoiceFromShipment($prepareInvoicePrepareInvoiceFromShipment)
            ->setPrepareInvoicePrepareInvoice($prepareInvoicePrepareInvoice)
            ->setPrintInvoice($printInvoice)
            ->setEmailInvoice($emailInvoice)
            ->setReleaseInvoice($releaseInvoice)
            ->setServiceCommands($serviceCommands);
    }
    /**
     * Get DisplayName value
     * @return string|null
     */
    public function getDisplayName()
    {
        return $this->DisplayName;
    }
    /**
     * Set DisplayName value
     * @param string $displayName
     * @return \StructType\ProcessOrderInvoicing
     */
    public function setDisplayName($displayName = null)
    {
        // validation for constraint: string
        if (!is_null($displayName) && !is_string($displayName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($displayName, true), gettype($displayName)), __LINE__);
        }
        $this->DisplayName = $displayName;
        return $this;
    }
    /**
     * Get PrepareInvoicePrepareInvoiceFromShipment value
     * @return \StructType\Field|null
     */
    public function getPrepareInvoicePrepareInvoiceFromShipment()
    {
        return $this->PrepareInvoicePrepareInvoiceFromShipment;
    }
    /**
     * Set PrepareInvoicePrepareInvoiceFromShipment value
     * @param \StructType\Field $prepareInvoicePrepareInvoiceFromShipment
     * @return \StructType\ProcessOrderInvoicing
     */
    public function setPrepareInvoicePrepareInvoiceFromShipment(\StructType\Field $prepareInvoicePrepareInvoiceFromShipment = null)
    {
        $this->PrepareInvoicePrepareInvoiceFromShipment = $prepareInvoicePrepareInvoiceFromShipment;
        return $this;
    }
    /**
     * Get PrepareInvoicePrepareInvoice value
     * @return \StructType\Field|null
     */
    public function getPrepareInvoicePrepareInvoice()
    {
        return $this->PrepareInvoicePrepareInvoice;
    }
    /**
     * Set PrepareInvoicePrepareInvoice value
     * @param \StructType\Field $prepareInvoicePrepareInvoice
     * @return \StructType\ProcessOrderInvoicing
     */
    public function setPrepareInvoicePrepareInvoice(\StructType\Field $prepareInvoicePrepareInvoice = null)
    {
        $this->PrepareInvoicePrepareInvoice = $prepareInvoicePrepareInvoice;
        return $this;
    }
    /**
     * Get PrintInvoice value
     * @return \StructType\Field|null
     */
    public function getPrintInvoice()
    {
        return $this->PrintInvoice;
    }
    /**
     * Set PrintInvoice value
     * @param \StructType\Field $printInvoice
     * @return \StructType\ProcessOrderInvoicing
     */
    public function setPrintInvoice(\StructType\Field $printInvoice = null)
    {
        $this->PrintInvoice = $printInvoice;
        return $this;
    }
    /**
     * Get EmailInvoice value
     * @return \StructType\Field|null
     */
    public function getEmailInvoice()
    {
        return $this->EmailInvoice;
    }
    /**
     * Set EmailInvoice value
     * @param \StructType\Field $emailInvoice
     * @return \StructType\ProcessOrderInvoicing
     */
    public function setEmailInvoice(\StructType\Field $emailInvoice = null)
    {
        $this->EmailInvoice = $emailInvoice;
        return $this;
    }
    /**
     * Get ReleaseInvoice value
     * @return \StructType\Field|null
     */
    public function getReleaseInvoice()
    {
        return $this->ReleaseInvoice;
    }
    /**
     * Set ReleaseInvoice value
     * @param \StructType\Field $releaseInvoice
     * @return \StructType\ProcessOrderInvoicing
     */
    public function setReleaseInvoice(\StructType\Field $releaseInvoice = null)
    {
        $this->ReleaseInvoice = $releaseInvoice;
        return $this;
    }
    /**
     * Get ServiceCommands value
     * @return \StructType\ProcessOrderInvoicingServiceCommands|null
     */
    public function getServiceCommands()
    {
        return $this->ServiceCommands;
    }
    /**
     * Set ServiceCommands value
     * @param \StructType\ProcessOrderInvoicingServiceCommands $serviceCommands
     * @return \StructType\ProcessOrderInvoicing
     */
    public function setServiceCommands(\StructType\ProcessOrderInvoicingServiceCommands $serviceCommands = null)
    {
        $this->ServiceCommands = $serviceCommands;
        return $this;
    }
}
