<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ProductionDetailsNone StructType
 * @subpackage Structs
 */
class ProductionDetailsNone extends AbstractStructBase
{
    /**
     * The DisplayName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DisplayName;
    /**
     * The OrderType
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $OrderType;
    /**
     * The ProdOrdID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $ProdOrdID;
    /**
     * The StatusID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $StatusID;
    /**
     * The ServiceCommands
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\ProductionDetailsNoneServiceCommands
     */
    public $ServiceCommands;
    /**
     * Constructor method for ProductionDetailsNone
     * @uses ProductionDetailsNone::setDisplayName()
     * @uses ProductionDetailsNone::setOrderType()
     * @uses ProductionDetailsNone::setProdOrdID()
     * @uses ProductionDetailsNone::setStatusID()
     * @uses ProductionDetailsNone::setServiceCommands()
     * @param string $displayName
     * @param \StructType\Field $orderType
     * @param \StructType\Field $prodOrdID
     * @param \StructType\Field $statusID
     * @param \StructType\ProductionDetailsNoneServiceCommands $serviceCommands
     */
    public function __construct($displayName = null, \StructType\Field $orderType = null, \StructType\Field $prodOrdID = null, \StructType\Field $statusID = null, \StructType\ProductionDetailsNoneServiceCommands $serviceCommands = null)
    {
        $this
            ->setDisplayName($displayName)
            ->setOrderType($orderType)
            ->setProdOrdID($prodOrdID)
            ->setStatusID($statusID)
            ->setServiceCommands($serviceCommands);
    }
    /**
     * Get DisplayName value
     * @return string|null
     */
    public function getDisplayName()
    {
        return $this->DisplayName;
    }
    /**
     * Set DisplayName value
     * @param string $displayName
     * @return \StructType\ProductionDetailsNone
     */
    public function setDisplayName($displayName = null)
    {
        // validation for constraint: string
        if (!is_null($displayName) && !is_string($displayName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($displayName, true), gettype($displayName)), __LINE__);
        }
        $this->DisplayName = $displayName;
        return $this;
    }
    /**
     * Get OrderType value
     * @return \StructType\Field|null
     */
    public function getOrderType()
    {
        return $this->OrderType;
    }
    /**
     * Set OrderType value
     * @param \StructType\Field $orderType
     * @return \StructType\ProductionDetailsNone
     */
    public function setOrderType(\StructType\Field $orderType = null)
    {
        $this->OrderType = $orderType;
        return $this;
    }
    /**
     * Get ProdOrdID value
     * @return \StructType\Field|null
     */
    public function getProdOrdID()
    {
        return $this->ProdOrdID;
    }
    /**
     * Set ProdOrdID value
     * @param \StructType\Field $prodOrdID
     * @return \StructType\ProductionDetailsNone
     */
    public function setProdOrdID(\StructType\Field $prodOrdID = null)
    {
        $this->ProdOrdID = $prodOrdID;
        return $this;
    }
    /**
     * Get StatusID value
     * @return \StructType\Field|null
     */
    public function getStatusID()
    {
        return $this->StatusID;
    }
    /**
     * Set StatusID value
     * @param \StructType\Field $statusID
     * @return \StructType\ProductionDetailsNone
     */
    public function setStatusID(\StructType\Field $statusID = null)
    {
        $this->StatusID = $statusID;
        return $this;
    }
    /**
     * Get ServiceCommands value
     * @return \StructType\ProductionDetailsNoneServiceCommands|null
     */
    public function getServiceCommands()
    {
        return $this->ServiceCommands;
    }
    /**
     * Set ServiceCommands value
     * @param \StructType\ProductionDetailsNoneServiceCommands $serviceCommands
     * @return \StructType\ProductionDetailsNone
     */
    public function setServiceCommands(\StructType\ProductionDetailsNoneServiceCommands $serviceCommands = null)
    {
        $this->ServiceCommands = $serviceCommands;
        return $this;
    }
}
