<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PurchasingDetailsPurchasingSettings StructType
 * @subpackage Structs
 */
class PurchasingDetailsPurchasingSettings extends AbstractStructBase
{
    /**
     * The DisplayName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DisplayName;
    /**
     * The POSource
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $POSource;
    /**
     * The VendorID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $VendorID;
    /**
     * The POSiteID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $POSiteID;
    /**
     * The ServiceCommands
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\PurchasingDetailsPurchasingSettingsServiceCommands
     */
    public $ServiceCommands;
    /**
     * Constructor method for PurchasingDetailsPurchasingSettings
     * @uses PurchasingDetailsPurchasingSettings::setDisplayName()
     * @uses PurchasingDetailsPurchasingSettings::setPOSource()
     * @uses PurchasingDetailsPurchasingSettings::setVendorID()
     * @uses PurchasingDetailsPurchasingSettings::setPOSiteID()
     * @uses PurchasingDetailsPurchasingSettings::setServiceCommands()
     * @param string $displayName
     * @param \StructType\Field $pOSource
     * @param \StructType\Field $vendorID
     * @param \StructType\Field $pOSiteID
     * @param \StructType\PurchasingDetailsPurchasingSettingsServiceCommands $serviceCommands
     */
    public function __construct($displayName = null, \StructType\Field $pOSource = null, \StructType\Field $vendorID = null, \StructType\Field $pOSiteID = null, \StructType\PurchasingDetailsPurchasingSettingsServiceCommands $serviceCommands = null)
    {
        $this
            ->setDisplayName($displayName)
            ->setPOSource($pOSource)
            ->setVendorID($vendorID)
            ->setPOSiteID($pOSiteID)
            ->setServiceCommands($serviceCommands);
    }
    /**
     * Get DisplayName value
     * @return string|null
     */
    public function getDisplayName()
    {
        return $this->DisplayName;
    }
    /**
     * Set DisplayName value
     * @param string $displayName
     * @return \StructType\PurchasingDetailsPurchasingSettings
     */
    public function setDisplayName($displayName = null)
    {
        // validation for constraint: string
        if (!is_null($displayName) && !is_string($displayName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($displayName, true), gettype($displayName)), __LINE__);
        }
        $this->DisplayName = $displayName;
        return $this;
    }
    /**
     * Get POSource value
     * @return \StructType\Field|null
     */
    public function getPOSource()
    {
        return $this->POSource;
    }
    /**
     * Set POSource value
     * @param \StructType\Field $pOSource
     * @return \StructType\PurchasingDetailsPurchasingSettings
     */
    public function setPOSource(\StructType\Field $pOSource = null)
    {
        $this->POSource = $pOSource;
        return $this;
    }
    /**
     * Get VendorID value
     * @return \StructType\Field|null
     */
    public function getVendorID()
    {
        return $this->VendorID;
    }
    /**
     * Set VendorID value
     * @param \StructType\Field $vendorID
     * @return \StructType\PurchasingDetailsPurchasingSettings
     */
    public function setVendorID(\StructType\Field $vendorID = null)
    {
        $this->VendorID = $vendorID;
        return $this;
    }
    /**
     * Get POSiteID value
     * @return \StructType\Field|null
     */
    public function getPOSiteID()
    {
        return $this->POSiteID;
    }
    /**
     * Set POSiteID value
     * @param \StructType\Field $pOSiteID
     * @return \StructType\PurchasingDetailsPurchasingSettings
     */
    public function setPOSiteID(\StructType\Field $pOSiteID = null)
    {
        $this->POSiteID = $pOSiteID;
        return $this;
    }
    /**
     * Get ServiceCommands value
     * @return \StructType\PurchasingDetailsPurchasingSettingsServiceCommands|null
     */
    public function getServiceCommands()
    {
        return $this->ServiceCommands;
    }
    /**
     * Set ServiceCommands value
     * @param \StructType\PurchasingDetailsPurchasingSettingsServiceCommands $serviceCommands
     * @return \StructType\PurchasingDetailsPurchasingSettings
     */
    public function setServiceCommands(\StructType\PurchasingDetailsPurchasingSettingsServiceCommands $serviceCommands = null)
    {
        $this->ServiceCommands = $serviceCommands;
        return $this;
    }
}
