<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RecalculatePrices StructType
 * @subpackage Structs
 */
class RecalculatePrices extends AbstractStructBase
{
    /**
     * The DisplayName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DisplayName;
    /**
     * The RecalcTarget
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $RecalcTarget;
    /**
     * The RecalcUnitPrices
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $RecalcUnitPrices;
    /**
     * The OverrideManualPrices
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $OverrideManualPrices;
    /**
     * The RecalcDiscounts
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $RecalcDiscounts;
    /**
     * The OverrideManualDiscounts
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $OverrideManualDiscounts;
    /**
     * The OverrideManualDocGroupDiscounts
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $OverrideManualDocGroupDiscounts;
    /**
     * The CalcDiscountsOnLinesWithDisabledAutomaticDiscounts
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $CalcDiscountsOnLinesWithDisabledAutomaticDiscounts;
    /**
     * The ServiceCommands
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\RecalculatePricesServiceCommands
     */
    public $ServiceCommands;
    /**
     * Constructor method for RecalculatePrices
     * @uses RecalculatePrices::setDisplayName()
     * @uses RecalculatePrices::setRecalcTarget()
     * @uses RecalculatePrices::setRecalcUnitPrices()
     * @uses RecalculatePrices::setOverrideManualPrices()
     * @uses RecalculatePrices::setRecalcDiscounts()
     * @uses RecalculatePrices::setOverrideManualDiscounts()
     * @uses RecalculatePrices::setOverrideManualDocGroupDiscounts()
     * @uses RecalculatePrices::setCalcDiscountsOnLinesWithDisabledAutomaticDiscounts()
     * @uses RecalculatePrices::setServiceCommands()
     * @param string $displayName
     * @param \StructType\Field $recalcTarget
     * @param \StructType\Field $recalcUnitPrices
     * @param \StructType\Field $overrideManualPrices
     * @param \StructType\Field $recalcDiscounts
     * @param \StructType\Field $overrideManualDiscounts
     * @param \StructType\Field $overrideManualDocGroupDiscounts
     * @param \StructType\Field $calcDiscountsOnLinesWithDisabledAutomaticDiscounts
     * @param \StructType\RecalculatePricesServiceCommands $serviceCommands
     */
    public function __construct($displayName = null, \StructType\Field $recalcTarget = null, \StructType\Field $recalcUnitPrices = null, \StructType\Field $overrideManualPrices = null, \StructType\Field $recalcDiscounts = null, \StructType\Field $overrideManualDiscounts = null, \StructType\Field $overrideManualDocGroupDiscounts = null, \StructType\Field $calcDiscountsOnLinesWithDisabledAutomaticDiscounts = null, \StructType\RecalculatePricesServiceCommands $serviceCommands = null)
    {
        $this
            ->setDisplayName($displayName)
            ->setRecalcTarget($recalcTarget)
            ->setRecalcUnitPrices($recalcUnitPrices)
            ->setOverrideManualPrices($overrideManualPrices)
            ->setRecalcDiscounts($recalcDiscounts)
            ->setOverrideManualDiscounts($overrideManualDiscounts)
            ->setOverrideManualDocGroupDiscounts($overrideManualDocGroupDiscounts)
            ->setCalcDiscountsOnLinesWithDisabledAutomaticDiscounts($calcDiscountsOnLinesWithDisabledAutomaticDiscounts)
            ->setServiceCommands($serviceCommands);
    }
    /**
     * Get DisplayName value
     * @return string|null
     */
    public function getDisplayName()
    {
        return $this->DisplayName;
    }
    /**
     * Set DisplayName value
     * @param string $displayName
     * @return \StructType\RecalculatePrices
     */
    public function setDisplayName($displayName = null)
    {
        // validation for constraint: string
        if (!is_null($displayName) && !is_string($displayName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($displayName, true), gettype($displayName)), __LINE__);
        }
        $this->DisplayName = $displayName;
        return $this;
    }
    /**
     * Get RecalcTarget value
     * @return \StructType\Field|null
     */
    public function getRecalcTarget()
    {
        return $this->RecalcTarget;
    }
    /**
     * Set RecalcTarget value
     * @param \StructType\Field $recalcTarget
     * @return \StructType\RecalculatePrices
     */
    public function setRecalcTarget(\StructType\Field $recalcTarget = null)
    {
        $this->RecalcTarget = $recalcTarget;
        return $this;
    }
    /**
     * Get RecalcUnitPrices value
     * @return \StructType\Field|null
     */
    public function getRecalcUnitPrices()
    {
        return $this->RecalcUnitPrices;
    }
    /**
     * Set RecalcUnitPrices value
     * @param \StructType\Field $recalcUnitPrices
     * @return \StructType\RecalculatePrices
     */
    public function setRecalcUnitPrices(\StructType\Field $recalcUnitPrices = null)
    {
        $this->RecalcUnitPrices = $recalcUnitPrices;
        return $this;
    }
    /**
     * Get OverrideManualPrices value
     * @return \StructType\Field|null
     */
    public function getOverrideManualPrices()
    {
        return $this->OverrideManualPrices;
    }
    /**
     * Set OverrideManualPrices value
     * @param \StructType\Field $overrideManualPrices
     * @return \StructType\RecalculatePrices
     */
    public function setOverrideManualPrices(\StructType\Field $overrideManualPrices = null)
    {
        $this->OverrideManualPrices = $overrideManualPrices;
        return $this;
    }
    /**
     * Get RecalcDiscounts value
     * @return \StructType\Field|null
     */
    public function getRecalcDiscounts()
    {
        return $this->RecalcDiscounts;
    }
    /**
     * Set RecalcDiscounts value
     * @param \StructType\Field $recalcDiscounts
     * @return \StructType\RecalculatePrices
     */
    public function setRecalcDiscounts(\StructType\Field $recalcDiscounts = null)
    {
        $this->RecalcDiscounts = $recalcDiscounts;
        return $this;
    }
    /**
     * Get OverrideManualDiscounts value
     * @return \StructType\Field|null
     */
    public function getOverrideManualDiscounts()
    {
        return $this->OverrideManualDiscounts;
    }
    /**
     * Set OverrideManualDiscounts value
     * @param \StructType\Field $overrideManualDiscounts
     * @return \StructType\RecalculatePrices
     */
    public function setOverrideManualDiscounts(\StructType\Field $overrideManualDiscounts = null)
    {
        $this->OverrideManualDiscounts = $overrideManualDiscounts;
        return $this;
    }
    /**
     * Get OverrideManualDocGroupDiscounts value
     * @return \StructType\Field|null
     */
    public function getOverrideManualDocGroupDiscounts()
    {
        return $this->OverrideManualDocGroupDiscounts;
    }
    /**
     * Set OverrideManualDocGroupDiscounts value
     * @param \StructType\Field $overrideManualDocGroupDiscounts
     * @return \StructType\RecalculatePrices
     */
    public function setOverrideManualDocGroupDiscounts(\StructType\Field $overrideManualDocGroupDiscounts = null)
    {
        $this->OverrideManualDocGroupDiscounts = $overrideManualDocGroupDiscounts;
        return $this;
    }
    /**
     * Get CalcDiscountsOnLinesWithDisabledAutomaticDiscounts value
     * @return \StructType\Field|null
     */
    public function getCalcDiscountsOnLinesWithDisabledAutomaticDiscounts()
    {
        return $this->CalcDiscountsOnLinesWithDisabledAutomaticDiscounts;
    }
    /**
     * Set CalcDiscountsOnLinesWithDisabledAutomaticDiscounts value
     * @param \StructType\Field $calcDiscountsOnLinesWithDisabledAutomaticDiscounts
     * @return \StructType\RecalculatePrices
     */
    public function setCalcDiscountsOnLinesWithDisabledAutomaticDiscounts(\StructType\Field $calcDiscountsOnLinesWithDisabledAutomaticDiscounts = null)
    {
        $this->CalcDiscountsOnLinesWithDisabledAutomaticDiscounts = $calcDiscountsOnLinesWithDisabledAutomaticDiscounts;
        return $this;
    }
    /**
     * Get ServiceCommands value
     * @return \StructType\RecalculatePricesServiceCommands|null
     */
    public function getServiceCommands()
    {
        return $this->ServiceCommands;
    }
    /**
     * Set ServiceCommands value
     * @param \StructType\RecalculatePricesServiceCommands $serviceCommands
     * @return \StructType\RecalculatePrices
     */
    public function setServiceCommands(\StructType\RecalculatePricesServiceCommands $serviceCommands = null)
    {
        $this->ServiceCommands = $serviceCommands;
        return $this;
    }
}
