<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SetSchema StructType
 * @subpackage Structs
 */
class SetSchema extends AbstractStructBase
{
    /**
     * The schema
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Content
     */
    public $schema;
    /**
     * Constructor method for SetSchema
     * @uses SetSchema::setSchema()
     * @param \StructType\Content $schema
     */
    public function __construct(\StructType\Content $schema = null)
    {
        $this
            ->setSchema($schema);
    }
    /**
     * Get schema value
     * @return \StructType\Content|null
     */
    public function getSchema()
    {
        return $this->schema;
    }
    /**
     * Set schema value
     * @param \StructType\Content $schema
     * @return \StructType\SetSchema
     */
    public function setSchema(\StructType\Content $schema = null)
    {
        $this->schema = $schema;
        return $this;
    }
}
