<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ShippingIntercompanyPurchase StructType
 * @subpackage Structs
 */
class ShippingIntercompanyPurchase extends AbstractStructBase
{
    /**
     * The DisplayName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DisplayName;
    /**
     * The RelatedOrderType
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $RelatedOrderType;
    /**
     * The RelatedOrderNbr
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $RelatedOrderNbr;
    /**
     * The RelatedPOReturnNbr
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $RelatedPOReturnNbr;
    /**
     * The ServiceCommands
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\ShippingIntercompanyPurchaseServiceCommands
     */
    public $ServiceCommands;
    /**
     * Constructor method for ShippingIntercompanyPurchase
     * @uses ShippingIntercompanyPurchase::setDisplayName()
     * @uses ShippingIntercompanyPurchase::setRelatedOrderType()
     * @uses ShippingIntercompanyPurchase::setRelatedOrderNbr()
     * @uses ShippingIntercompanyPurchase::setRelatedPOReturnNbr()
     * @uses ShippingIntercompanyPurchase::setServiceCommands()
     * @param string $displayName
     * @param \StructType\Field $relatedOrderType
     * @param \StructType\Field $relatedOrderNbr
     * @param \StructType\Field $relatedPOReturnNbr
     * @param \StructType\ShippingIntercompanyPurchaseServiceCommands $serviceCommands
     */
    public function __construct($displayName = null, \StructType\Field $relatedOrderType = null, \StructType\Field $relatedOrderNbr = null, \StructType\Field $relatedPOReturnNbr = null, \StructType\ShippingIntercompanyPurchaseServiceCommands $serviceCommands = null)
    {
        $this
            ->setDisplayName($displayName)
            ->setRelatedOrderType($relatedOrderType)
            ->setRelatedOrderNbr($relatedOrderNbr)
            ->setRelatedPOReturnNbr($relatedPOReturnNbr)
            ->setServiceCommands($serviceCommands);
    }
    /**
     * Get DisplayName value
     * @return string|null
     */
    public function getDisplayName()
    {
        return $this->DisplayName;
    }
    /**
     * Set DisplayName value
     * @param string $displayName
     * @return \StructType\ShippingIntercompanyPurchase
     */
    public function setDisplayName($displayName = null)
    {
        // validation for constraint: string
        if (!is_null($displayName) && !is_string($displayName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($displayName, true), gettype($displayName)), __LINE__);
        }
        $this->DisplayName = $displayName;
        return $this;
    }
    /**
     * Get RelatedOrderType value
     * @return \StructType\Field|null
     */
    public function getRelatedOrderType()
    {
        return $this->RelatedOrderType;
    }
    /**
     * Set RelatedOrderType value
     * @param \StructType\Field $relatedOrderType
     * @return \StructType\ShippingIntercompanyPurchase
     */
    public function setRelatedOrderType(\StructType\Field $relatedOrderType = null)
    {
        $this->RelatedOrderType = $relatedOrderType;
        return $this;
    }
    /**
     * Get RelatedOrderNbr value
     * @return \StructType\Field|null
     */
    public function getRelatedOrderNbr()
    {
        return $this->RelatedOrderNbr;
    }
    /**
     * Set RelatedOrderNbr value
     * @param \StructType\Field $relatedOrderNbr
     * @return \StructType\ShippingIntercompanyPurchase
     */
    public function setRelatedOrderNbr(\StructType\Field $relatedOrderNbr = null)
    {
        $this->RelatedOrderNbr = $relatedOrderNbr;
        return $this;
    }
    /**
     * Get RelatedPOReturnNbr value
     * @return \StructType\Field|null
     */
    public function getRelatedPOReturnNbr()
    {
        return $this->RelatedPOReturnNbr;
    }
    /**
     * Set RelatedPOReturnNbr value
     * @param \StructType\Field $relatedPOReturnNbr
     * @return \StructType\ShippingIntercompanyPurchase
     */
    public function setRelatedPOReturnNbr(\StructType\Field $relatedPOReturnNbr = null)
    {
        $this->RelatedPOReturnNbr = $relatedPOReturnNbr;
        return $this;
    }
    /**
     * Get ServiceCommands value
     * @return \StructType\ShippingIntercompanyPurchaseServiceCommands|null
     */
    public function getServiceCommands()
    {
        return $this->ServiceCommands;
    }
    /**
     * Set ServiceCommands value
     * @param \StructType\ShippingIntercompanyPurchaseServiceCommands $serviceCommands
     * @return \StructType\ShippingIntercompanyPurchase
     */
    public function setServiceCommands(\StructType\ShippingIntercompanyPurchaseServiceCommands $serviceCommands = null)
    {
        $this->ServiceCommands = $serviceCommands;
        return $this;
    }
}
