<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ShippingOrderShippingSettings StructType
 * @subpackage Structs
 */
class ShippingOrderShippingSettings extends AbstractStructBase
{
    /**
     * The DisplayName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DisplayName;
    /**
     * The SchedShipment
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $SchedShipment;
    /**
     * The ShipSeparately
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $ShipSeparately;
    /**
     * The ShippingRule
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $ShippingRule;
    /**
     * The CancelBy
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $CancelBy;
    /**
     * The Canceled
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $Canceled;
    /**
     * The PreferredWarehouseID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $PreferredWarehouseID;
    /**
     * The ServiceCommands
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\ShippingOrderShippingSettingsServiceCommands
     */
    public $ServiceCommands;
    /**
     * Constructor method for ShippingOrderShippingSettings
     * @uses ShippingOrderShippingSettings::setDisplayName()
     * @uses ShippingOrderShippingSettings::setSchedShipment()
     * @uses ShippingOrderShippingSettings::setShipSeparately()
     * @uses ShippingOrderShippingSettings::setShippingRule()
     * @uses ShippingOrderShippingSettings::setCancelBy()
     * @uses ShippingOrderShippingSettings::setCanceled()
     * @uses ShippingOrderShippingSettings::setPreferredWarehouseID()
     * @uses ShippingOrderShippingSettings::setServiceCommands()
     * @param string $displayName
     * @param \StructType\Field $schedShipment
     * @param \StructType\Field $shipSeparately
     * @param \StructType\Field $shippingRule
     * @param \StructType\Field $cancelBy
     * @param \StructType\Field $canceled
     * @param \StructType\Field $preferredWarehouseID
     * @param \StructType\ShippingOrderShippingSettingsServiceCommands $serviceCommands
     */
    public function __construct($displayName = null, \StructType\Field $schedShipment = null, \StructType\Field $shipSeparately = null, \StructType\Field $shippingRule = null, \StructType\Field $cancelBy = null, \StructType\Field $canceled = null, \StructType\Field $preferredWarehouseID = null, \StructType\ShippingOrderShippingSettingsServiceCommands $serviceCommands = null)
    {
        $this
            ->setDisplayName($displayName)
            ->setSchedShipment($schedShipment)
            ->setShipSeparately($shipSeparately)
            ->setShippingRule($shippingRule)
            ->setCancelBy($cancelBy)
            ->setCanceled($canceled)
            ->setPreferredWarehouseID($preferredWarehouseID)
            ->setServiceCommands($serviceCommands);
    }
    /**
     * Get DisplayName value
     * @return string|null
     */
    public function getDisplayName()
    {
        return $this->DisplayName;
    }
    /**
     * Set DisplayName value
     * @param string $displayName
     * @return \StructType\ShippingOrderShippingSettings
     */
    public function setDisplayName($displayName = null)
    {
        // validation for constraint: string
        if (!is_null($displayName) && !is_string($displayName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($displayName, true), gettype($displayName)), __LINE__);
        }
        $this->DisplayName = $displayName;
        return $this;
    }
    /**
     * Get SchedShipment value
     * @return \StructType\Field|null
     */
    public function getSchedShipment()
    {
        return $this->SchedShipment;
    }
    /**
     * Set SchedShipment value
     * @param \StructType\Field $schedShipment
     * @return \StructType\ShippingOrderShippingSettings
     */
    public function setSchedShipment(\StructType\Field $schedShipment = null)
    {
        $this->SchedShipment = $schedShipment;
        return $this;
    }
    /**
     * Get ShipSeparately value
     * @return \StructType\Field|null
     */
    public function getShipSeparately()
    {
        return $this->ShipSeparately;
    }
    /**
     * Set ShipSeparately value
     * @param \StructType\Field $shipSeparately
     * @return \StructType\ShippingOrderShippingSettings
     */
    public function setShipSeparately(\StructType\Field $shipSeparately = null)
    {
        $this->ShipSeparately = $shipSeparately;
        return $this;
    }
    /**
     * Get ShippingRule value
     * @return \StructType\Field|null
     */
    public function getShippingRule()
    {
        return $this->ShippingRule;
    }
    /**
     * Set ShippingRule value
     * @param \StructType\Field $shippingRule
     * @return \StructType\ShippingOrderShippingSettings
     */
    public function setShippingRule(\StructType\Field $shippingRule = null)
    {
        $this->ShippingRule = $shippingRule;
        return $this;
    }
    /**
     * Get CancelBy value
     * @return \StructType\Field|null
     */
    public function getCancelBy()
    {
        return $this->CancelBy;
    }
    /**
     * Set CancelBy value
     * @param \StructType\Field $cancelBy
     * @return \StructType\ShippingOrderShippingSettings
     */
    public function setCancelBy(\StructType\Field $cancelBy = null)
    {
        $this->CancelBy = $cancelBy;
        return $this;
    }
    /**
     * Get Canceled value
     * @return \StructType\Field|null
     */
    public function getCanceled()
    {
        return $this->Canceled;
    }
    /**
     * Set Canceled value
     * @param \StructType\Field $canceled
     * @return \StructType\ShippingOrderShippingSettings
     */
    public function setCanceled(\StructType\Field $canceled = null)
    {
        $this->Canceled = $canceled;
        return $this;
    }
    /**
     * Get PreferredWarehouseID value
     * @return \StructType\Field|null
     */
    public function getPreferredWarehouseID()
    {
        return $this->PreferredWarehouseID;
    }
    /**
     * Set PreferredWarehouseID value
     * @param \StructType\Field $preferredWarehouseID
     * @return \StructType\ShippingOrderShippingSettings
     */
    public function setPreferredWarehouseID(\StructType\Field $preferredWarehouseID = null)
    {
        $this->PreferredWarehouseID = $preferredWarehouseID;
        return $this;
    }
    /**
     * Get ServiceCommands value
     * @return \StructType\ShippingOrderShippingSettingsServiceCommands|null
     */
    public function getServiceCommands()
    {
        return $this->ServiceCommands;
    }
    /**
     * Set ServiceCommands value
     * @param \StructType\ShippingOrderShippingSettingsServiceCommands $serviceCommands
     * @return \StructType\ShippingOrderShippingSettings
     */
    public function setServiceCommands(\StructType\ShippingOrderShippingSettingsServiceCommands $serviceCommands = null)
    {
        $this->ServiceCommands = $serviceCommands;
        return $this;
    }
}
