<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ShopForRatesCarrierRates StructType
 * @subpackage Structs
 */
class ShopForRatesCarrierRates extends AbstractStructBase
{
    /**
     * The DisplayName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DisplayName;
    /**
     * The Selected
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $Selected;
    /**
     * The Code
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $Code;
    /**
     * The Description
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $Description;
    /**
     * The Amount
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $Amount;
    /**
     * The DaysInTransit
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $DaysInTransit;
    /**
     * The DeliveryDate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $DeliveryDate;
    /**
     * The ServiceCommands
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\ShopForRatesCarrierRatesServiceCommands
     */
    public $ServiceCommands;
    /**
     * Constructor method for ShopForRatesCarrierRates
     * @uses ShopForRatesCarrierRates::setDisplayName()
     * @uses ShopForRatesCarrierRates::setSelected()
     * @uses ShopForRatesCarrierRates::setCode()
     * @uses ShopForRatesCarrierRates::setDescription()
     * @uses ShopForRatesCarrierRates::setAmount()
     * @uses ShopForRatesCarrierRates::setDaysInTransit()
     * @uses ShopForRatesCarrierRates::setDeliveryDate()
     * @uses ShopForRatesCarrierRates::setServiceCommands()
     * @param string $displayName
     * @param \StructType\Field $selected
     * @param \StructType\Field $code
     * @param \StructType\Field $description
     * @param \StructType\Field $amount
     * @param \StructType\Field $daysInTransit
     * @param \StructType\Field $deliveryDate
     * @param \StructType\ShopForRatesCarrierRatesServiceCommands $serviceCommands
     */
    public function __construct($displayName = null, \StructType\Field $selected = null, \StructType\Field $code = null, \StructType\Field $description = null, \StructType\Field $amount = null, \StructType\Field $daysInTransit = null, \StructType\Field $deliveryDate = null, \StructType\ShopForRatesCarrierRatesServiceCommands $serviceCommands = null)
    {
        $this
            ->setDisplayName($displayName)
            ->setSelected($selected)
            ->setCode($code)
            ->setDescription($description)
            ->setAmount($amount)
            ->setDaysInTransit($daysInTransit)
            ->setDeliveryDate($deliveryDate)
            ->setServiceCommands($serviceCommands);
    }
    /**
     * Get DisplayName value
     * @return string|null
     */
    public function getDisplayName()
    {
        return $this->DisplayName;
    }
    /**
     * Set DisplayName value
     * @param string $displayName
     * @return \StructType\ShopForRatesCarrierRates
     */
    public function setDisplayName($displayName = null)
    {
        // validation for constraint: string
        if (!is_null($displayName) && !is_string($displayName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($displayName, true), gettype($displayName)), __LINE__);
        }
        $this->DisplayName = $displayName;
        return $this;
    }
    /**
     * Get Selected value
     * @return \StructType\Field|null
     */
    public function getSelected()
    {
        return $this->Selected;
    }
    /**
     * Set Selected value
     * @param \StructType\Field $selected
     * @return \StructType\ShopForRatesCarrierRates
     */
    public function setSelected(\StructType\Field $selected = null)
    {
        $this->Selected = $selected;
        return $this;
    }
    /**
     * Get Code value
     * @return \StructType\Field|null
     */
    public function getCode()
    {
        return $this->Code;
    }
    /**
     * Set Code value
     * @param \StructType\Field $code
     * @return \StructType\ShopForRatesCarrierRates
     */
    public function setCode(\StructType\Field $code = null)
    {
        $this->Code = $code;
        return $this;
    }
    /**
     * Get Description value
     * @return \StructType\Field|null
     */
    public function getDescription()
    {
        return $this->Description;
    }
    /**
     * Set Description value
     * @param \StructType\Field $description
     * @return \StructType\ShopForRatesCarrierRates
     */
    public function setDescription(\StructType\Field $description = null)
    {
        $this->Description = $description;
        return $this;
    }
    /**
     * Get Amount value
     * @return \StructType\Field|null
     */
    public function getAmount()
    {
        return $this->Amount;
    }
    /**
     * Set Amount value
     * @param \StructType\Field $amount
     * @return \StructType\ShopForRatesCarrierRates
     */
    public function setAmount(\StructType\Field $amount = null)
    {
        $this->Amount = $amount;
        return $this;
    }
    /**
     * Get DaysInTransit value
     * @return \StructType\Field|null
     */
    public function getDaysInTransit()
    {
        return $this->DaysInTransit;
    }
    /**
     * Set DaysInTransit value
     * @param \StructType\Field $daysInTransit
     * @return \StructType\ShopForRatesCarrierRates
     */
    public function setDaysInTransit(\StructType\Field $daysInTransit = null)
    {
        $this->DaysInTransit = $daysInTransit;
        return $this;
    }
    /**
     * Get DeliveryDate value
     * @return \StructType\Field|null
     */
    public function getDeliveryDate()
    {
        return $this->DeliveryDate;
    }
    /**
     * Set DeliveryDate value
     * @param \StructType\Field $deliveryDate
     * @return \StructType\ShopForRatesCarrierRates
     */
    public function setDeliveryDate(\StructType\Field $deliveryDate = null)
    {
        $this->DeliveryDate = $deliveryDate;
        return $this;
    }
    /**
     * Get ServiceCommands value
     * @return \StructType\ShopForRatesCarrierRatesServiceCommands|null
     */
    public function getServiceCommands()
    {
        return $this->ServiceCommands;
    }
    /**
     * Set ServiceCommands value
     * @param \StructType\ShopForRatesCarrierRatesServiceCommands $serviceCommands
     * @return \StructType\ShopForRatesCarrierRates
     */
    public function setServiceCommands(\StructType\ShopForRatesCarrierRatesServiceCommands $serviceCommands = null)
    {
        $this->ServiceCommands = $serviceCommands;
        return $this;
    }
}
