<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ShopForRatesPackages StructType
 * @subpackage Structs
 */
class ShopForRatesPackages extends AbstractStructBase
{
    /**
     * The DisplayName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DisplayName;
    /**
     * The BoxID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $BoxID;
    /**
     * The Description
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $Description;
    /**
     * The ShipFromWarehouse
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $ShipFromWarehouse;
    /**
     * The WeightUOM
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $WeightUOM;
    /**
     * The NetWeight
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $NetWeight;
    /**
     * The BoxWeight
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $BoxWeight;
    /**
     * The GrossWeight
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $GrossWeight;
    /**
     * The DeclaredValue
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $DeclaredValue;
    /**
     * The COD
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $COD;
    /**
     * The StampsSurcharges
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $StampsSurcharges;
    /**
     * The ServiceCommands
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\ShopForRatesPackagesServiceCommands
     */
    public $ServiceCommands;
    /**
     * Constructor method for ShopForRatesPackages
     * @uses ShopForRatesPackages::setDisplayName()
     * @uses ShopForRatesPackages::setBoxID()
     * @uses ShopForRatesPackages::setDescription()
     * @uses ShopForRatesPackages::setShipFromWarehouse()
     * @uses ShopForRatesPackages::setWeightUOM()
     * @uses ShopForRatesPackages::setNetWeight()
     * @uses ShopForRatesPackages::setBoxWeight()
     * @uses ShopForRatesPackages::setGrossWeight()
     * @uses ShopForRatesPackages::setDeclaredValue()
     * @uses ShopForRatesPackages::setCOD()
     * @uses ShopForRatesPackages::setStampsSurcharges()
     * @uses ShopForRatesPackages::setServiceCommands()
     * @param string $displayName
     * @param \StructType\Field $boxID
     * @param \StructType\Field $description
     * @param \StructType\Field $shipFromWarehouse
     * @param \StructType\Field $weightUOM
     * @param \StructType\Field $netWeight
     * @param \StructType\Field $boxWeight
     * @param \StructType\Field $grossWeight
     * @param \StructType\Field $declaredValue
     * @param \StructType\Field $cOD
     * @param \StructType\Field $stampsSurcharges
     * @param \StructType\ShopForRatesPackagesServiceCommands $serviceCommands
     */
    public function __construct($displayName = null, \StructType\Field $boxID = null, \StructType\Field $description = null, \StructType\Field $shipFromWarehouse = null, \StructType\Field $weightUOM = null, \StructType\Field $netWeight = null, \StructType\Field $boxWeight = null, \StructType\Field $grossWeight = null, \StructType\Field $declaredValue = null, \StructType\Field $cOD = null, \StructType\Field $stampsSurcharges = null, \StructType\ShopForRatesPackagesServiceCommands $serviceCommands = null)
    {
        $this
            ->setDisplayName($displayName)
            ->setBoxID($boxID)
            ->setDescription($description)
            ->setShipFromWarehouse($shipFromWarehouse)
            ->setWeightUOM($weightUOM)
            ->setNetWeight($netWeight)
            ->setBoxWeight($boxWeight)
            ->setGrossWeight($grossWeight)
            ->setDeclaredValue($declaredValue)
            ->setCOD($cOD)
            ->setStampsSurcharges($stampsSurcharges)
            ->setServiceCommands($serviceCommands);
    }
    /**
     * Get DisplayName value
     * @return string|null
     */
    public function getDisplayName()
    {
        return $this->DisplayName;
    }
    /**
     * Set DisplayName value
     * @param string $displayName
     * @return \StructType\ShopForRatesPackages
     */
    public function setDisplayName($displayName = null)
    {
        // validation for constraint: string
        if (!is_null($displayName) && !is_string($displayName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($displayName, true), gettype($displayName)), __LINE__);
        }
        $this->DisplayName = $displayName;
        return $this;
    }
    /**
     * Get BoxID value
     * @return \StructType\Field|null
     */
    public function getBoxID()
    {
        return $this->BoxID;
    }
    /**
     * Set BoxID value
     * @param \StructType\Field $boxID
     * @return \StructType\ShopForRatesPackages
     */
    public function setBoxID(\StructType\Field $boxID = null)
    {
        $this->BoxID = $boxID;
        return $this;
    }
    /**
     * Get Description value
     * @return \StructType\Field|null
     */
    public function getDescription()
    {
        return $this->Description;
    }
    /**
     * Set Description value
     * @param \StructType\Field $description
     * @return \StructType\ShopForRatesPackages
     */
    public function setDescription(\StructType\Field $description = null)
    {
        $this->Description = $description;
        return $this;
    }
    /**
     * Get ShipFromWarehouse value
     * @return \StructType\Field|null
     */
    public function getShipFromWarehouse()
    {
        return $this->ShipFromWarehouse;
    }
    /**
     * Set ShipFromWarehouse value
     * @param \StructType\Field $shipFromWarehouse
     * @return \StructType\ShopForRatesPackages
     */
    public function setShipFromWarehouse(\StructType\Field $shipFromWarehouse = null)
    {
        $this->ShipFromWarehouse = $shipFromWarehouse;
        return $this;
    }
    /**
     * Get WeightUOM value
     * @return \StructType\Field|null
     */
    public function getWeightUOM()
    {
        return $this->WeightUOM;
    }
    /**
     * Set WeightUOM value
     * @param \StructType\Field $weightUOM
     * @return \StructType\ShopForRatesPackages
     */
    public function setWeightUOM(\StructType\Field $weightUOM = null)
    {
        $this->WeightUOM = $weightUOM;
        return $this;
    }
    /**
     * Get NetWeight value
     * @return \StructType\Field|null
     */
    public function getNetWeight()
    {
        return $this->NetWeight;
    }
    /**
     * Set NetWeight value
     * @param \StructType\Field $netWeight
     * @return \StructType\ShopForRatesPackages
     */
    public function setNetWeight(\StructType\Field $netWeight = null)
    {
        $this->NetWeight = $netWeight;
        return $this;
    }
    /**
     * Get BoxWeight value
     * @return \StructType\Field|null
     */
    public function getBoxWeight()
    {
        return $this->BoxWeight;
    }
    /**
     * Set BoxWeight value
     * @param \StructType\Field $boxWeight
     * @return \StructType\ShopForRatesPackages
     */
    public function setBoxWeight(\StructType\Field $boxWeight = null)
    {
        $this->BoxWeight = $boxWeight;
        return $this;
    }
    /**
     * Get GrossWeight value
     * @return \StructType\Field|null
     */
    public function getGrossWeight()
    {
        return $this->GrossWeight;
    }
    /**
     * Set GrossWeight value
     * @param \StructType\Field $grossWeight
     * @return \StructType\ShopForRatesPackages
     */
    public function setGrossWeight(\StructType\Field $grossWeight = null)
    {
        $this->GrossWeight = $grossWeight;
        return $this;
    }
    /**
     * Get DeclaredValue value
     * @return \StructType\Field|null
     */
    public function getDeclaredValue()
    {
        return $this->DeclaredValue;
    }
    /**
     * Set DeclaredValue value
     * @param \StructType\Field $declaredValue
     * @return \StructType\ShopForRatesPackages
     */
    public function setDeclaredValue(\StructType\Field $declaredValue = null)
    {
        $this->DeclaredValue = $declaredValue;
        return $this;
    }
    /**
     * Get COD value
     * @return \StructType\Field|null
     */
    public function getCOD()
    {
        return $this->COD;
    }
    /**
     * Set COD value
     * @param \StructType\Field $cOD
     * @return \StructType\ShopForRatesPackages
     */
    public function setCOD(\StructType\Field $cOD = null)
    {
        $this->COD = $cOD;
        return $this;
    }
    /**
     * Get StampsSurcharges value
     * @return \StructType\Field|null
     */
    public function getStampsSurcharges()
    {
        return $this->StampsSurcharges;
    }
    /**
     * Set StampsSurcharges value
     * @param \StructType\Field $stampsSurcharges
     * @return \StructType\ShopForRatesPackages
     */
    public function setStampsSurcharges(\StructType\Field $stampsSurcharges = null)
    {
        $this->StampsSurcharges = $stampsSurcharges;
        return $this;
    }
    /**
     * Get ServiceCommands value
     * @return \StructType\ShopForRatesPackagesServiceCommands|null
     */
    public function getServiceCommands()
    {
        return $this->ServiceCommands;
    }
    /**
     * Set ServiceCommands value
     * @param \StructType\ShopForRatesPackagesServiceCommands $serviceCommands
     * @return \StructType\ShopForRatesPackages
     */
    public function setServiceCommands(\StructType\ShopForRatesPackagesServiceCommands $serviceCommands = null)
    {
        $this->ServiceCommands = $serviceCommands;
        return $this;
    }
}
