<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TaxesServiceCommands StructType
 * @subpackage Structs
 */
class TaxesServiceCommands extends AbstractStructBase
{
    /**
     * The KeyTaxID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Key
     */
    public $KeyTaxID;
    /**
     * The NewRow
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\NewRow
     */
    public $NewRow;
    /**
     * The RowNumber
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\RowNumber
     */
    public $RowNumber;
    /**
     * The DeleteRow
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\DeleteRow
     */
    public $DeleteRow;
    /**
     * The DialogAnswer
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Answer
     */
    public $DialogAnswer;
    /**
     * Constructor method for TaxesServiceCommands
     * @uses TaxesServiceCommands::setKeyTaxID()
     * @uses TaxesServiceCommands::setNewRow()
     * @uses TaxesServiceCommands::setRowNumber()
     * @uses TaxesServiceCommands::setDeleteRow()
     * @uses TaxesServiceCommands::setDialogAnswer()
     * @param \StructType\Key $keyTaxID
     * @param \StructType\NewRow $newRow
     * @param \StructType\RowNumber $rowNumber
     * @param \StructType\DeleteRow $deleteRow
     * @param \StructType\Answer $dialogAnswer
     */
    public function __construct(\StructType\Key $keyTaxID = null, \StructType\NewRow $newRow = null, \StructType\RowNumber $rowNumber = null, \StructType\DeleteRow $deleteRow = null, \StructType\Answer $dialogAnswer = null)
    {
        $this
            ->setKeyTaxID($keyTaxID)
            ->setNewRow($newRow)
            ->setRowNumber($rowNumber)
            ->setDeleteRow($deleteRow)
            ->setDialogAnswer($dialogAnswer);
    }
    /**
     * Get KeyTaxID value
     * @return \StructType\Key|null
     */
    public function getKeyTaxID()
    {
        return $this->KeyTaxID;
    }
    /**
     * Set KeyTaxID value
     * @param \StructType\Key $keyTaxID
     * @return \StructType\TaxesServiceCommands
     */
    public function setKeyTaxID(\StructType\Key $keyTaxID = null)
    {
        $this->KeyTaxID = $keyTaxID;
        return $this;
    }
    /**
     * Get NewRow value
     * @return \StructType\NewRow|null
     */
    public function getNewRow()
    {
        return $this->NewRow;
    }
    /**
     * Set NewRow value
     * @param \StructType\NewRow $newRow
     * @return \StructType\TaxesServiceCommands
     */
    public function setNewRow(\StructType\NewRow $newRow = null)
    {
        $this->NewRow = $newRow;
        return $this;
    }
    /**
     * Get RowNumber value
     * @return \StructType\RowNumber|null
     */
    public function getRowNumber()
    {
        return $this->RowNumber;
    }
    /**
     * Set RowNumber value
     * @param \StructType\RowNumber $rowNumber
     * @return \StructType\TaxesServiceCommands
     */
    public function setRowNumber(\StructType\RowNumber $rowNumber = null)
    {
        $this->RowNumber = $rowNumber;
        return $this;
    }
    /**
     * Get DeleteRow value
     * @return \StructType\DeleteRow|null
     */
    public function getDeleteRow()
    {
        return $this->DeleteRow;
    }
    /**
     * Set DeleteRow value
     * @param \StructType\DeleteRow $deleteRow
     * @return \StructType\TaxesServiceCommands
     */
    public function setDeleteRow(\StructType\DeleteRow $deleteRow = null)
    {
        $this->DeleteRow = $deleteRow;
        return $this;
    }
    /**
     * Get DialogAnswer value
     * @return \StructType\Answer|null
     */
    public function getDialogAnswer()
    {
        return $this->DialogAnswer;
    }
    /**
     * Set DialogAnswer value
     * @param \StructType\Answer $dialogAnswer
     * @return \StructType\TaxesServiceCommands
     */
    public function setDialogAnswer(\StructType\Answer $dialogAnswer = null)
    {
        $this->DialogAnswer = $dialogAnswer;
        return $this;
    }
}
