<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TotalsCalculatedAmountsAndQuantities StructType
 * @subpackage Structs
 */
class TotalsCalculatedAmountsAndQuantities extends AbstractStructBase
{
    /**
     * The DisplayName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DisplayName;
    /**
     * The EstimateQty
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $EstimateQty;
    /**
     * The OpenQuantity
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $OpenQuantity;
    /**
     * The UnshippedQuantity
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $UnshippedQuantity;
    /**
     * The UnshippedAmount
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $UnshippedAmount;
    /**
     * The UnbilledQuantity
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $UnbilledQuantity;
    /**
     * The UnbilledBalance
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $UnbilledBalance;
    /**
     * The TotalPaid
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $TotalPaid;
    /**
     * The UnpaidBalance
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $UnpaidBalance;
    /**
     * The ServiceCommands
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\TotalsCalculatedAmountsAndQuantitiesServiceCommands
     */
    public $ServiceCommands;
    /**
     * Constructor method for TotalsCalculatedAmountsAndQuantities
     * @uses TotalsCalculatedAmountsAndQuantities::setDisplayName()
     * @uses TotalsCalculatedAmountsAndQuantities::setEstimateQty()
     * @uses TotalsCalculatedAmountsAndQuantities::setOpenQuantity()
     * @uses TotalsCalculatedAmountsAndQuantities::setUnshippedQuantity()
     * @uses TotalsCalculatedAmountsAndQuantities::setUnshippedAmount()
     * @uses TotalsCalculatedAmountsAndQuantities::setUnbilledQuantity()
     * @uses TotalsCalculatedAmountsAndQuantities::setUnbilledBalance()
     * @uses TotalsCalculatedAmountsAndQuantities::setTotalPaid()
     * @uses TotalsCalculatedAmountsAndQuantities::setUnpaidBalance()
     * @uses TotalsCalculatedAmountsAndQuantities::setServiceCommands()
     * @param string $displayName
     * @param \StructType\Field $estimateQty
     * @param \StructType\Field $openQuantity
     * @param \StructType\Field $unshippedQuantity
     * @param \StructType\Field $unshippedAmount
     * @param \StructType\Field $unbilledQuantity
     * @param \StructType\Field $unbilledBalance
     * @param \StructType\Field $totalPaid
     * @param \StructType\Field $unpaidBalance
     * @param \StructType\TotalsCalculatedAmountsAndQuantitiesServiceCommands $serviceCommands
     */
    public function __construct($displayName = null, \StructType\Field $estimateQty = null, \StructType\Field $openQuantity = null, \StructType\Field $unshippedQuantity = null, \StructType\Field $unshippedAmount = null, \StructType\Field $unbilledQuantity = null, \StructType\Field $unbilledBalance = null, \StructType\Field $totalPaid = null, \StructType\Field $unpaidBalance = null, \StructType\TotalsCalculatedAmountsAndQuantitiesServiceCommands $serviceCommands = null)
    {
        $this
            ->setDisplayName($displayName)
            ->setEstimateQty($estimateQty)
            ->setOpenQuantity($openQuantity)
            ->setUnshippedQuantity($unshippedQuantity)
            ->setUnshippedAmount($unshippedAmount)
            ->setUnbilledQuantity($unbilledQuantity)
            ->setUnbilledBalance($unbilledBalance)
            ->setTotalPaid($totalPaid)
            ->setUnpaidBalance($unpaidBalance)
            ->setServiceCommands($serviceCommands);
    }
    /**
     * Get DisplayName value
     * @return string|null
     */
    public function getDisplayName()
    {
        return $this->DisplayName;
    }
    /**
     * Set DisplayName value
     * @param string $displayName
     * @return \StructType\TotalsCalculatedAmountsAndQuantities
     */
    public function setDisplayName($displayName = null)
    {
        // validation for constraint: string
        if (!is_null($displayName) && !is_string($displayName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($displayName, true), gettype($displayName)), __LINE__);
        }
        $this->DisplayName = $displayName;
        return $this;
    }
    /**
     * Get EstimateQty value
     * @return \StructType\Field|null
     */
    public function getEstimateQty()
    {
        return $this->EstimateQty;
    }
    /**
     * Set EstimateQty value
     * @param \StructType\Field $estimateQty
     * @return \StructType\TotalsCalculatedAmountsAndQuantities
     */
    public function setEstimateQty(\StructType\Field $estimateQty = null)
    {
        $this->EstimateQty = $estimateQty;
        return $this;
    }
    /**
     * Get OpenQuantity value
     * @return \StructType\Field|null
     */
    public function getOpenQuantity()
    {
        return $this->OpenQuantity;
    }
    /**
     * Set OpenQuantity value
     * @param \StructType\Field $openQuantity
     * @return \StructType\TotalsCalculatedAmountsAndQuantities
     */
    public function setOpenQuantity(\StructType\Field $openQuantity = null)
    {
        $this->OpenQuantity = $openQuantity;
        return $this;
    }
    /**
     * Get UnshippedQuantity value
     * @return \StructType\Field|null
     */
    public function getUnshippedQuantity()
    {
        return $this->UnshippedQuantity;
    }
    /**
     * Set UnshippedQuantity value
     * @param \StructType\Field $unshippedQuantity
     * @return \StructType\TotalsCalculatedAmountsAndQuantities
     */
    public function setUnshippedQuantity(\StructType\Field $unshippedQuantity = null)
    {
        $this->UnshippedQuantity = $unshippedQuantity;
        return $this;
    }
    /**
     * Get UnshippedAmount value
     * @return \StructType\Field|null
     */
    public function getUnshippedAmount()
    {
        return $this->UnshippedAmount;
    }
    /**
     * Set UnshippedAmount value
     * @param \StructType\Field $unshippedAmount
     * @return \StructType\TotalsCalculatedAmountsAndQuantities
     */
    public function setUnshippedAmount(\StructType\Field $unshippedAmount = null)
    {
        $this->UnshippedAmount = $unshippedAmount;
        return $this;
    }
    /**
     * Get UnbilledQuantity value
     * @return \StructType\Field|null
     */
    public function getUnbilledQuantity()
    {
        return $this->UnbilledQuantity;
    }
    /**
     * Set UnbilledQuantity value
     * @param \StructType\Field $unbilledQuantity
     * @return \StructType\TotalsCalculatedAmountsAndQuantities
     */
    public function setUnbilledQuantity(\StructType\Field $unbilledQuantity = null)
    {
        $this->UnbilledQuantity = $unbilledQuantity;
        return $this;
    }
    /**
     * Get UnbilledBalance value
     * @return \StructType\Field|null
     */
    public function getUnbilledBalance()
    {
        return $this->UnbilledBalance;
    }
    /**
     * Set UnbilledBalance value
     * @param \StructType\Field $unbilledBalance
     * @return \StructType\TotalsCalculatedAmountsAndQuantities
     */
    public function setUnbilledBalance(\StructType\Field $unbilledBalance = null)
    {
        $this->UnbilledBalance = $unbilledBalance;
        return $this;
    }
    /**
     * Get TotalPaid value
     * @return \StructType\Field|null
     */
    public function getTotalPaid()
    {
        return $this->TotalPaid;
    }
    /**
     * Set TotalPaid value
     * @param \StructType\Field $totalPaid
     * @return \StructType\TotalsCalculatedAmountsAndQuantities
     */
    public function setTotalPaid(\StructType\Field $totalPaid = null)
    {
        $this->TotalPaid = $totalPaid;
        return $this;
    }
    /**
     * Get UnpaidBalance value
     * @return \StructType\Field|null
     */
    public function getUnpaidBalance()
    {
        return $this->UnpaidBalance;
    }
    /**
     * Set UnpaidBalance value
     * @param \StructType\Field $unpaidBalance
     * @return \StructType\TotalsCalculatedAmountsAndQuantities
     */
    public function setUnpaidBalance(\StructType\Field $unpaidBalance = null)
    {
        $this->UnpaidBalance = $unpaidBalance;
        return $this;
    }
    /**
     * Get ServiceCommands value
     * @return \StructType\TotalsCalculatedAmountsAndQuantitiesServiceCommands|null
     */
    public function getServiceCommands()
    {
        return $this->ServiceCommands;
    }
    /**
     * Set ServiceCommands value
     * @param \StructType\TotalsCalculatedAmountsAndQuantitiesServiceCommands $serviceCommands
     * @return \StructType\TotalsCalculatedAmountsAndQuantities
     */
    public function setServiceCommands(\StructType\TotalsCalculatedAmountsAndQuantitiesServiceCommands $serviceCommands = null)
    {
        $this->ServiceCommands = $serviceCommands;
        return $this;
    }
}
