<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TotalsFreightInfo StructType
 * @subpackage Structs
 */
class TotalsFreightInfo extends AbstractStructBase
{
    /**
     * The DisplayName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DisplayName;
    /**
     * The OrderWeight
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $OrderWeight;
    /**
     * The OrderVolume
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $OrderVolume;
    /**
     * The PackageWeight
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $PackageWeight;
    /**
     * The FreightCost
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $FreightCost;
    /**
     * The FreightCostIsUpToDate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $FreightCostIsUpToDate;
    /**
     * The OverrideFreightPrice
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $OverrideFreightPrice;
    /**
     * The InvoiceFreightPriceBasedOn
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $InvoiceFreightPriceBasedOn;
    /**
     * The FreightPrice
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $FreightPrice;
    /**
     * The PremiumFreightPrice
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $PremiumFreightPrice;
    /**
     * The FreightTaxCategory
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $FreightTaxCategory;
    /**
     * The ServiceCommands
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\TotalsFreightInfoServiceCommands
     */
    public $ServiceCommands;
    /**
     * Constructor method for TotalsFreightInfo
     * @uses TotalsFreightInfo::setDisplayName()
     * @uses TotalsFreightInfo::setOrderWeight()
     * @uses TotalsFreightInfo::setOrderVolume()
     * @uses TotalsFreightInfo::setPackageWeight()
     * @uses TotalsFreightInfo::setFreightCost()
     * @uses TotalsFreightInfo::setFreightCostIsUpToDate()
     * @uses TotalsFreightInfo::setOverrideFreightPrice()
     * @uses TotalsFreightInfo::setInvoiceFreightPriceBasedOn()
     * @uses TotalsFreightInfo::setFreightPrice()
     * @uses TotalsFreightInfo::setPremiumFreightPrice()
     * @uses TotalsFreightInfo::setFreightTaxCategory()
     * @uses TotalsFreightInfo::setServiceCommands()
     * @param string $displayName
     * @param \StructType\Field $orderWeight
     * @param \StructType\Field $orderVolume
     * @param \StructType\Field $packageWeight
     * @param \StructType\Field $freightCost
     * @param \StructType\Field $freightCostIsUpToDate
     * @param \StructType\Field $overrideFreightPrice
     * @param \StructType\Field $invoiceFreightPriceBasedOn
     * @param \StructType\Field $freightPrice
     * @param \StructType\Field $premiumFreightPrice
     * @param \StructType\Field $freightTaxCategory
     * @param \StructType\TotalsFreightInfoServiceCommands $serviceCommands
     */
    public function __construct($displayName = null, \StructType\Field $orderWeight = null, \StructType\Field $orderVolume = null, \StructType\Field $packageWeight = null, \StructType\Field $freightCost = null, \StructType\Field $freightCostIsUpToDate = null, \StructType\Field $overrideFreightPrice = null, \StructType\Field $invoiceFreightPriceBasedOn = null, \StructType\Field $freightPrice = null, \StructType\Field $premiumFreightPrice = null, \StructType\Field $freightTaxCategory = null, \StructType\TotalsFreightInfoServiceCommands $serviceCommands = null)
    {
        $this
            ->setDisplayName($displayName)
            ->setOrderWeight($orderWeight)
            ->setOrderVolume($orderVolume)
            ->setPackageWeight($packageWeight)
            ->setFreightCost($freightCost)
            ->setFreightCostIsUpToDate($freightCostIsUpToDate)
            ->setOverrideFreightPrice($overrideFreightPrice)
            ->setInvoiceFreightPriceBasedOn($invoiceFreightPriceBasedOn)
            ->setFreightPrice($freightPrice)
            ->setPremiumFreightPrice($premiumFreightPrice)
            ->setFreightTaxCategory($freightTaxCategory)
            ->setServiceCommands($serviceCommands);
    }
    /**
     * Get DisplayName value
     * @return string|null
     */
    public function getDisplayName()
    {
        return $this->DisplayName;
    }
    /**
     * Set DisplayName value
     * @param string $displayName
     * @return \StructType\TotalsFreightInfo
     */
    public function setDisplayName($displayName = null)
    {
        // validation for constraint: string
        if (!is_null($displayName) && !is_string($displayName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($displayName, true), gettype($displayName)), __LINE__);
        }
        $this->DisplayName = $displayName;
        return $this;
    }
    /**
     * Get OrderWeight value
     * @return \StructType\Field|null
     */
    public function getOrderWeight()
    {
        return $this->OrderWeight;
    }
    /**
     * Set OrderWeight value
     * @param \StructType\Field $orderWeight
     * @return \StructType\TotalsFreightInfo
     */
    public function setOrderWeight(\StructType\Field $orderWeight = null)
    {
        $this->OrderWeight = $orderWeight;
        return $this;
    }
    /**
     * Get OrderVolume value
     * @return \StructType\Field|null
     */
    public function getOrderVolume()
    {
        return $this->OrderVolume;
    }
    /**
     * Set OrderVolume value
     * @param \StructType\Field $orderVolume
     * @return \StructType\TotalsFreightInfo
     */
    public function setOrderVolume(\StructType\Field $orderVolume = null)
    {
        $this->OrderVolume = $orderVolume;
        return $this;
    }
    /**
     * Get PackageWeight value
     * @return \StructType\Field|null
     */
    public function getPackageWeight()
    {
        return $this->PackageWeight;
    }
    /**
     * Set PackageWeight value
     * @param \StructType\Field $packageWeight
     * @return \StructType\TotalsFreightInfo
     */
    public function setPackageWeight(\StructType\Field $packageWeight = null)
    {
        $this->PackageWeight = $packageWeight;
        return $this;
    }
    /**
     * Get FreightCost value
     * @return \StructType\Field|null
     */
    public function getFreightCost()
    {
        return $this->FreightCost;
    }
    /**
     * Set FreightCost value
     * @param \StructType\Field $freightCost
     * @return \StructType\TotalsFreightInfo
     */
    public function setFreightCost(\StructType\Field $freightCost = null)
    {
        $this->FreightCost = $freightCost;
        return $this;
    }
    /**
     * Get FreightCostIsUpToDate value
     * @return \StructType\Field|null
     */
    public function getFreightCostIsUpToDate()
    {
        return $this->FreightCostIsUpToDate;
    }
    /**
     * Set FreightCostIsUpToDate value
     * @param \StructType\Field $freightCostIsUpToDate
     * @return \StructType\TotalsFreightInfo
     */
    public function setFreightCostIsUpToDate(\StructType\Field $freightCostIsUpToDate = null)
    {
        $this->FreightCostIsUpToDate = $freightCostIsUpToDate;
        return $this;
    }
    /**
     * Get OverrideFreightPrice value
     * @return \StructType\Field|null
     */
    public function getOverrideFreightPrice()
    {
        return $this->OverrideFreightPrice;
    }
    /**
     * Set OverrideFreightPrice value
     * @param \StructType\Field $overrideFreightPrice
     * @return \StructType\TotalsFreightInfo
     */
    public function setOverrideFreightPrice(\StructType\Field $overrideFreightPrice = null)
    {
        $this->OverrideFreightPrice = $overrideFreightPrice;
        return $this;
    }
    /**
     * Get InvoiceFreightPriceBasedOn value
     * @return \StructType\Field|null
     */
    public function getInvoiceFreightPriceBasedOn()
    {
        return $this->InvoiceFreightPriceBasedOn;
    }
    /**
     * Set InvoiceFreightPriceBasedOn value
     * @param \StructType\Field $invoiceFreightPriceBasedOn
     * @return \StructType\TotalsFreightInfo
     */
    public function setInvoiceFreightPriceBasedOn(\StructType\Field $invoiceFreightPriceBasedOn = null)
    {
        $this->InvoiceFreightPriceBasedOn = $invoiceFreightPriceBasedOn;
        return $this;
    }
    /**
     * Get FreightPrice value
     * @return \StructType\Field|null
     */
    public function getFreightPrice()
    {
        return $this->FreightPrice;
    }
    /**
     * Set FreightPrice value
     * @param \StructType\Field $freightPrice
     * @return \StructType\TotalsFreightInfo
     */
    public function setFreightPrice(\StructType\Field $freightPrice = null)
    {
        $this->FreightPrice = $freightPrice;
        return $this;
    }
    /**
     * Get PremiumFreightPrice value
     * @return \StructType\Field|null
     */
    public function getPremiumFreightPrice()
    {
        return $this->PremiumFreightPrice;
    }
    /**
     * Set PremiumFreightPrice value
     * @param \StructType\Field $premiumFreightPrice
     * @return \StructType\TotalsFreightInfo
     */
    public function setPremiumFreightPrice(\StructType\Field $premiumFreightPrice = null)
    {
        $this->PremiumFreightPrice = $premiumFreightPrice;
        return $this;
    }
    /**
     * Get FreightTaxCategory value
     * @return \StructType\Field|null
     */
    public function getFreightTaxCategory()
    {
        return $this->FreightTaxCategory;
    }
    /**
     * Set FreightTaxCategory value
     * @param \StructType\Field $freightTaxCategory
     * @return \StructType\TotalsFreightInfo
     */
    public function setFreightTaxCategory(\StructType\Field $freightTaxCategory = null)
    {
        $this->FreightTaxCategory = $freightTaxCategory;
        return $this;
    }
    /**
     * Get ServiceCommands value
     * @return \StructType\TotalsFreightInfoServiceCommands|null
     */
    public function getServiceCommands()
    {
        return $this->ServiceCommands;
    }
    /**
     * Set ServiceCommands value
     * @param \StructType\TotalsFreightInfoServiceCommands $serviceCommands
     * @return \StructType\TotalsFreightInfo
     */
    public function setServiceCommands(\StructType\TotalsFreightInfoServiceCommands $serviceCommands = null)
    {
        $this->ServiceCommands = $serviceCommands;
        return $this;
    }
}
