<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TotalsOrderTotals StructType
 * @subpackage Structs
 */
class TotalsOrderTotals extends AbstractStructBase
{
    /**
     * The DisplayName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DisplayName;
    /**
     * The EstimateTotal
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $EstimateTotal;
    /**
     * The LineTotal
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $LineTotal;
    /**
     * The MiscTotal
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $MiscTotal;
    /**
     * The TaxTotal
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $TaxTotal;
    /**
     * The ServiceCommands
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\TotalsOrderTotalsServiceCommands
     */
    public $ServiceCommands;
    /**
     * Constructor method for TotalsOrderTotals
     * @uses TotalsOrderTotals::setDisplayName()
     * @uses TotalsOrderTotals::setEstimateTotal()
     * @uses TotalsOrderTotals::setLineTotal()
     * @uses TotalsOrderTotals::setMiscTotal()
     * @uses TotalsOrderTotals::setTaxTotal()
     * @uses TotalsOrderTotals::setServiceCommands()
     * @param string $displayName
     * @param \StructType\Field $estimateTotal
     * @param \StructType\Field $lineTotal
     * @param \StructType\Field $miscTotal
     * @param \StructType\Field $taxTotal
     * @param \StructType\TotalsOrderTotalsServiceCommands $serviceCommands
     */
    public function __construct($displayName = null, \StructType\Field $estimateTotal = null, \StructType\Field $lineTotal = null, \StructType\Field $miscTotal = null, \StructType\Field $taxTotal = null, \StructType\TotalsOrderTotalsServiceCommands $serviceCommands = null)
    {
        $this
            ->setDisplayName($displayName)
            ->setEstimateTotal($estimateTotal)
            ->setLineTotal($lineTotal)
            ->setMiscTotal($miscTotal)
            ->setTaxTotal($taxTotal)
            ->setServiceCommands($serviceCommands);
    }
    /**
     * Get DisplayName value
     * @return string|null
     */
    public function getDisplayName()
    {
        return $this->DisplayName;
    }
    /**
     * Set DisplayName value
     * @param string $displayName
     * @return \StructType\TotalsOrderTotals
     */
    public function setDisplayName($displayName = null)
    {
        // validation for constraint: string
        if (!is_null($displayName) && !is_string($displayName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($displayName, true), gettype($displayName)), __LINE__);
        }
        $this->DisplayName = $displayName;
        return $this;
    }
    /**
     * Get EstimateTotal value
     * @return \StructType\Field|null
     */
    public function getEstimateTotal()
    {
        return $this->EstimateTotal;
    }
    /**
     * Set EstimateTotal value
     * @param \StructType\Field $estimateTotal
     * @return \StructType\TotalsOrderTotals
     */
    public function setEstimateTotal(\StructType\Field $estimateTotal = null)
    {
        $this->EstimateTotal = $estimateTotal;
        return $this;
    }
    /**
     * Get LineTotal value
     * @return \StructType\Field|null
     */
    public function getLineTotal()
    {
        return $this->LineTotal;
    }
    /**
     * Set LineTotal value
     * @param \StructType\Field $lineTotal
     * @return \StructType\TotalsOrderTotals
     */
    public function setLineTotal(\StructType\Field $lineTotal = null)
    {
        $this->LineTotal = $lineTotal;
        return $this;
    }
    /**
     * Get MiscTotal value
     * @return \StructType\Field|null
     */
    public function getMiscTotal()
    {
        return $this->MiscTotal;
    }
    /**
     * Set MiscTotal value
     * @param \StructType\Field $miscTotal
     * @return \StructType\TotalsOrderTotals
     */
    public function setMiscTotal(\StructType\Field $miscTotal = null)
    {
        $this->MiscTotal = $miscTotal;
        return $this;
    }
    /**
     * Get TaxTotal value
     * @return \StructType\Field|null
     */
    public function getTaxTotal()
    {
        return $this->TaxTotal;
    }
    /**
     * Set TaxTotal value
     * @param \StructType\Field $taxTotal
     * @return \StructType\TotalsOrderTotals
     */
    public function setTaxTotal(\StructType\Field $taxTotal = null)
    {
        $this->TaxTotal = $taxTotal;
        return $this;
    }
    /**
     * Get ServiceCommands value
     * @return \StructType\TotalsOrderTotalsServiceCommands|null
     */
    public function getServiceCommands()
    {
        return $this->ServiceCommands;
    }
    /**
     * Set ServiceCommands value
     * @param \StructType\TotalsOrderTotalsServiceCommands $serviceCommands
     * @return \StructType\TotalsOrderTotals
     */
    public function setServiceCommands(\StructType\TotalsOrderTotalsServiceCommands $serviceCommands = null)
    {
        $this->ServiceCommands = $serviceCommands;
        return $this;
    }
}
