<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Value StructType
 * @subpackage Structs
 */
class Value extends Field
{
    /**
     * The Message
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Message;
    /**
     * The IsError
     * Meta information extracted from the WSDL
     * - default: false
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var bool
     */
    public $IsError;
    /**
     * The ErrorLevel
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ErrorLevel;
    /**
     * Constructor method for Value
     * @uses Value::setMessage()
     * @uses Value::setIsError()
     * @uses Value::setErrorLevel()
     * @param string $message
     * @param bool $isError
     * @param string $errorLevel
     */
    public function __construct($message = null, $isError = false, $errorLevel = null)
    {
        $this
            ->setMessage($message)
            ->setIsError($isError)
            ->setErrorLevel($errorLevel);
    }
    /**
     * Get Message value
     * @return string|null
     */
    public function getMessage()
    {
        return $this->Message;
    }
    /**
     * Set Message value
     * @param string $message
     * @return \StructType\Value
     */
    public function setMessage($message = null)
    {
        // validation for constraint: string
        if (!is_null($message) && !is_string($message)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($message, true), gettype($message)), __LINE__);
        }
        $this->Message = $message;
        return $this;
    }
    /**
     * Get IsError value
     * @return bool|null
     */
    public function getIsError()
    {
        return $this->IsError;
    }
    /**
     * Set IsError value
     * @param bool $isError
     * @return \StructType\Value
     */
    public function setIsError($isError = false)
    {
        // validation for constraint: boolean
        if (!is_null($isError) && !is_bool($isError)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isError, true), gettype($isError)), __LINE__);
        }
        $this->IsError = $isError;
        return $this;
    }
    /**
     * Get ErrorLevel value
     * @return string|null
     */
    public function getErrorLevel()
    {
        return $this->ErrorLevel;
    }
    /**
     * Set ErrorLevel value
     * @param string $errorLevel
     * @return \StructType\Value
     */
    public function setErrorLevel($errorLevel = null)
    {
        // validation for constraint: string
        if (!is_null($errorLevel) && !is_string($errorLevel)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($errorLevel, true), gettype($errorLevel)), __LINE__);
        }
        $this->ErrorLevel = $errorLevel;
        return $this;
    }
}
